(function() {
    "use strict"
    angular.module('starter')
    .controller('authenticationApproval', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', '$stateParams','$state','validate',
    function($rootScope, $scope, nav, control, nativeHelper, $stateParams,$state,validate) {
        $scope.approvalDetail=$stateParams.authorizationDetail;

        $scope.lastPage=$scope.approvalDetail.srcPage;
        var getDate = function(time, day) {
        	time.setDate(time.getDate() + day);
        	var y = time.getFullYear();
        	var m = time.getMonth() + 1;
        	var d = time.getDate();
        	return y + "-" + (m < 10 ? "0" + m: m) + "-" + (d < 10 ? "0" + d: d);
        }
        var nowTime = new Date();
        var getTime = getDate(nowTime, 0);

        var years = function() {
        	for (var t = [], e = nowTime.getFullYear(); e <= nowTime.getFullYear() + 1; e++) t.push(e);
        	return t
        }
        function formatDayTime(val) {
        	if (val) {
        		var date = new Date(val) ;
        		var Y = date.getFullYear();
        		var M = date.getMonth() + 1;
        		var D = date.getDate();
        		if (M < 10) {
        			M = '0' + M;
        		}
        		if (D < 10) {
        			D = '0' + D;
        		}
        		return Y + '-' + M + '-' + D;
        	} else {
        		return '';
        	}
        }
        //选择截止日期
        $("#datetime-picker-end").datetimePicker({
        	onOpen: function(data) {
        		// debugger
        		$('#picker-title').html(data.value[0] + '-' + data.value[1] + '-' + data.value[2]);
        	},
        	onChange: function(data) {
        		$('#picker-title').html(data.value[0] + '-' + data.value[1] + '-' + data.value[2]);
        	},
        	years: years(),
        	toolbarTemplate: '<div class="tool-bar"><div class="close-picker fl close-text">关闭</div><div class="fl title-text" id="picker-title"></div><div class="close-picker fr finish-text">完成</div></div>',
        	times: function() {
        		return [];
        	}
        });

        var date = new Date($scope.approvalDetail.startTime.replace(/-/g, '/'));
        $("#datetime-picker-end").val(formatDayTime(date.setDate(date.getDate() + 30)) + " ");

        screen.orientation.unlock();
        screen.orientation.lock('portrait');



        var validTime=function (endTime){
           var date1 = new Date($scope.approvalDetail.startTime.replace(/-/g, '/'));
           var date2 = new Date(endTime.replace(/-/g, '/'));
           var arr1 = $scope.approvalDetail.startTime.split("/");
           var date3=new Date(parseInt(arr1[0])+1,parseInt(arr1[1])-1,parseInt(arr1[2]),0,0,0);

           var nowDate=new Date();
           if(date1.getTime()>date2.getTime()) {
               return '0';
           }else if(date2.getTime()>date3.getTime()){
               return '1';
           }else if(date2.getTime()<nowDate.getTime()){
               return '2';
           }else if (date2.getTime() > date1.getTime()+(365*1000*60*60*24)) {
               return '3';
           }
        }
        $scope.authenticationSign=function(){
            var endDate=$('#datetime-picker-end').val();

            if(validate.nullOrEmpty(endDate)){
                control.showPopup('请选择授权截止日期', 2000);
                return;
            }
            if(validTime(endDate)=='0'){
                control.showPopup('截止日期不能小于起始日期', 2000);
                return;
            }
            if(validTime(endDate)=='2'){
                control.showPopup('授权日期不能小于当前时间', 2000);
                return;
            }
            if(validTime(endDate)=='3'){
                control.showPopup('截止时间最长选择不能超过1年', 2000);
                return;
            }

            $scope.approvalDetail.endTime=endDate;
//            $state.go('signatureAuthorization',{'authorizationDetail':$scope.approvalDetail});
            $state.go('authorizationBook',{'authorizationDetail':$scope.approvalDetail});

//           if (cordova.platformId === 'ios') {
//               nativeHelper.setOrientation({ data: ['LandscapeRight'], success: null, fail: null });
//           }
        }

        $scope.navigate = function(state) {
            nav.navigate(state);
        };

    }]);
})();
