(function() {
    "use strict"

    angular.module('starter')
    .controller('downloadCert', ['$rootScope', '$scope', '$filter', 'nav', 'control', 'nativeHelper', 'validate', 'localStorage', 'utility', '$stateParams', '$state','verifyIdentity', 'requestWrapper', 'md5','$ionicModal',
    function($rootScope, $scope, $filter, nav, control, nativeHelper, validate, localStorage, utility, $stateParams, $state,verifyIdentity,requestWrapper, md5,$ionicModal) {


        setTimeout(function() {
             let input=document.getElementById("inputPassword");
             input.focus();
                    }, 500);
        $scope.downloadCertInfo = $stateParams.downloadCertInfo;
        $scope.certUse = {
            password: '',
            confirmPwd: ''
        };

        $scope.iptPass ='';
        $scope.iptPassnew ='';
        $scope.gbState = false;
        $scope.gbStateT = false;
        $scope.focusFunO = function () {
            $scope.gbState = true;
        };
        $scope.blurFunO = function () {
            $scope.gbState = false;
        };
        $scope.focusFunT = function () {
            $scope.gbStateT = true;
        };
        $scope.blurFunT = function () {
            $scope.gbStateT = false;
        };
        $scope.$watch('certUse.password', function(newValue, oldValue) {
              //当第一次确认输入完成，自动跳到第二次输入 光标移动到第二个input
              if($scope.certUse.password.length==6){
                   setTimeout(function() {
                       let input=document.getElementById("inputConfirmPwd");
                           input.focus();
                    }, 500);
                }
              });
        $scope.$watch('certUse.confirmPwd', function(newValue, oldValue) {
               //当第二次确认输入完成，自动开始验证
                if($scope.certUse.confirmPwd.length==6){
                //移除焦点，取消软键盘
                 let input=document.getElementById("inputConfirmPwd");
                     input.blur();
                    $scope.startDownloadCert();
                    }
                });

        var downloadCertEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "下载证书";
            MobclickAgent.onEventWithParameters("downloadCertEvent", eventCounter);
        }
        
        var downloadCertCompletedEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "证书下载成功";
            MobclickAgent.onEventWithParameters("downloadCertCompletedEvent", eventCounter);
             if($rootScope.applyCertType == 0){
                 var eventCounter = new Object();
                 eventCounter.page = "证书申领-证书下载成功";
                 MobclickAgent.onEventWithParameters("applyCertDownloadEvent", eventCounter);
             }else if($rootScope.applyCertType == 1){
                 var eventCounter = new Object();
                 eventCounter.page = "证书补办-证书下载成功";
                 MobclickAgent.onEventWithParameters("makeUpCertDownloadEvent", eventCounter);
             }
        }

        $scope.downloadSuccess=false;
        $scope.canClick = false;

        // 上传设备信息/添加设备
        var addMobileDevice = function() {
            var time = utility.getCurrentTime();
            var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
            var temp = {
                'mobilePhone': $rootScope.loginInfo.mobile,
                'idCard': $rootScope.loginInfo.idCard,
                'mobileModel': $rootScope.deviceModelName,
                'systemName': $rootScope.systemVersion,
                'keySerial': $rootScope.uuid,
                'keyNo':$rootScope.uuid,
                "token" : $rootScope.loginInfo.token
            }

            var reqParams = DES3.encrypt(hashdata.substring(0,24), 'ZJHUIXIN', angular.toJson(temp))
            
            var params = {
                "appid": $rootScope.appid,
                "time": time,
                "hashdata": hashdata,
                "reqParams": reqParams
            };

            console.log('addMobileDevice params - ' + JSON.stringify(params));
            requestWrapper.doAddMobileDevice({data: params, refresh: true})
                .then(function (result) {
                    console.log("doAddMobileDevice" + JSON.stringify(result));
                    if (true == result.success) {
                    } else {
                    }
                });
        }

        /**
         * 下载证书
         * */
        var downloadCert = function () {
            control.showLoading();
            downloadCertEvent();//监听下载
            
            var timeout = setTimeout(function () {
                if ($scope.downloadCertInfo.canReApply) {
                    var type = 'reApply';
                } else {
                    var type = $filter('businessCode')($scope.downloadCertInfo.businessCode);
                }

                $scope.containerName = $scope.downloadCertInfo.orderNo;
                if ($scope.downloadCertInfo.businessCode == 'B02') {
                    if($scope.downloadCertInfo.containerId==null||$scope.downloadCertInfo.containerId==''||$scope.downloadCertInfo.containerId==undefined){
                        control.showPopup("B02类型的containerId为空", 3000);
                        return;
                    }
                    $scope.containerName = $scope.downloadCertInfo.containerId;
                }

                if($scope.containerName==null|| $scope.containerName==''|| $scope.containerName==undefined||$scope.containerName=="undefined"){
                    control.showPopup($scope.downloadCertInfo.businessCode+"类型的containerId为空->"+$scope.containerName, 3000);
                    return;
                }
                var params = [
//                        $scope.downloadCertInfo.entName,
//                        $scope.downloadCertInfo.uniscid,
                    $scope.downloadCertInfo.orderNo,
                    $scope.downloadCertInfo.corpid,
                    type,
//                        '',//certId
                    $scope.certUse.password,
                    cordova.platformId,
                    $scope.containerName,
                    $rootScope.SDKVersion,//V1：旧版密码模块，V2：新版密码模块
                    $rootScope.loginInfo.accountId,
                    "1",//自启用
//                        secureCoreVersion,
                    $scope.downloadCertInfo.sourceClient?$scope.downloadCertInfo.sourceClient:"EPASSAPP"
                ];
                var successFunc = function (result) {
                    clearTimeout(timeout)
//                        control.hideLoading();
                    if (result == null || angular.equals({}, result)) { return; }
                        console.log("添加证书 "+JSON.stringify(result));
                        

                        switch (result.success) {
                        case true:
                            // 下载成功上传设备信息
                            addMobileDevice();
                            //证书下载成功刷新首页证书
                            $rootScope.isGetHomeCertApi = true;
                            downloadCertCompletedEvent();//监听下载成功
                            $scope.canClick = false;
                            $scope.downloadSuccess = true;
                            //核验身份
                            verifyIdentity.checkIdentity($scope.downloadCertInfo.uniscid, $scope.downloadCertInfo.operatorId, '2', checkIdentityRes);

                            if(($rootScope.openBiometryAndroid == '1'  && 'android' == cordova.platformId) || ($rootScope.openBiometryIOS == '1' && 'ios' == cordova.platformId)){
                                // let openVerify = localStorage.getObject('openVerify');//账号与安全中是否已开启
                                var authInfo = localStorage.getObject('authInfo' + $rootScope.loginInfo.accountId);
                                if($rootScope.isShowGuide && '1' != authInfo.openVerify){
                                    setTimeout(function () {
                                        $scope.dialog.show();
                                    }, 500);
                                }
                            }
                            
                            break;
                        case false:
                            control.hideLoading();
                            control.showPopup(result.msg, 3000);
                            break;
                        };
                 };

                var failFunc = function (result) {
                    $scope.canClick = false;
                    control.hideLoading();
                    control.showPopup(result.msg, 3000);
                    clearTimeout(timeout)
                    requestWrapper.sendMesToDingTalk("密码模块错误","下载证书",result.alarmMsg)
                };

                nativeHelper.downloadCert({ data: params, success: successFunc, fail: failFunc });
            }, 500);
        }

            /**
             * 证书密码校验
             * */
            $scope.startDownloadCert = function () {
                if (!validate.certPassword($scope.certUse.password) || !validate.certPassword($scope.certUse.confirmPwd)) {
                    control.showPopup('请输入6位数字密码', 2000);
                    return;
                }

                if ($scope.certUse.password !== $scope.certUse.confirmPwd) {
                    control.showPopup('两次输入的密码不一致，请重新输入', 3000);
                    return;
                }

                downloadCert();
            }

            $scope.navigate = function (state) {
                nav.navigate(state);
            };
            /*立即扫码*/
            $scope.scanFunc = function (){
                var params = [];
                var successFunc = function (result) {
                    }
                var failFunc = function (error) {
                       control.showPopup(error.msg, 2000);
                    };
                $rootScope.scanFromCertDetail = false;
                nativeHelper.navToScanView({ data: params, success: successFunc, fail: failFunc });
              if($rootScope.applyCertType == 0){
                  var eventCounter = new Object();
                  eventCounter.page = "证书申领-立即扫码使用";
                  MobclickAgent.onEventWithParameters("applyImmediatelyScanEvent", eventCounter);
              }else if($rootScope.applyCertType == 1){
                  var eventCounter = new Object();
                  eventCounter.page = "证书补办-立即扫码使用";
                  MobclickAgent.onEventWithParameters("makeUpImmediatelyScanEvent", eventCounter);
              }
            }

           //证书使用说明
           $scope.helpExplain =function() {
                 utility.helpExplain(window.certUserHelp,"证书使用说明","helpCertUseEvent");
           };

           $scope.isExistValidAdmin = false;

            //查询是否存在有效管理员
            var checkIsExistValidAdmin = function() {

                control.showLoading();
                var params = [$scope.downloadCertInfo.uniscid];
                var successFunc = function(result) {
                    control.hideLoading();
                    if (result == null || angular.equals({},
                    result)) {
                        control.showPopup('服务出错啦', 3000);
                    }
                    if (result.rslt == 'success') {
    //                "existValidAdmin":"0不存在1存在"
                        if (result.existValidAdmin == '0') {
                            $scope.isExistValidAdmin = true;
                        }
                    }

                    if (result.rslt == 'fail') {
                        control.showPopup(result.errorMsg, 2000);
                    }
                }
                var failFunc = function(error) {
                    control.hideLoading();
                    control.showPopup(error.msg, 2000);
                    return '';
                };
                nativeHelper.existValidAdmin({
                    data: params,
                    success: successFunc,
                    fail: failFunc
                });
            }

            var identityId;
            var checkIdentityRes = function(result) {
                if (result.rslt == 'success') {
                    $scope.identityType = result.identityType; //0法定代表人1管理员2经办人
                     identityId=result.identityId
                    if (result.identityType == '0') checkIsExistValidAdmin();
                }
                if (result.rslt == 'fail') {}
            }


            $scope.openWeChat = function() {
                var successFunc = function(result) {
                    control.showPopup('复制成功', 2000);
                }

                var failFunc = function(error) {
                    console.log(error);
                    control.showPopup('复制失败', 2000);
                };

                nativeHelper.socialAgent({
                    data: ["e照通", 4,''],
                    success: successFunc,
                    fail: failFunc
                });
            }

            $scope.setAdmin = function() {
                $state.go('addAdmin', {
                    'certEntInfo':{'uniscid':$scope.downloadCertInfo.uniscid,'authIdentityId':identityId}
                });
            }

            $ionicModal.fromTemplateUrl("html/downloadCert/deviceAuthGuide.html", {
                scope:$scope,
                animation:"slide-in-up"
            }).then(function(modal) {
                $scope.dialog = modal;
            });

            $rootScope.openAuth = function(){
                if ('0' != $rootScope.deviceAuthenticationType) {
                    // 如果指纹已打开且可用 用指纹校验
                    var successFunc = function(res) {
                        console.log('success - ' + JSON.stringify(res));
                        if (1 == res.code) {
                            // localStorage.setObject('openVerify', '1');
                            var authConfigInfo = {
                                openVerify:'1',
                                isFirstVerify:'0'
                            }
                            localStorage.setObject('authInfo' + $rootScope.loginInfo.accountId, authConfigInfo);

                            var msg = '指纹验证设置成功';
                            if($rootScope.deviceAuthenticationType == '1'){
                                msg = '面容验证设置成功';
                            }
                            control.showPopup(msg, 2000);
                            $scope.dialog.hide();

                            // nav.navigate('home')
                        } else if(2 == res.code) {
                            //用户选择了取消

                            return;
                        }else if(3 == res.code) {
                            //连续失败5次，锁定
                            control.showPopup('操作太频繁，请稍后再试', 2000);
                            $scope.dialog.hide();
                            return;
                        }else if(4 == res.code) {
                            //用户未录入指纹
                            var msg = '你尚未设置设备指纹，请先在手机系统设置中录入指纹';
                            if($rootScope.deviceAuthenticationType == '1'){
                                msg = '你尚未设置面容ID，请先在手机系统设置中录入面容';
                            }
                            control.showCustomAlert6(msg,'check-information');
                            $scope.dialog.hide();
                            return;
                        }else if(5 == res.code) {
                            //连续错误3次
                            var msg = '指纹不匹配';
                            if($rootScope.deviceAuthenticationType == '1'){
                                msg = '面容不匹配';
                            }
                            control.showPopup(msg, 2000);
                            return;
                        }else if(6 == res.code) {
                            //权限未打开
                            var msg = '需要开启设备指纹权限才能使用';
                            if($rootScope.deviceAuthenticationType == '1'){
                                msg = '需要开启设备面容ID权限才能使用';
                            }
                            control.showPopup(msg, 2000);
                            return;
                        }else {
                            // control.showPopup(res.msg, 2000);
                            return;
                        }  
                    }
                    var failFunc = function(res) {
                        console.log('fail - ' + JSON.stringify(res));
                    }
                    nativeHelper.deviceAuthentication({
                        data: [''], 
                        success: successFunc, 
                        fail: failFunc 
                    });
                } else {
                    control.showPopup('当前设备不支持指纹或面部认证', 2000);
                }
            }

            $rootScope.closeModal = function(){
                $scope.dialog.hide();
            }

            $rootScope.deviceAuthGuideCloseClick = function() {
                // control.hideCustomPopup();
                $scope.dialog.hide();

                $rootScope.isShowGuide = false;
            }


            // 记录开始时间
            var startTime = 0;
            // 长按时间阈值
            var longPressTime = 1000;
            // 监听 touchstart 事件开始触摸
            document.getElementById('qrCode').addEventListener('touchstart', function (event) {
              startTime = new Date().getTime();
            });
            // 监听 touchend 事件结束触摸
            document.getElementById('qrCode').addEventListener('touchend', function (event) {
              var endTime = new Date().getTime();
              if (endTime - startTime > longPressTime) {
                // 触发长按操作
                $scope.openWeChat();
              } else {
                // 触发单击操作

              }
            });

             $rootScope.backClick = function(){
               if($scope.certUse.password.length==6){
                    $scope.certUse.password="";
                    $scope.certUse.confirmPwd="";
                }else{
                    if($scope.downloadCertInfo.sourceType =="certManage"){
                        nav.navigate('certManage');
                    }else if($scope.downloadCertInfo.sourceType =="tab/home"){
                        nav.navigate('tab/home');
                    }else{
                        nav.navigate('businessManage');
                    }

                }
             }

    }]);
})();
