(function() {
    "use strict"
    angular.module('starter')
    .controller('ableApplyCertInfoV2', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper','verifyIdentity','$state','$filter', 'requestWrapper', 'md5', 'utility',
    function($rootScope, $scope, nav, control, nativeHelper,verifyIdentity,$state,$filter,requestWrapper,md5, utility) {
        $rootScope.applyCertInfo = { uniscid: '' };
        $rootScope.curAuthCode = '20191016172831442090';//不同证书类目，不同授权码，默认值

//        $rootScope.applyCertType = 0 // 0 可申领的证书   1 可补办的证书 2走邮寄流程
        var isUploadMaterials = false;// 续费或付款完 是否上传材料

        $scope.certTypeList = [];
        $scope.chooseIndex = 0;
        $scope.chooseCert = {};
        $scope.isHaveCertIllustrate = false;
        $scope.categoryExplain = {};
        $scope.defaultCategoryExplain = {};

        $scope.chooseCertClick = function(item,index){
            $scope.chooseIndex = index;
            $scope.chooseCert = $scope.certTypeList[index]
            if($scope.chooseCert.categoryExplain != ''&&$scope.chooseCert.categoryExplain != null){
                 $scope.isHaveCertIllustrate = true
                 $scope.categoryExplain = JSON.parse($scope.chooseCert.categoryExplain)
            }else {
                 $scope.isHaveCertIllustrate = false
                 $scope.defaultCategoryExplain = JSON.parse($scope.chooseCert.defaultCategoryExplain)
            }
        }
        var  parentPage = "ableMakeUpCertInfoV2";
        var initData = function() {
            var isMakeUp = true; // 是否补办
            //V2.9.2增加参数 判断补办列表是否存在主证书
             $scope.mainCertMakeUp=false;
             $scope.showMakeUpTip=false;

            if($rootScope.applyCertType == 2){
                var isMakeUp060 = false;// 省外证书是否补办过
                // 补办
                $rootScope.searchResult.alreadyReceived.forEach(function(v) {
                     if (v.categoryBh == '060' ) {
                          isMakeUp060 = true
                     }
                 });
                $rootScope.searchResult.canReceived.forEach(function(v) {
                    if (v.categoryBh == '010') {
                        isMakeUp = false
                        parentPage = "ableApplyCertInfoV2"
                    } else if (v.categoryBh ==('060')&&!isMakeUp060) {
                        isMakeUp = false
                        parentPage = "ableApplyCertInfoV2"
                    }
                });
            }else if($rootScope.applyCertType == 0){
                parentPage = "ableApplyCertInfoV2";
            }else if($rootScope.applyCertType == 1){
                parentPage = "ableMakeUpCertInfoV2";
            }

            if($rootScope.applyCertType == 0||($rootScope.applyCertType == 2&&!isMakeUp)){ // 申领
               //V2.9.2 如果省法人证书已经领取，子申领子证书时，增加主证书展示提示.仅在有主证书未领取的情况下
                //  010	省法人数字证书
                //  011	子证书
                //  020	衢州社保证书
                //  030	个体户证书
                //  060	外省法人数字证书
                //  080	汇信电子工作证
                //  185	政采云专项证书
                $rootScope.searchResult.alreadyReceived.forEach(function(l) {
                            if (l.hasOwnProperty('applyNew')) {
                                l.certApplyType = '新领'
                            } else if (l.hasOwnProperty('makeUp')) {
                                l.certApplyType = '补办'
                            }
                            if (l.categoryBh=='010') {
                               //增加参数 判断补办列表是否存在主证书
                               $scope.mainCertMakeUp=true;
                               //定义全局的主证书名称参数
                               $rootScope.cartNameHtmlMian=l.category;
                               //主证书item信息
                                $scope.MainCertInfo = l;
                            }
                       })

                $rootScope.searchResult.canReceived.forEach(function(l) {
                    if (l.hasOwnProperty('applyNew')) {
                        l.certApplyType = '新领'
                    } else if (l.hasOwnProperty('makeUp')) {
                        l.certApplyType = '补办'
                    }
                    $scope.certTypeList.push(l);

                })
            }else{ // 补办
                $rootScope.searchResult.alreadyReceived.forEach(function(v) {
                    if (v.hasOwnProperty('applyNew')) {
                        v.certApplyType = '新领'
                    } else if (v.hasOwnProperty('makeUp')) {
                        v.certApplyType = '补办'
                    }
                     $scope.certTypeList.push(v);
                });
                //V2.9.2 去除新领证书的展示，只展示补办的证书。
//                if(isMakeUp){
//                    //  010	省法人数字证书
//                    //  011	子证书
//                    //  020	衢州社保证书
//                    //  030	个体户证书
//                    //  060	外省法人数字证书
//                    //  080	汇信电子工作证
//                    //  185	政采云专项证书
//                    $rootScope.searchResult.canReceived.forEach(function(l) {
//                         if (l.hasOwnProperty('applyNew')&&(l.categoryBh=='011'||l.categoryBh=='030'||l.categoryBh=='060')) {
//                              l.certApplyType = '新领'
//                              l.certName = $rootScope.searchResult.entName
//                              $scope.certTypeList.push(l);
//                         }
//                    })
//                }
            }

            if( $scope.certTypeList.length>0){
                $scope.chooseCert = $scope.certTypeList[0]
                try{
                    if($scope.chooseCert.categoryExplain != ''&&$scope.chooseCert.categoryExplain != null){
                        $scope.isHaveCertIllustrate = true
                        $scope.categoryExplain = JSON.parse($scope.chooseCert.categoryExplain)
                    }else {
                        $scope.isHaveCertIllustrate = false
                        $scope.defaultCategoryExplain = JSON.parse($scope.chooseCert.defaultCategoryExplain)
                    }
                } catch(e){
                    console.log("说明解析异常" + e);
                }
            }
        }

        initData();


        //证书操作类型收缩控制
        $scope.showOtherCert = function() {
            $scope.showMore = !$scope.showMore;
        }


        /*
         * 证书新领、补办数据全局声明
         * businessCode: "P012"证书新领 "B03"证书补办
         * netType业务单类型6:证书新领 8:证书补办 7:子证书新领
         */
        var toApply = function(item, businessCode, netType) {
            //封装证书申领进行中所需信息
            $rootScope.certUnderwayInfo = {
                entName: $rootScope.searchResult.entName,
                uniscid: $rootScope.searchResult.uniscid,
                category: item.category,
                categoryBh: item.categoryBh,
                entProvince: item.entProvince,
                isFree: item.isFree?item.isFree:item.inService,
                inService: item.inService,
                corpid: item.corpid,
                certName:item.certName,
                certApplyType: item.certApplyType,
                businessCode: businessCode,
                netType: netType,
                operator: '',
                operatorid: '',
                identityType:'',
            }
            if($rootScope.loginInfo.realNameGrade=="1"){
                 //开始判断身份类型
                 checkIdentityType();
            }else{
                 if($rootScope.applyCertType ==2){
                    usingMaterials();
                 }else{
                    nav.navigate('claimantInfo');
                 }
            }
        }

                /**
                *收费提示
                *B03：已领
                *P012:新领
                */
        var certFeeScale = function(item, type, btnLeft) {
            //封装证书申领进行中所需信息
            $rootScope.certUnderwayInfo = {
                 entName: $rootScope.searchResult.entName,
                 uniscid: $rootScope.searchResult.uniscid,
                 category: item.category,
                 categoryBh: item.categoryBh,
                 entProvince: item.entProvince,
                 isFree: item.isFree?item.isFree:item.inService,
                 inService: item.inService,
                 corpid: item.corpid,
                 certName:item.certName,
                 certApplyType: item.certApplyType,
                 businessCode: type,
                 netType: "8",
                 operator: '',
                 operatorid: '',
                 identityType:'',
            }


            var tipContent = '';
            var btnRight = '';
            if (type == 'B03') {
                //tipContent = '证书年费<p>证书年费服务期已于' + item.endDate + '过期请先缴纳证书年费后再办理证书相关维护业务。<p>'
                tipContent = '证书年费<p>证书年费服务期已于' + item.endDate + '过期,请先缴纳证书年费后再办理证书相关维护业务,证书使用年费'+item.fee+'元/张/年。<p>'
                btnRight = "取消";
            }
//             else if (type == 'P012') {
//                tipContent = '新领证书:<p>这是申领' + item.category + '，证书服务费用<span>' + item.fee + '元/年</span>，确定要申领请点“申领”。若是补办首张免费省法人证书请点“取消”后去补办省法人证书。</p > '
//                btnRight = "申领";
//            }

            control.showConfirm(tipContent,

            function() {
            },

            function() {
                            /*
                            *补办
                            * 业务单类型8:证书补办
                            */
                if (type == 'B03') {
                    if (2 == item.existAnnueeFee) {
                        control.showPopup(item.refuseReason, 3000);
                        return;
                    }
                    //封装证书年费所需信息
                    $rootScope.certAnnualFeeInfo = {
                        entName: $rootScope.searchResult.entName,
                        uniscid: $rootScope.searchResult.uniscid,
                        category: item.category,
                        categoryBh: item.categoryBh,
                        isFree: item.isFree,
                        corpid: item.corpid,
                        businessCode: type,
                        operator: '',
                        operatorid: '',
                        count: '',
                        parentPage: parentPage,
                        isUploadMaterials:isUploadMaterials
                    }
                    nav.navigate('confirmPayInfo');
                    return;
                }
            },
            btnLeft, btnRight, 'cusClass');
        }
        var paymentApply = function(item) {

            $rootScope.paymentWay = '0'//申领方式
            $scope.okFunc = function() {
                usingMaterials();
                $scope.showTimeConfirm = false;
            }
            $scope.cancelClick2 = function() {
                $scope.showTimeConfirm = false;
            }
            $scope.showTimeConfirm = true;
            return;
        }

        // 补办/新领 后续操作
        var certOp = function(item) {
            switch (item.certApplyType) {
                case '补办':
                    if (!item.makeUp) {
                        control.showCustom3Popup('知道了','check-information','温馨提示',item.reason);
                    } else {
                    var isHaveTender= $rootScope.searchResult.isHaveTender ? $rootScope.searchResult.isHaveTender:"false";
                    if(isHaveTender=="true"&&item.isMedium=="true"){
                        control.showCustom3Popup('知道了','check-information','温馨提示','贵单位近期内有项目正在进行招投标，暂不支持补办业务，请在项目招标结束操作补办业务。');
                        return;
                    }
                        if ("true" == item.isMedium) {
                            control.showConfirm("当前介质证书补办为移动证书后，介质证书将无法继续使用，确定继续补办吗？",
                            function() {
                                if (!item.inService) {
                                    certFeeScale(item, 'B03', '续费');
                                } else {
                                    toApply(item, "B03", "8");
                                }
                            }, function() {}, "取消", "继续补办");
                        } else {
                            if (!item.inService) {
                                certFeeScale(item, 'B03', '续费');
                            } else {
                                toApply(item, "B03", "8");
                            }
                        }
                    }
                    break;
                case '新领':
                    if (!item.applyNew) {
                        control.showPopup(item.reason, 2000);
                    } else {
                        if (!item.isFree) {
                             $rootScope.certCharge = item.fee;
                            if (item.categoryBh == '011') {
                                 toApply(item, 'P012', "7");
                            } else {
                                 toApply(item, 'P012', "6");
                            }


                        } else {
                            if (item.categoryBh == '011') {
                                toApply(item, 'P012', "7");
                            } else toApply(item, 'P012', "6");
                        }
                    }
                    break;
                }
        }

        // 点击新领/补办按钮
        $scope.nextClick = function() {
            if($scope.certTypeList.length <= 0&&$rootScope.applyCertType==1){
                $rootScope.applyCertType = 0;
                nav.navigate('applyCertSearchV2');
                return
            }
            if(!$scope.chooseCert.canApply&&$scope.chooseCert.certApplyType == "新领"){
                control.showPopup('请先申领浙江省数字法人证书', 1500);
                return
            }

            // 新领省法人主证书
            if($scope.chooseCert.certApplyType == "新领"&&$scope.chooseCert.categoryBh=="010"){
                checkIsApplyFreeCert();
            }else{
                nextOperate();
            }

        }


        var checkIsApplyFreeCert = function() {
            var params = [$scope.chooseCert.corpid];
            control.showLoading();
            var successFunc = function (result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                    result)) {
                    control.showPopup('服务出错啦', 2000);
                    return;
                }
                if (result.code==200) {
                    if(result.data.isApply){
                         var template = "<h3>"+result.data.msg+"</h3>"
                         control.showCustomAlert2(template,'确定', 'check-information',function() {});
                         return
                    }else{
                        nextOperate();
                    }
                }else{
                    control.showPopup(result.message, 2000);
                }
            }
            var failFunc = function (error) {
                control.hideLoading();
                control.showPopup(error.msg, 2000);
            };

            nativeHelper.checkIsApplyFreeCert({
               data: params,
               success: successFunc,
               fail: failFunc
            });
        }
        // 点击新领/补办按钮
        var nextOperate = function() {
//            if($scope.certTypeList.length <= 0&&$rootScope.applyCertType==1){
//                $rootScope.applyCertType = 0;
//                nav.navigate('applyCertSearchV2');
//                return
//            }
//            if(!$scope.chooseCert.canApply&&$scope.chooseCert.certApplyType == "新领"){
//                control.showPopup('请先申领浙江省数字法人证书', 1500);
//                return
//            }




            $rootScope.curAuthCode = $scope.chooseCert.itemCode;
            //定义全局的当前证书名称参数
            $rootScope.cartNameHtml=$scope.chooseCert.category;
            $rootScope.certCharge = $scope.chooseCert.fee;
            var netType = ""
            if($scope.chooseCert.certApplyType == "新领"){
                  var eventCounter = new Object();
                  eventCounter.page = "证书申领-可申领的证书页面-下一步";
                  MobclickAgent.onEventWithParameters("applyCanApplyCertEvent", eventCounter);
                 if ($scope.chooseCert.categoryBh == '011') {
                     netType = "7"
                     $scope.userNetType="7"
                    //v2.9.2 主证书已申领情况下，申领子证书增加主证书补办入口
                    if($scope.mainCertMakeUp){
                     $scope.showMakeUpTip=true;
                     return;
                    }
                 } else {
                     netType = "6"
                     $scope.userNetType="6"
                 }

            }else if($scope.chooseCert.certApplyType == "补办"){
                 var eventCounter = new Object();
                 eventCounter.page = "证书补办-可补办的证书页面-下一步";
                 MobclickAgent.onEventWithParameters("makeUpCanApplyCertEvent", eventCounter);
                 netType = "8"
                 var isHaveCert = false //有效证书  未过期
                 var isHaveExpireCert = false //有效证书  已过期
                 $rootScope.localCertList.forEach(function (l) {
                      if(l.corpid==$scope.chooseCert.corpid&&l.isValid){
                         //v3.0.2 有效证书判断是否过期，过期证书提示延期弹窗 certTipStatus 0过期 1有效,2即将过期 3 变更
                          if(l.certTipStatus=='0'){
                          isHaveExpireCert=true
                          }else{
                           isHaveCert = true
                          }

                      }
                 })
                 if(isHaveCert){
                      var template = "<h3>您的设备已下载该证书，可直接进行扫码使用，无需补办。</h3>"
                      control.showCustomAlert2(template,'确定', 'check-information',function() {});
                      return
                 }
                 if(isHaveExpireCert){
                      var template = "<h3>您的本地已有该单位证书（已过期），请前往我的证书，操作证书延期。</h3>"
                      control.showCustomAlert2(template,'证书延期', 'check-information',function() {
                        $rootScope.showDelayCert = true;
                        $scope.navigate('certManage');
                      });
                      return
                 }

            }
            checkIsRepeatAuth($scope.chooseCert,netType)

        }
        //补办
        $scope.makeUpFunc = function() {
            $scope.showMakeUpTip = false;
           // $scope.chooseCert=$scope.MainCertInfo
             var netType = "8"
             var isHaveCert = false
             $rootScope.localCertList.forEach(function (l) {
                if(l.corpid==$scope.MainCertInfo.corpid&&l.isValid){
                    isHaveCert = true
                }
             })
             if(isHaveCert){
                var template = "<h3>您的设备已下载该证书，可直接进行扫码使用，无需补办。</h3>"
                control.showCustomAlert2(template,'确定', 'check-information',function() {});
                return
             }
              checkIsRepeatAuth($scope.MainCertInfo,netType)
        }
        //继续申领
        $scope.continueFunc = function() {
            $scope.showMakeUpTip = false;
            checkIsRepeatAuth($scope.chooseCert,$scope.userNetType)
        }
        //取消
        $scope.cancleFunc = function() {
            $scope.showMakeUpTip = false;
        }

        // 判断是否存在重复授权
        var checkIsRepeatAuth = function(item,netType){
            var time = utility.getCurrentTime();
            var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);

            var temp = {
                "idcard": $rootScope.loginInfo.idCard,
                "uniscid": $rootScope.searchResult.uniscid,
                "netType": netType,
                "corpid": item.corpid,
                "categoryBh":item.categoryBh
            }
            console.log("checkIsRepeatAuth temp :" + JSON.stringify(temp));
            var reqParams = DES3.encrypt(hashdata.substring(0,24), 'ZJHUIXIN', angular.toJson(temp))

            var params = {
                "appid": $rootScope.appid,
                "time": time,
                "hashdata": hashdata,
                "keyNo": $rootScope.uuid,
                "token": $rootScope.loginInfo.token,
                "reqParams": reqParams
            };
            console.log("checkIsRepeatAuth params :" + JSON.stringify(params));
            control.showLoading();
            requestWrapper.checkIsRepeatAuth({ data: params, refresh: true })
                .then(function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    };
            console.log("checkIsRepeatAuth temp :" + JSON.stringify(result));
            console.log("checkIsRepeatAuth type :" + result.value.type+" belongMe:"+result.value.belongMe+" orderAuditState:"+result.value.orderAuditState+" paystate:"+result.value.paystate);
                    if (true == result.success) {
                        //v2.9.2 新增参数belongMe："1" 业务单或授权单在自己手里  ，"0"  业务单或授权单在其他人手里
                        // 有业务单
                        if ("1" == result.value.type) {
                             if(result.value.belongMe=='1'){//业务单在自己手里
                                //V2.9.2 新增参数orderAuditState 2审核中 ，3审核通过，4 审核拒绝 区分审核中状态提示弹窗
                                if(result.value.orderAuditState=='2'){
                                  var template = "<div><h3>"+result.value.tipMsg+"</h3></div>"
                                  control.showCustomAlert2(template,'查看业务单', 'check-information',function() {
                                      $state.go('businessManage', {
                                            orderNo: result.value.orderNo,
                                            parentPage: parentPage
                                      });
                                  });
                                }else{
                                 var template = "<h3>"+result.value.tipMsg+"</h3>"
                                  control.showConfirm3(function() {
                                      $state.go('businessManage', {
                                           orderNo: result.value.orderNo,
                                           parentPage: parentPage
                                      });
                                  },function() {},'', '去处理', 'check-information', template);
                                }
                                 return;
                             }else  if(result.value.belongMe=='0'){//业务单在其他人手里
                                 //v2.9.2 新增参数payState  1 业务单存在付款记录 0或者空业务单不存在付款记录
                                 if(result.value.payState=='1'){
                                       var template = "<div><h3>"+result.value.tipMsg+"</h3></div>"
                                       control.showCustomAlert2(template,'返回', 'check-information',function() {

                                        });
                                         return;
                                    }else{
                                        var template = "<h3>"+result.value.tipMsg+"</h3>"
                                         control.showConfirm3(function() {
                                             continueMakeUp(item,netType);
                                         },function() {},'', '继续', 'check-information', template);
                                         return;
                                    }
                             }
                        } else if ("2" == result.value.type) {//有授权
                               if(result.value.belongMe=='1'){//授权单在自己手里
                                   if ("1" == result.value.authStatus) {// 有授权记录
                                      //有授权记录但是非邮寄的提示去下载  有授权记录但是走邮寄的，允许生成业务单
                                      if($rootScope.applyCertType != 2){
                                         var template = "<h3>"+result.value.tipMsg+"</h3>"
                                         control.showConfirm3(function() {
                                         $state.go('authorizationRecord', {
                                             authStatus: result.value.authStatus,
                                             parentPage: parentPage
                                         });
                                     },function() {},'', '去下载', 'check-information', template);
                                    }else{
                                       $rootScope.certUnderwayInfo = {
                                          categoryBh: $scope.chooseCert.categoryBh,
                                          entProvince: $rootScope.searchResult.entProvince,
                                       }
                                       if($scope.chooseCert.certApplyType == "新领"&&!item.isFree){
                                           $rootScope.certCharge = item.fee;
                                           paymentApply();
                                       }else{
                                           usingMaterials();
                                       }
                                    }
                                }else if ("0" == result.value.authStatus) { // 没有授权记录(待审核)
                                       var template = "<div><h3>"+result.value.tipMsg+"</h3><p>提交时间："+result.value.time+"</p></div>"
                                       control.showCustomAlert2(template,'查看授权记录', 'check-information',function() {
                                            $state.go('authorizationRecord', {
                                                 authStatus: result.value.authStatus,
                                                 parentPage: parentPage
                                            });
                                        });
                                }
                               }else  if(result.value.belongMe=='0'){//有授权单在其他人手里
                                    var template = "<h3>"+result.value.tipMsg+"</h3>"
                                    control.showConfirm3(function() {
                                         continueMakeUp(item,netType);
                                    },function() {},'', '继续', 'check-information', template);
                                     return;
                               }
                        }
                        else{
                            $rootScope.certUnderwayInfo = {
                                categoryBh: $scope.chooseCert.categoryBh,
                                entProvince: $rootScope.searchResult.entProvince,
                            }
                            if($rootScope.applyCertType == 2){
                                if($scope.chooseCert.certApplyType == "新领"&&!item.isFree){
                                    $rootScope.certCharge = item.fee;
                                    paymentApply();
                                }else{
                                    usingMaterials();
                                }
                            }else{
                                if ("HCCA_NEW" == item.caName) {
                                    doCheckUploadPicture(item);
                                } else {
                                    certOp(item);
                                }
                            }
                        }
                    } else {
                        control.showPopup(result.msg, 2000);
                    }
                }).catch(function (e) {
                    control.hideLoading();
                    control.showPopup('网络请求失败：' + e.status, 2000);
                });
            }
        //当其他人持有证书，补办提示弹窗点击继续
        var continueMakeUp = function(item,netType){
              $rootScope.certUnderwayInfo = {
                  categoryBh: $scope.chooseCert.categoryBh,
                  entProvince: $rootScope.searchResult.entProvince,
              }
              if($rootScope.applyCertType == 2){
                  if($scope.chooseCert.certApplyType == "新领"&&!item.isFree){
                      $rootScope.certCharge = item.fee;
                      paymentApply();
                  }else{
                      usingMaterials();
                  }
              }else{
                  if ("HCCA_NEW" == item.caName) {
                       doCheckUploadPicture(item);
                  } else {
                       certOp(item);
                  }
              }
        }



        // 华测证书判断是否需要上传材料
        var doCheckUploadPicture = function (item) {
            var time = utility.getCurrentTime();
            var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);

            var temp = {
                "corpid": item.corpid,
                "proxIdNo": $rootScope.loginInfo.idCard,
                "categoryBh": item.categoryBh,
                'keyNo':$rootScope.uuid,
                "token" : $rootScope.loginInfo.token
            }

            var reqParams = DES3.encrypt(hashdata.substring(0,24), 'ZJHUIXIN', angular.toJson(temp))

            var params = {
                "appid": $rootScope.appid,
                "time": time,
                "hashdata": hashdata,
                "reqParams": reqParams
            };

            console.log("doCheckUploadPicture params :" + JSON.stringify(params));
            requestWrapper.doCheckUploadPicture({ data: params, refresh: true })
                .then(function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    };

                    if (true == result.success) {
                        if ("yes" == result.value.isUpload) {
                           usingMaterials();
                        } else {
                            certOp(item);
                        }
                    } else {
                        control.showPopup(result.msg, 2000);
                    }
                })
                .catch(function (e) {
                    control.hideLoading();
                    control.showPopup('网络请求失败：' + e.status, 2000);
                });
        }

        // 走材料(材料领证和材料邮寄)
        var usingMaterials = function() {
            var bCode = '';
            var nType = '';
            if ($scope.chooseCert.hasOwnProperty('applyNew')) {
                // 新领
                bCode = 'P012';
                if ($scope.chooseCert.categoryBh == '011') {
                    nType = '7';
                } else {
                    nType = '6';
                }
            } else if ($scope.chooseCert.hasOwnProperty('makeUp')) {
                // 补办
                bCode = 'B03';
                nType = '8';
            }
            $rootScope.certCharge = $scope.chooseCert.fee;
            $rootScope.certUnderwayInfo = {
                entName: $rootScope.searchResult.entName,
                categoryBh: $scope.chooseCert.categoryBh,
                entProvince: $rootScope.searchResult.entProvince,
                businessCode: bCode,
                netType: nType,
                uniscid: $rootScope.searchResult.uniscid,
                corpid: $scope.chooseCert.corpid,
                category: $scope.chooseCert.category,
                isFree: $scope.chooseCert.isFree?$scope.chooseCert.isFree:$scope.chooseCert.inService,

                inService: $scope.chooseCert.inService,
                certName:$scope.chooseCert.certName,
                certApplyType: $scope.chooseCert.certApplyType,
                caName: $scope.chooseCert.caName,
                operator: '',
                operatorid: '',
                identityType:'',
            }

             if($rootScope.applyCertType == 2){
                if (!$scope.chooseCert.inService&&$scope.chooseCert.makeUp) {  // 材料邮寄 续费(补办)
                     certFeeScale($scope.chooseCert, 'B03', '续费');
                }else if(!$scope.chooseCert.isFree&&$scope.chooseCert.applyNew){ // 材料邮寄 收费(新领)
                    nav.navigate('mailPayInvoice');
                }else{
                    // 材料邮寄 免费
                    $state.go('postIntroduction', {
                        orderNo: ''
                    });
                }
            }else{

                if (!$scope.chooseCert.inService&&$scope.chooseCert.makeUp) {  // 材料申领 续费(补办)
                    isUploadMaterials = true;//需要上传材料
                    certFeeScale($scope.chooseCert, 'B03', '续费');
                }
//                else if(!$scope.chooseCert.isFree&&$scope.chooseCert.applyNew){  // 材料申领 收费(新领)
//                    $rootScope.isUploadMaterials = true;//需要上传材料
//                    toApply(item, 'P012', "7");;//华测ca证书  续费走上传材料
//                }
                else {
                    // 材料领证 免费
                    nav.go('userNotice');
                }
            }
        }


        //人脸图片与身份信息核验失败提示
        var detectionError = function() {
             control.showPopup(resultMsg, 2000);
        }
    //申请授权成功
    var applyAuthorizeRes = function(res) {
        $state.go('applyAuthorizeComplete', {
            linkInfo: res
        });
    }
    //更新扩展字段
    var updateExtendData = function(authId) {
        control.showLoading();
        var extendData = {
            'certName': $rootScope.certUnderwayInfo.netType == "8" ? $rootScope.certUnderwayInfo.certName: $rootScope.certUnderwayInfo.entName,
            'categoryBh': $rootScope.certUnderwayInfo.categoryBh,
            'netType': $rootScope.certUnderwayInfo.netType,
            'corpid': $rootScope.certUnderwayInfo.corpid,
            'businessType': $filter('netTypeNumToText')($rootScope.certUnderwayInfo.netType),
        };

        var params = [authId, "EPASSAPP", extendData];
        //             var params = ["1","20190325092052817016",cardId,"玉环金源进出口有限公司","913310217719107159" ];
        var successFunc = function(result) {
            control.hideLoading();
            if (result.rslt == 'success') {
                $rootScope.recordType='1';
                nav.navigate('authorizationRecord');
            } else {
                control.showPopup(result.errorMsg, 2000);
            }
        }
        var failFunc = function(result) {
            control.hideLoading();
            control.showPopup(result.msg, 2000);
        };
        nativeHelper.updateExtendData({
            data: params,
            success: successFunc,
            fail: failFunc
        });
    }
    //授权鉴权结果
    var checkAuthInfoFunc = function(result) {
        console.log("checkAuthInfoFunc - " + JSON.stringify(result));
        $scope.$apply(function() {
            if (result.checkData.checkRslt == "true") {
                if(result.authInfoData.extendData==null){
                    updateExtendData(result.checkData.authId);
                }else{
                    var categoryBh=JSON.parse(result.authInfoData.extendData).categoryBh;
                    let netType = JSON.parse(result.authInfoData.extendData).netType;
                    if(categoryBh==$rootScope.certUnderwayInfo.categoryBh){

                        // 判断当前用户操作和授权记录（补办/新领） 是否一致  一致：去授权记录  不一致：去申领
                        if ($rootScope.certUnderwayInfo == netType) {
                            $rootScope.recordType='1';
                            nav.navigate('authorizationRecord');
                        } else {
                            var template = "<div><i class='icon-tips2'></i><h3>查无授权</h3><p>您尚未被授权领证，请申请</p></div>"
                            control.showConfirm3(function() {
                                verifyIdentity.applyAuthorize($rootScope.certUnderwayInfo.systemTime, $rootScope.loginInfo.idCard, $rootScope.loginInfo.userName, applyAuthorizeRes);
                            },
                            function() {},
                            '取消', '申请', 'check-information', template);
                        }
                    }else{
                        var template = "<div><i class='icon-tips2'></i><h3>查无授权</h3><p>您尚未被授权领证，请申请</p></div>"
                        control.showConfirm3(function() {

                            verifyIdentity.applyAuthorize($rootScope.certUnderwayInfo.systemTime, $rootScope.loginInfo.idCard, $rootScope.loginInfo.userName, applyAuthorizeRes);
                        },
                        function() {},
                        '取消', '申请', 'check-information', template);
                    }
                }
            } else {
                var template = "<div><i class='icon-tips2'></i><h3>查无授权</h3><p>您尚未被授权领证，请申请</p></div>"
                control.showConfirm3(function() {
                    console.log('您尚未被授权领证，请申请')
                    verifyIdentity.applyAuthorize($rootScope.certUnderwayInfo.systemTime, $rootScope.loginInfo.idCard, $rootScope.loginInfo.userName, applyAuthorizeRes);
                },
                function() {},
                '取消', '申请', 'check-information', template);
            }
        });

    }




        var checkIdentityTypeRes=function(result){

            if (result.rslt == 'success') {
                $rootScope.certUnderwayInfo.systemTime = result.systemTime;
                $rootScope.certUnderwayInfo.identityType = result.identityType; //0法定代表人1管理员2经办人
                $rootScope.certUnderwayInfo.identityId = result.identityId;
                // 0 正常申领  1.申领短信验证返回  2.申领短信验证通过  3.正常授权 4.授权短信验证返回  5.授权短信验证通过
                $rootScope.verifyCodeType = '0';
                nav.navigate('chooseIdentity');
            }
            if (result.rslt == 'fail') {
                $scope.$apply(function() {
                    if ("ERROR_027" == result.errorCode) {
                        //表示法定代表人身份证无法通过校验
                        control.showCustomAlert3('知道了', 'check-information');
                        return;
                    }
                    if ("ERROR_028" == result.errorCode ) {
                        //法人身份与主体法人不符
                        control.showCustomAlert4('知道了', 'check-information');
                        return;
                    }
                    if ("ERROR_029" == result.errorCode ) {
                        //法定代表人身份证不属于中国大陆
                         nav.navigate('userNotice');
                        return;
                    }
                    if("ERROR_038"==result.errorCode){
                        nav.navigate('userNotice');
                        return;
                    }
                    if("ERROR_023"==result.errorCode){
                        nav.navigate('userNotice');
                        return;
                    }

                    control.showPopup(result.errorMsg, 2000);
                });
            }
        }


           //检查经办人身份类型
        var checkIdentityType=function(){
            verifyIdentity.checkIdentity($rootScope.searchResult.uniscid,$rootScope.loginInfo.idCard,'2',checkIdentityTypeRes);
        }
        $scope.navigate = function(state) {
            nav.navigate(state);
        };
    }]);
})();
