(function () {
    "use strict"

    angular.module('starter')
        .controller('chooseApplyWay', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', '$state', '$filter','localStorage', '$ionicHistory','verifyIdentity','utility',
        function ($rootScope, $scope, nav, control, nativeHelper, $state, $filter,localStorage, $ionicHistory,verifyIdentity, utility) {
            $scope.chooseApplyWay = 0;//0 未选择 1 在线申领  2 材料领证
            $scope.chooseRadio = function(type) {
                $scope.chooseApplyWay = type;
            }

            // 经办人 申请授权成功
            var applyAuthorizeRes = function(res) {
                $state.go('applyAuthorizeComplete', {
                    linkInfo: res
                });
            }

            $scope.next = function () {
                if( $scope.chooseApplyWay == 1){
                    verifyIdentity.applyAuthorize($rootScope.certUnderwayInfo.systemTime, $rootScope.loginInfo.idCard, $rootScope.loginInfo.userName, applyAuthorizeRes);
                }else if($scope.chooseApplyWay == 2){
                    nav.navigate('userNotice');
                }
                if($rootScope.applyCertType == 0){
                    var eventCounter = new Object();
                    eventCounter.page = "证书申领-选择领证方式页面-下一步";
                    MobclickAgent.onEventWithParameters("applyOnlineAuthorizationEvent", eventCounter);
                }else if($rootScope.applyCertType == 1){
                    var eventCounter = new Object();
                    eventCounter.page = "证书补办-选择领证方式页面-下一步";
                    MobclickAgent.onEventWithParameters("makeUpOnlineAuthorizationEvent", eventCounter);
                    }
            };

            $scope.goBack=function(){
                $ionicHistory.goBack();
            }

        }]);
})();
