(function () {
    "use strict"

    angular.module('starter')
        .controller('chooseIdentity', ['$rootScope', '$scope', 'nav', 'control', 'nativeHelper', '$state', '$filter','localStorage', '$ionicHistory','verifyIdentity',
        function ($rootScope, $scope, nav, control, nativeHelper, $state, $filter,localStorage, $ionicHistory,verifyIdentity) {

            $scope.represent={type:''}

            $scope.chooseIdentity = 0;//0 未选择 1 法人/管理员  2 经办人
            $scope.isShowLegalPop = false;// 选择证书持有人 弹框选择
            $rootScope.chooseCertType = 0;// 选择证书持有人 未选择 1 自己申领  2 授权他人
            $scope.isAgreeCertProtocol = false;

            if($rootScope.verifyCodeType=='1'){
                $scope.chooseIdentity = 1;
            }if($rootScope.verifyCodeType=='2'){
                $scope.chooseIdentity = 1;
                $scope.isShowLegalPop = true
            }

            $scope.chooseRadio = function(type) {
                $scope.chooseIdentity = type;
            }

            $scope.agree = function() {
                $scope.isAgreeCertProtocol = !$scope.isAgreeCertProtocol;
            }

            // 点击下一步 检查经办人身份类型
           $scope.checkIdentityType = function(){
               if($rootScope.applyCertType == 0){
                    var eventCounter = new Object();
                    eventCounter.page = "证书申领-选择身份页面-下一步";
                    MobclickAgent.onEventWithParameters("applySelectIdentityEvent", eventCounter);
                }else if($rootScope.applyCertType == 1){
                    var eventCounter = new Object();
                    eventCounter.page = "证书补办-选择身份页面-下一步";
                    MobclickAgent.onEventWithParameters("makeUpSelectIdentityEvent", eventCounter);
                }
                if($scope.chooseIdentity == 0){
                    return;
                }
                verifyIdentity.checkIdentity($rootScope.searchResult.uniscid,$rootScope.loginInfo.idCard,'2',checkIdentityTypeRes);
           }
            var checkIdentityTypeRes=function(result){
                    if (result.rslt == 'success') {
                           $rootScope.certUnderwayInfo.systemTime = result.systemTime;
                           $rootScope.certUnderwayInfo.identityType = result.identityType; //0法定代表人1管理员2经办人
                           $rootScope.certUnderwayInfo.identityId = result.identityId;
                            // 我是法人或者管理员
                            if($rootScope.certUnderwayInfo.identityType !='2') {
                                // 判断选择经办人
                                if($scope.chooseIdentity==1){
                                    if($rootScope.certUnderwayInfo.identityType == '0'){
                                        verifyIdentity.mobileCheck($rootScope.certUnderwayInfo.corpid,$rootScope.loginInfo.userName,
                                            $rootScope.loginInfo.idCard,$rootScope.loginInfo.mobile,$rootScope.loginInfo.accountId,mobileCheckRes);
                                    }else{
                                      $scope.isShowLegalPop = true
                                    }
                                }else{
                                    control.showPopup("抱歉，经校验您的选择有误，请选择「我是法定代表人」继续申请", 3000);
                                }
                            } else { // 我是经办人
                                // 判断选择经办人
                                if($scope.chooseIdentity==2){
                                    verifyIdentity.getAuthorizationComfirmInfo($rootScope.loginInfo.idCard,$rootScope.certUnderwayInfo.entName,$rootScope.certUnderwayInfo.uniscid,checkAuthInfoFunc);
                                }else{
                                    control.showPopup("抱歉，经校验您的身份不是申请单位法定代表人，请重新选择您的身份", 3000);
                                }
                            }
                    }
                    if (result.rslt == 'fail') {
                           $scope.$apply(function() {
                               if ("ERROR_027" == result.errorCode) {
                                     //表示法定代表人身份证无法通过校验
                                     control.showCustomAlert3('知道了', 'check-information');
                                     return;
                               }
                               if ("ERROR_028" == result.errorCode ) {
                                     //法人身份与主体法人不符
                                     control.showCustomAlert4('知道了', 'check-information');
                                     return;
                               }
                               if ("ERROR_029" == result.errorCode ) {
                                     //法定代表人身份证不属于中国大陆
                                     nav.navigate('userNotice');
                                     return;
                               }
                               if("ERROR_038"==result.errorCode){
                                     nav.go('userNotice');
                                     return;
                               }
                               if("ERROR_023"==result.errorCode){
                                     nav.go('userNotice');
                                     return;
                               }
                               control.showPopup(result.errorMsg, 2000);
                           });
                    }
            }



//            $scope.isIdentityVerifyPop = false;
            var mobileCheckRes = function(result){
                 console.log('mobileCheckRes - ' + JSON.stringify(result));
                 if (result.success) {
                    $scope.verifyResult = result.value.verifyResult
                    // 0.核验通过 1.三要素核验通过发短信 2.核验不通过 3.设备换过发短信 4.核验业务单待确认 5.无核验业务单
                    if ($scope.verifyResult == '0'){
                         $scope.isShowLegalPop = true
                    } else if ($scope.verifyResult == '1'){
                         nav.navigate('enterVerifyCode')
                    } else if ($scope.verifyResult == '2'){
                         $scope.verifyMsg = result.value.verifyMsg;
                         $scope.isShowNotVerifyMobilePop = true;
                    } else if ($scope.verifyResult == '3'){
                         nav.navigate('enterVerifyCode')
                    } else if ($scope.verifyResult == '4'){ // 核验业务单待确认
                         $scope.identityVerifyClick();
                    } else if ($scope.verifyResult == '5'){ // 无核验业务单
                         $scope.identityVerifyClick();
                    }
                }else{
                    control.showPopup(result.msg, 2000);
                }
            }
            $scope.isShowNotVerifyMobilePop = false;
            $scope.notVerifyMobileComfire =  function(){
              $scope.isShowNotVerifyMobilePop = false;
            }
            $scope.identityVerifyClick =  function(){
                if($scope.verifyResult == '5'){
                    $rootScope.autoApplyInfo = {
                        businessLicensePic: '',
                        businessLicenseEntName: '',
                        businessLicenseOrgCode: '',
                        authorizationPic: '',
                        authorizationEntName: '',
                        authorizationPerson: '',
                        authorizationID: '',
                        authorizationTel: '',
                        authorizationExpDate: '',
                        IDCardFrontPic: '',
                        IDCardBackPic: '',
                        IDCardName: $rootScope.loginInfo.userName ? $rootScope.loginInfo.userName: '',
                        IDCardNumber: $rootScope.loginInfo.idCard ? $rootScope.loginInfo.idCard: '',
                        IDCardIndate: '',
                    };
                    $rootScope.certApplyNoticeParent = 'doIdentityVerifyToUploadPic';
                    nav.navigate('uploadApplyMaterials');
                }else if($scope.verifyResult == '4'){
                    nav.navigate('businessManage')
                }
            }

            //授权鉴权结果
            var checkAuthInfoFunc = function(result) {
                console.log("checkAuthInfoFunc - " + JSON.stringify(result));
                $scope.$apply(function() {
                    if (result.checkData.checkRslt == "true") {
                        if(result.authInfoData.extendData==null){
                            updateExtendData(result.checkData.authId);
                        }else{
                            var categoryBh=JSON.parse(result.authInfoData.extendData).categoryBh;
                            let netType = JSON.parse(result.authInfoData.extendData).netType;
                            if(categoryBh==$rootScope.certUnderwayInfo.categoryBh){

                                // 判断当前用户操作和授权记录（补办/新领） 是否一致  一致：去授权记录  不一致：去申领
                                if ($rootScope.certUnderwayInfo == netType) {
                                    $rootScope.recordType='1';
                                    nav.navigate('authorizationRecord');
                                } else {
                                    nav.navigate('chooseApplyWay');
                                }
                            }else{
                                nav.navigate('chooseApplyWay');
                            }
                        }
                    } else {
                        nav.navigate('chooseApplyWay');
                    }
                });
            }

            //更新扩展字段
            var updateExtendData = function(authId) {
                control.showLoading();
                var extendData = {
                    'certName': $rootScope.certUnderwayInfo.netType == "8" ? $rootScope.certUnderwayInfo.certName: $rootScope.certUnderwayInfo.entName,
                    'categoryBh': $rootScope.certUnderwayInfo.categoryBh,
                    'netType': $rootScope.certUnderwayInfo.netType,
                    'corpid': $rootScope.certUnderwayInfo.corpid,
                    'businessType': $filter('netTypeNumToText')($rootScope.certUnderwayInfo.netType),
                };

                var params = [authId, "EPASSAPP", extendData];
                var successFunc = function(result) {
                    control.hideLoading();
                    if (result.rslt == 'success') {
                        $rootScope.recordType='1';
                        nav.navigate('authorizationRecord');
                    } else {
                        control.showPopup(result.errorMsg, 2000);
                    }
                }
                var failFunc = function(result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 2000);
                };
                nativeHelper.updateExtendData({
                    data: params,
                    success: successFunc,
                    fail: failFunc
                });
            }
             $scope.chooseCertTypeClick = function(i){
                $rootScope.chooseCertType = i;
             }
            // 经办人 申请授权成功
            var applyAuthorizeRes = function(res) {
                $state.go('applyAuthorizeComplete', {
                    linkInfo: res
                });
            }
            var operatorType;
            // 提交选择证书持有人
            $scope.checkCertType = function(){
                if($rootScope.chooseCertType!=0&&!$scope.isAgreeCertProtocol){
                     control.showPopup('请阅读并同意《数字证书服务协议》', 1000);
                     return
                }
                $scope.isShowLegalPop = false
                switch($rootScope.certUnderwayInfo.identityType){
                    case '0':
                        operatorType='0'
                        break;
                    case '1':
                        operatorType='2';
                        break;
                    case '2':
                        operatorType='1';
                        break;
                }

                if($rootScope.chooseCertType==1){
                    // 法人/管理员 本人申领证书 身份验证
                    if($rootScope.isAuthFace()){
                        $scope.alert_applicant_info = true;
                    }else{
                         if(!$rootScope.certUnderwayInfo.isFree){
                             paymentApply();
                         }else {
                             createBusinessOrder();
                         }
                    }
                }else if($rootScope.chooseCertType==2){
                    // 法人/管理员 授权他人领取
//                    if(!$rootScope.certUnderwayInfo.isFree){
//                        paymentApply(2);
//                    }else {
                        nav.navigate('approvallnfoV2');
//                    }
                }
            }

             // 付费提醒
             var paymentApply = function() {

                $rootScope.paymentWay = '0'//申领方式
             	$scope.okFunc = function() {
             	    createBusinessOrder()
             		$scope.showTimeConfirm = false;
             	}
             	$scope.cancelClick2 = function() {
             		$scope.showTimeConfirm = false;
             	}
             	$scope.showTimeConfirm = true;
             	return;
             }


            //生成业务单
            var doNetOrderInfo = function() {
            control.showLoading();
            var params = [$rootScope.loginInfo.userName, $rootScope.loginInfo.idCard,
            $rootScope.loginInfo.mobile, $rootScope.loginInfo.accountId,
            $rootScope.certUnderwayInfo.corpid, $rootScope.certUnderwayInfo.categoryBh,
            $rootScope.certUnderwayInfo.netType, {
                'letter': '',
                'idCardFace':"data:image/png;base64,"+$rootScope.certUnderwayInfo.base64PhotoData
            },
            'EPASSAPP',
            '',
            operatorType];
            var successFunc = function(result) {

                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 2000);
                    return;
                }
                 if (result.success) {

                    //0：法人 1:经办人
                    $scope.$apply(function(){
                            $rootScope.certUnderwayInfo.orderNo=result.value.orderNo;
                            $rootScope.certUnderwayInfo.orderType='1';
                            $state.go('downloadCert',{'downloadCertInfo':$rootScope.certUnderwayInfo});
                    });
                }
                if (!result.success) {
                    control.showPopup(result.msg, 2000);
                }
            }
            var failFunc = function(error) {

                control.hideLoading();
                control.showPopup(error.msg, 2000);
            };

            nativeHelper.doSaveAuthNetOrderInfo({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }
//     32   "identityType": "0法定代表人1管理员2经办人",

            var createBusinessOrder=function(){

                if ($rootScope.certUnderwayInfo.businessCode == 'P012' && !$rootScope.certUnderwayInfo.isFree) {
                        $state.go('confirmCertInvoice',{'netOrderInfoWithInvoice':{
                        'entName':$rootScope.certUnderwayInfo.entName,
                        'uniscid':$rootScope.certUnderwayInfo.uniscid,
                        'agenter':$rootScope.loginInfo.userName,
                        'cert':$rootScope.loginInfo.idCard,
                        'mobile':$rootScope.loginInfo.mobile,
                        'corpid':$rootScope.certUnderwayInfo.corpid,
                        'categoryBh':$rootScope.certUnderwayInfo.categoryBh,
                        'netType':$rootScope.certUnderwayInfo.netType,
                        'letter':'',
                        'idCardFace':$rootScope.certUnderwayInfo.base64PhotoData,
                        'authId':$rootScope.certUnderwayInfo.identityId,
                        'operatorType':operatorType,
                        'businessCode':$rootScope.certUnderwayInfo.businessCode,
                        'orderType':'1',
                        }});
                        return;
                }
//                if($rootScope.isAuthFace()){
//                     $scope.alert_applicant_info=true;
//                }else{
                     doNetOrderInfo();
//                }
            }
//            // 经办人申请证书
//            $scope.applyAuthorize = function() {
//                verifyIdentity.applyAuthorize($rootScope.certUnderwayInfo.systemTime, $rootScope.loginInfo.idCard, $rootScope.loginInfo.userName, applyAuthorizeRes);
//            }

           //实人检测错误提示
            var detectionError = function(resultMsg) {
                control.showPopup(resultMsg, 2000);

            }
            //采集人脸提示
            $scope.alert_applicant_info = false;
            $scope.closeApplicantInfoAlert = function() {
                $scope.alert_applicant_info = false;
            }

            //开始活体检测
            $scope.startBiopsyClick=function(){
                $scope.alert_applicant_info=false;
                $scope.acShowAuthConfirm = true;
            }
            
            var authLivingFailEvent = function() {
                var eventCounter = new Object();
                eventCounter.page = "活体识别失败";
                MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
            }


            var startBiopsy = function() {
                var eventCounter = new Object();
                eventCounter.page = "活体检测-法人下载";
                MobclickAgent.onEventWithParameters("authLivingLegalPersonEvent", eventCounter);
                $scope.alert_applicant_info=false;
                verifyIdentity.startLiveDetection($rootScope.loginInfo.userName, $rootScope.loginInfo.idCard, $rootScope.loginInfo.userId,liveDetectionResult);
            }


            $scope.acShowAuthConfirm = false;
            $scope.acCloseClick = function() {
                $scope.acShowAuthConfirm = false;
            }
            $scope.acIsAgreeApplyAgreement = false;
            $scope.acAgree = function() {
                $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
            }
            $scope.acAgreement = function() {
                var url = window.currentUrl + '/app/ezt/faceAgreement.html';
                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                cordova.InAppBrowser.open(url, '_blank', operation);
            }
            $scope.acNext = function() {
                if (!$scope.acIsAgreeApplyAgreement) {
                    control.showPopup("请确认同意《人脸认证功能协议》", 2000);
                    return;
                }
                $scope.acShowAuthConfirm = false;
                startBiopsy();
            }
            // 人脸再试一次
            $scope.faceAuthTryAgain = function(){
                $scope.acShowAuthConfirm = true;
                $rootScope.closeFaceAuthFail();
            }

            var photoData;
            //人脸识别结果监听
            var liveDetectionResult = function(res) {
                $scope.$apply(function() {
                    if (res.rslt == 'success') {
                        photoData = res.photoData;
                        $rootScope.certUnderwayInfo.base64PhotoData = photoData;
                        IdentityAuthenticationRes(res.data)
                    }else{
                        authLivingFailEvent();
                        detectionError(res.resultMsg);
                    }
                });
            };

            //人脸信息和身份信息对比结果
            var IdentityAuthenticationRes = function(data) {
                    if (data.result == 'fail') {
                         if (data.authResult == '5XXX' || data.authResult == '6XXX') {
                             if(!$rootScope.isOpenFaceAuthFail()){
                                 detectionError('姓名或身份证号码有误，错误代码' + data.authResult);
                             }
                             return;
                         } else if(data.authResult == '01XX' || data.authResult == '02XX' || data.authResult == '02XX'){
                             if(!$rootScope.isOpenFaceAuthFail()){
                                detectionError('人脸比对失败，错误代码'+data.authResult);
                             }
                             return;
                         } else {
                            if(!$rootScope.isOpenFaceAuthFail()){
                                control.showPopup(data.authResultMsg, 2000);
                            }
                         }
                    }
                    if (data.result == 'success') {
                        $rootScope.setAuthSuccessTime();
                        if(!$rootScope.certUnderwayInfo.isFree){
                            paymentApply();
                        }else {
                            createBusinessOrder();
                        }
//                        //生成业务单
//                        doNetOrderInfo();
                    }

            }




        var authLivingFailEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "活体识别失败";
            MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
        }


        $scope.navigate = function (state) {
            nav.navigate(state);
        };
        $scope.goBack=function(){
            $ionicHistory.goBack();
        }

    }]);
})();
