﻿(function () {
    "use strict"
    angular.module('starter')
        .controller('checkBusinessLicense', ['$rootScope', '$scope', 'nav', 'control', 'utility', function ($rootScope, $scope, nav, control, utility) {
//            $scope.isShowPhotoRules = false;

            $scope.checkPicture = function () {
                var successFunc = function (pic) {
                  $scope.$apply(function () {
                    control.hideLoading();
                    $rootScope.autoApplyInfo.businessLicensePic = 'data:image/png;base64,' + pic;
                  });
                };

                var failFunc = function (e) {
                    control.hideLoading();
                };

                control.camera(successFunc, failFunc, false,$rootScope.isDoIdentityVerify);
            }
            $scope.isPreviewPicture = false;
            $scope.previewPicture = function () {
                $scope.previewPic = $rootScope.autoApplyInfo.businessLicensePic;
                $scope.isPreviewPicture = true;
            }
            $scope.cancel = function () {
                $scope.isPreviewPicture = false;
            }
//            var img = document.querySelector('.preview-pic img');
//
//            var hammers = new Hammer(img)
//            hammers.on('pan panstart panmove panend pinchstart pinchmove pinchend', function(ev) {
//                console.log(ev);
//            });
//            var scale = 1;
//            var startDistance = 0;
//            var distX = 0;
//            var distY = 0;
//            var startX = 0;
//            var startY = 0;
//            var isMoving = false;
//
//            img.addEventListener('touchstart', (e) => {
//              if (e.touches.length === 2) { // 当两指同时触摸时
//                var touch1 = e.touches[0];
//                var touch2 = e.touches[1];
//
//                 // 计算两个手指之间的距离 先计算xy1、xy2
//                 startDistance = Math.hypot(Math.abs(touch1.pageX - touch2.pageX),Math.abs(touch1.pageY - touch2.pageY));
//              }else if(e.touches.length === 1){
//                 isMoving = true;
//                 var touch = e.touches[0];
//                 startX = touch.pageX;
//                 startY = touch.pageY;
//                 console.log("=======touchstart startX="+startX+",startY="+startY);
//                 distX = 0;
//                 distY = 0;
//              }
//            });
//
//            img.addEventListener('touchmove', (e) => {
//              e.preventDefault();
//
//              if (e.touches.length === 2) {
//                console.log("suligen 1");
//
//                var touch1 = e.touches[0];
//                var touch2 = e.touches[1];
//                // 移动后两个手指的距离
//                var moveDistance = Math.hypot(Math.abs(touch1.pageX - touch2.pageX),Math.abs(touch1.pageY - touch2.pageY));
//                scale = moveDistance/startDistance
//
//                if(scale<1){
//                    scale = 1
//                }else if(scale>3){
//                    scale = 3
//                }
//                img.style.transform = `translate(${img.offsetLeft}px, ${img.offsetTop}px) scale(${scale})`;
//              } else if (e.touches.length === 1) {
//
//                // 移动时
//                var touch = e.touches[0];
//
//                distX = touch.pageX - startX;
//                distY = touch.pageY - startY;
//
//                console.log("=======touchmove distX="+distX+",distY="+distY+";scale="+scale);
//                img.style.transform =  `translate(${distX}px, ${distY}px) scale(${scale})`;
//
//              }
//            });
//
//            img.addEventListener('touchend', (e) => {
//              if (isMoving) {
//                  // 单点触摸结束
//                  isMoving = false;
//                }
//            });
//
//
//
            $scope.next = function () {
                if ($rootScope.autoApplyInfo.businessLicensePic == '') {
                        control.showPopup('请上传图片', 2000);
                    return;
                }
                $rootScope.autoApplyInfo.businessLicenseEntName = $rootScope.certUnderwayInfo.entName;
                nav.navigate('uploadApplyMaterials');
            }

            $scope.navigate = function (state) {
                nav.navigate(state);
            };
            $scope.showPic = false;
            $scope.showPicClick = function() {
                $scope.showPic = true;
            }
            $scope.picClick = function() {
                $scope.showPic = false;
                $scope.isPreviewPicture = false;
            }

        }]);
})();