(function () {
    "use strict"
    angular.module('starter')
        .controller('userNotice', ['$rootScope', '$scope', 'nav', 'localStorage', 'control', '$ionicActionSheet', 'nativeHelper','verifyIdentity','$stateParams', function ($rootScope, $scope, nav, localStorage, control, $ionicActionSheet, nativeHelper,verifyIdentity,$stateParams) {
            $scope.orderNo = $stateParams.orderNo
            $rootScope.autoApplyInfo = {
                businessLicensePic: '',
                businessLicenseEntName: '',
                businessLicenseOrgCode: '',
                authorizationPic: '',
                authorizationEntName: '',
                authorizationPerson: '',
                authorizationID: '',
                authorizationTel: '',
                authorizationExpDate: '',
                IDCardFrontPic: '',
                IDCardBackPic: '',
                IDCardName: $rootScope.loginInfo.userName ? $rootScope.loginInfo.userName: '',
                IDCardNumber: $rootScope.loginInfo.idCard ? $rootScope.loginInfo.idCard: '',
                IDCardIndate: '',
                serviceProtocolPic: '',// 2.8.2新增  服务协议
                orderNo:''//2.8.2新增  材料业务单先付款在上传
            };

            $rootScope.cancelBusiness = function () {
                control.showCustomPopup('html/home/autoApply/popupCancelBusiness.html', '', '取消', '继续', 'popup-btn-default', 'popup-btn-light', function () {
                    nav.navigate('reissueOrGetNewCert');
                }, function () {
                    return;
                });
            }
            var eventCounter = new Object();
            eventCounter.page = "材料领证-申领须知页面";
            MobclickAgent.onEventWithParameters("materialCertificationEvent", eventCounter);

            $rootScope.infoMismatchMsg = '信息不一致，重新上传资料';
            $rootScope.infoMismatch = function () {
                control.showCustomPopup('html/home/autoApply/popupInfoMismatch.html', '', '重传资料', '普通审核通道', 'popup-btn-primary', 'popup-btn-default', function () {
                    return;
                }, function () {
                    $rootScope.isAutoApply = false;
                    nav.navigate('reissueOrGetNewCert');
                });
            }


            $rootScope.OCRFailMsg = '图像识别失败，请重试';
            $rootScope.OCRFail = function () {
                control.showCustomAlert('test', 'html/home/autoApply/popupOCRFail.html', '知道了', 'popup-btn-positive', function () {
                    return;
                });
            }

//            $scope.navToTrust = function () {
//                $rootScope.entrustTemplateParent = 'userNotice';
//                nav.navigate('entrustTemplate');
//            }


            $scope.userNotice = {selectAutoOrOrdinary: 1};

            $scope.isAgreeApplyAgreement=false;
            $scope.agree=function(){
                $scope.isAgreeApplyAgreement=!$scope.isAgreeApplyAgreement;
            }

            $rootScope.applyCertInfo={'uniscid':''}
            $scope.$watch('applyCertInfo.uniscid', function(newValue, oldValue) {
                $rootScope.applyCertInfo.uniscid = newValue.replace(/\s+/g,"");
            });
            var confirmOrgCode=function(){


                $scope.showCheckUniscid = true;
                $scope.checkUniscidFunc = function() {
                	if ($rootScope.applyCertInfo.uniscid.length !== 4) {
                		control.showPopup('请输入统一社会信用代码后4位!' + $rootScope.applyCertInfo.uniscid, 2000);
                		return;
                	}
                	if ($rootScope.applyCertInfo.uniscid.toUpperCase() !== $rootScope.searchResult.uniscid.substr(-4)) {
                		control.showPopup("信息校验未通过，请确认后再次尝试", 2000);
                		return;
                	}
                	if($rootScope.isAuthFace()){
                        $scope.alert_applicant_info = true;
                    } else {

                        if(!$rootScope.certUnderwayInfo.isFree){
                            paymentApply();
                        }else{
                            //生成业务单
                            $scope.alert_applicant_info = false;
                            $scope.acShowAuthConfirm = false;

                            $rootScope.certApplyNoticeParent = 'userNotice';
                            nav.navigate('uploadApplyMaterials')
                            var eventCounter = new Object();
                            eventCounter.page = "材料领证-申领须知页面-在线办理业务";
                            MobclickAgent.onEventWithParameters("materialCertificationOnlineBusinessProcessingEvent", eventCounter);

                        }
                    }
                	$scope.showCheckUniscid = false;
                }
                $scope.hideCheckUniscid = function() {
                    $scope.showCheckUniscid = false;
                    // $scope.goBack();
                }
                $scope.getUniscid = function(i) {
                	if ($rootScope.applyCertInfo.uniscid.length > i) {
                		return $rootScope.applyCertInfo.uniscid.substring(i, i + 1);
                	} else {
                		return ''
                	}
                }
            }

            $scope.acCloseClick = function() {
                $scope.alert_applicant_info = false;
                $scope.acShowAuthConfirm = false;
                $scope.goBack();
            }
            // 人脸再试一次
             $scope.faceAuthTryAgain = function(){
                 $scope.acShowAuthConfirm = true;
                 $rootScope.closeFaceAuthFail();
             }
            $scope.next = function (selectType) {
                if (!$scope.isAgreeApplyAgreement) {
                    control.showPopup("请阅读并同意协议", 2000);
                    return;
                }
                confirmOrgCode();
//                $rootScope.certApplyNoticeParent = 'userNotice';
//                nav.navigate('uploadApplyMaterials')
//                var eventCounter = new Object();
//                eventCounter.page = "材料领证-申领须知页面-在线办理业务";
//                MobclickAgent.onEventWithParameters("materialCertificationOnlineBusinessProcessingEvent", eventCounter);
            }

            $scope.navigate = function (state) {
                nav.go(state);
            };
            $scope.goBack = function () {
                nav.goBack();
            };


            $scope.closeApplicantInfoAlert = function() {
                $rootScope.goBackV2()
            }
            $scope.startLiveDetectionClick = function() {
                $scope.acShowAuthConfirm = true
                $scope.alert_applicant_info = false
            }
            $scope.acIsAgreeApplyAgreement = false;
            $scope.acAgree = function() {
                $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
            }
            $scope.acNext = function() {
                if (!$scope.acIsAgreeApplyAgreement) {
                    control.showPopup("请确认同意《人脸认证功能协议》", 2000);
                    return;
                }
                startLiveDetection();
            }
            var startLiveDetection = function() {
                verifyIdentity.startLiveDetection($scope.autoApplyInfo.IDCardName, $scope.autoApplyInfo.IDCardNumber, $rootScope.loginInfo.userId,liveDetectionResult);
            };
            $scope.acAgreement = function() {
                var url = window.currentUrl + '/app/ezt/faceAgreement.html';
                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                cordova.InAppBrowser.open(url, '_blank', operation);
            }
            //        $rootScope.photoData = '';
            //        nav.navigate('userNotice')
            // 验证身份和活体信息是否匹配
            var liveDetectionResult = function(res) {
                $scope.$apply(function() {
                    if (res.rslt == 'success') {
                        $rootScope.photoData = res.photoData;
                        resultFunc(res.data)
                    }else{
                        authLivingFailEvent();
                    }
                });
            };
            var resultFunc = function(data) {
//                $scope.$apply(function() {
                    if (data.result == 'fail') {
                        if (!$rootScope.isOpenFaceAuthFail()) {
                            control.showPopup(data.authResultMsg, 2000);
                        }
                    }
                    if (data.result == 'success') {
                        $rootScope.setAuthSuccessTime();
                        if($rootScope.certUnderwayInfo.businessCode === 'P012' &&!$rootScope.certUnderwayInfo.isFree){
                             paymentApply();
                        }else{
                             //生成业务单
                             $scope.alert_applicant_info = false;
                             $scope.acShowAuthConfirm = false;
                             // 上传材料
                             $rootScope.certApplyNoticeParent = 'userNotice';
                             nav.navigate('uploadApplyMaterials')
                             var eventCounter = new Object();
                             eventCounter.page = "材料领证-申领须知页面-在线办理业务";
                             MobclickAgent.onEventWithParameters("materialCertificationOnlineBusinessProcessingEvent", eventCounter);

                        }
                    }
//                });
            }

            var authLivingFailEvent = function() {
                var eventCounter = new Object();
                eventCounter.page = "活体识别失败";
                MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
            }

             // 付费提醒
             var paymentApply = function() {
                $rootScope.paymentWay = '0'//申领方式
             	$scope.okFunc = function() {
                    /**
                     * 判断是否收费控制生成业务单流程
                     **/
                     if ($rootScope.certUnderwayInfo.businessCode === 'P012' && !$rootScope.certUnderwayInfo.isFree) {
                          nav.navigate('autoApplyInvoice');
                          return;
                     }
             		$scope.showTimeConfirm = false;
                    // 上传材料
                    $rootScope.certApplyNoticeParent = 'userNotice';
                    nav.navigate('uploadApplyMaterials')
                    var eventCounter = new Object();
                    eventCounter.page = "材料领证-申领须知页面-在线办理业务";
                    MobclickAgent.onEventWithParameters("materialCertificationOnlineBusinessProcessingEvent", eventCounter);

             	}
             	$scope.cancelClick2 = function() {
             		$scope.showTimeConfirm = false;
             	}
             	$scope.showTimeConfirm = true;
             	return;
             }
              //区分省内省外协议示例
              if($rootScope.certUnderwayInfo.entProvince=='FZJS'){
                    //省外示例
                    $scope.showProvinceimg1 = 'img/pic-example7.jpg';
                    $scope.showProvinceimg2 = 'img/pic-example6.jpg';

              }else{
                   //省内示例
                    $scope.showProvinceimg1 = 'img/pic-example5.jpg';
                    $scope.showProvinceimg2 = 'img/pic-example6.jpg';
              }
              $scope.slideIndex = '1/2';
              $scope.slideChanged = function (index) {
                if(index==0){
                    $scope.slideIndex = '1/2';
                }else{
                    $scope.slideIndex = '2/2';
                }
              };
             $scope.showPicStatus = '0';
             $scope.showPicClick = function(status) {
                $scope.showPicStatus = status;
             }
             $scope.picClick = function() {
                $scope.showPicStatus = '0';
                $scope.$apply();
             }
             if($scope.orderNo != null&&$scope.orderNo != ''&&$scope.orderNo != undefined){
                // 材料领证付款完后根据业务单上传资料
                $rootScope.autoApplyInfo.orderNo = $scope.orderNo;

                $rootScope.certApplyNoticeParent = 'userNotice';
                nav.navigate('uploadApplyMaterials')
                var eventCounter = new Object();
                eventCounter.page = "材料领证-申领须知页面-在线办理业务";
                MobclickAgent.onEventWithParameters("materialCertificationOnlineBusinessProcessingEvent", eventCounter);

             }

        }]);
})();
