(function () {
    "use strict"
    angular.module('starter')
        .controller('certManage', ['$rootScope', '$scope', '$ionicLoading', '$ionicActionSheet', 'nav', 'control', 'nativeHelper', 'validate', 'utility', '$filter', '$timeout', 'url','md5', 'requestWrapper','localStorage','$state','$stateParams','verifyIdentity','downloadLogic',
            function ($rootScope, $scope, $ionicLoading, $ionicActionSheet, nav, control,
                nativeHelper, validate, utility, $filter, $timeout, urlFct,md5,requestWrapper,localStorage,$state,$stateParams,verifyIdentity,downloadLogic) {
                $rootScope.changeCertPasswordInfo = { oldPwd: '', newPwd: '', verifyPwd: '' };
                $rootScope.resetCertPasswordInfo = { tel: '', authCode: '', newPwd: '' };
                $rootScope.deleteCertInfo = { password: '' };
                $scope.searchInfo = { key: '' };
                $rootScope.certApplyNoticeParent = 'certManage';
                $scope.isFirstLoad = true;
                $scope.showLocalCertList = [];
                $scope.AllCertList = [];// 本地证书和授权单业务单合并
                $scope.isCertChangeEntry = false; // 是否从首页证书变更入口进去
                //使用证书时，忘记密码跳转证书页删除证书，参数用户过滤列表，再此初始化该参数
                $rootScope.deleteCertSnfromPopup='';
                $rootScope.homeCertShowUpdatePicAlert = false;// 华测证书下载需要更新资源的弹框开关

                // 延期证书
                $scope.delayCertList = [];
                // 变更证书
                $scope.changeCertList = [];
                $scope.changeCertListV2 = [];
                // 即将到期证书
                $scope.invalidCertList = [];
                // 有效证书
                $scope.effectiveCertList = [];

                $scope.tabIndex="";
                $scope.waitDownCertByOrderAndAuthRecord=[];
                // 首页跳转 显示即将过期证书
                if ($rootScope.showDelayCert) {
                      $rootScope.showDelayCert = false;
                      $rootScope.showChangeCert = false;
                      $scope.tabIndex="1";
                } else if ($rootScope.showChangeCert) {  // 首页跳转 显示变更证书
                      $rootScope.showDelayCert = false;
                      $rootScope.showChangeCert = false;
                      $scope.tabIndex="2";
                }

                $rootScope.updatePictures = {
                    businessLicensePic: '',
                    IDCardFrontPic: '',
                    IDCardBackPic: '',
                    authorizationPic: '',
                    uploadFrom: ''
                }

                var isScroll = function () {
                    var ele = angular.element(document.querySelector('ion-content'));
                    var changeEle = angular.element(document.querySelector('ion-floating-button'));
                    var timer;
                    ele.on('touchmove', function () {
                        if (timer && timer.$$state.status != 2) {
                            $timeout.cancel(timer)
                        }
                        changeEle.css('visibility', 'hidden');
                    })
                    ele.on('touchend', function () {
                        timer = $timeout(function () {
                            changeEle.css('visibility', 'visible');
                            $timeout.cancel(timer)
                        }, 300)
                    })
                }
                isScroll()
                var getCertValidityV2 = function(operaType) {
                   if(operaType == "modify"){//变更
                        var eventCounter = new Object();
                        eventCounter.page = "V2接口变更证书校验";
                        MobclickAgent.onEventWithParameters("CertValidityV2ModifyInterface", eventCounter);
                   }else{
                        var eventCounter = new Object();
                        eventCounter.page = "V2接口全部证书校验";
                        MobclickAgent.onEventWithParameters("CertValidityV2AllInterface", eventCounter);
                   }
                    var certSnList = [];
                    // 变更 第一次是否从首页证书变更入口  因为这个时候还没有有效证书  所以非第一次切换变更传本地有效证书
                    if(operaType == "modify"&&!$scope.isCertChangeEntry){
                        $scope.effectiveCertList.forEach(function (v) {
                            certSnList.push(v.serialNum);
                        });
                        $scope.changeCertList.forEach(function (v) {
                            certSnList.push(v.serialNum);
                        });
                        $scope.delayCertList.forEach(function (v) {
                            certSnList.push(v.serialNum);
                        });
                    }else{//非变更
                        $rootScope.localCertList.forEach(function(v) {
                            certSnList.push(v.serialNum);
                        });
                    }
                    control.showLoading();
                    var params = [certSnList,operaType];
                    var successFunc = function(result) {
                        if (result == null || angular.equals({},result)) {
                            control.hideLoading();
                            control.showPopup('服务出错啦', 3000);
                            return;
                        };

                        if (result.success) {
                            if(operaType == "modify"){//变更
                                $rootScope.changeCertNum = 0;// 变更证书数量
                                $scope.showLocalCertList=[];
                                $scope.changeCertListV2 = [];
                            }else{
                                $scope.showLocalCertList=[];
                                $rootScope.delayCertNum = 0;// 延期证书数量
                                $rootScope.changeCertNum = 0;// 变更证书数量
                                $scope.AllCertList = [];// 本地证书和授权单业务单合并
                                // 延期证书
                                $scope.delayCertList = [];
                                // 变更证书
                                $scope.changeCertList = [];
                                // 失效证书
                                $scope.invalidCertList = [];
                                // 有效证书
                                $scope.effectiveCertList = [];

                            }
                            result.value.forEach(function(c) {
                                $rootScope.localCertList.forEach(function(l) {
                                    if (l.serialNum == c.certSn) {
                                        l.isValid = c.valid;
                                        l.operation = c.operation;
                                        l.canPostpone = c.canPostpone;
                                        l.canModify = c.canModify;
                                        l.reason = c.reason;
                                        if (typeof c.category != 'undefined') {
                                            l.category = c.category;
                                        };
                                        if (typeof c.categoryBh != 'undefined') {
                                            l.categoryBh = c.categoryBh;
                                        };
                                        if (typeof c.yearSerEnd != 'undefined') {
                                            l.yearSerEnd = c.yearSerEnd;
                                        };
                                        if (typeof c.annueeFee != 'undefined') {
                                            l.annueeFee = c.annueeFee;
                                        };
                                        l.corpid = c.corpid;//必须替换，使用校验接口的corpid

                                        l.existAnnueeFee = c.existAnnueeFee;
                                        l.refuseReason = c.refuseReason;

                                        // 区分有效证书和失效证书
                                        if (l.isValid) {
                                            l.certTipStatus = c.certTipStatus;
                                            // certTipStatus 0过期 1有效,2即将过期 3变更 4 待安装
                                            if(operaType == "modify"){//变更
                                                if(l.certTipStatus=='3'){//变更
                                                    $rootScope.changeCertNum++;
                                                    $scope.changeCertListV2.unshift(l);
                                                }
                                            }else{
                                                if(l.certTipStatus=='0'||l.certTipStatus=='2'){
                                                    $rootScope.delayCertNum++;
                                                    $scope.delayCertList.unshift(l);
                                                }else if(l.certTipStatus=='3'){
                                                    $rootScope.changeCertNum++;
                                                    $scope.changeCertList.unshift(l);
                                                }else if(l.certTipStatus=='1'){
                                                    $scope.effectiveCertList.unshift(l);
                                                }
                                            }
                                        } else {
                                             //V2.9.8新增失效证书区分证书冻结 certFrozen=1 冻结
                                             if (typeof c.certFrozen != 'undefined') {
                                                  l.certFrozen = c.certFrozen;
                                             };
                                            $scope.invalidCertList.unshift(l);
                                        }
                                    }
                                });
                            });
                            // 证书变更tab
                            if(operaType == "modify"){//变更
                                control.hideLoading();
                                $scope.showLocalCertList = $scope.changeCertListV2;
                            }else{
                                // 合并本地证书和授权单业务单
                                var tempCertList = [];
                                $scope.invalidCertList.forEach(function (v) {
                                    tempCertList.unshift(v);
                                });
                                $scope.effectiveCertList.forEach(function (v) {
                                    tempCertList.unshift(v);
                                });
                                $scope.changeCertList.forEach(function (v) {
                                    tempCertList.unshift(v);
                                });
                                $scope.delayCertList.forEach(function (v) {
                                    tempCertList.unshift(v);
                                });
                                $rootScope.localCertList = tempCertList;
    //                            $rootScope.localCertList.sort((a, b) => b.isValid - a.isValid);
                                if (JSON.stringify($scope.showLocalCertList) == '{}') {
                                     $scope.showLocalCertList = [];
                                }

                                // 首页跳转 显示即延期证书
                                if ($scope.tabIndex=="1") {
                                    $scope.showLocalCertList = $scope.delayCertList;
                                }

//                                else if ($scope.tabIndex=="2") {  // 首页跳转 显示变更证书
//                                    $scope.showLocalCertList = $scope.changeCertList;
//                                }
                            }
                            if(operaType != "modify"){
                                getWaitDownCertByOrderAndAuthRecord();
                            }
                        } else {
                            control.showPopup(result.msg, 3000);
                            if(operaType != "modify"){
                                getWaitDownCertByOrderAndAuthRecord();
                            }else{
                               control.hideLoading();
                            }
                        }
                    };
                    var failFunc = function(error) {
                        control.hideLoading();
                        control.showPopup(error.msg, 2000);
                        if(operaType != "modify"){
                            getWaitDownCertByOrderAndAuthRecord();
                        }else{
                            control.hideLoading();
                        }
                    };
                    nativeHelper.getCertValidityV2({
                        data: params,
                        success: successFunc,
                        fail: failFunc
                    });
                };
                // 获取待授权的业务单和授权单
                var getWaitDownCertByOrderAndAuthRecord = function () {
                    var params = [
                        $rootScope.loginInfo.accountId,
                        $rootScope.loginInfo.mobile,
                        $rootScope.loginInfo.idCard,
                        $scope.searchInfo.key
                    ];

                    var successFunc = function (result) {
                        control.hideLoading();
                        $scope.isFirstLoad = false;
                        if (result == null || angular.equals({},result)) {
                            control.showPopup('本地证书校验失败', 3000);
                            return;
                        };
                        if (result.success) {
                            $scope.allCertList = $rootScope.localCertList;
                            if (result.value != null && !angular.equals({},result)) {
                                result.value.forEach(function(d) {
                                    var isValidHaveCert = false;// 是否有有效证书
                                    d.sourceType = "certManage";
                                    // 授权单新领 不过滤显示
                                    if(d.downloadType == '1'&&(d.netType == '6'||d.netType == '7')){
                                        d.certTipStatus = "4";
                                        $scope.allCertList.unshift(d);
                                    }else{
                                        $rootScope.localCertList.forEach(function(l) {
                                            console.log('result corpid:' + d.corpid)
                                            console.log('localCertList corpid:' + l.corpid)
                                            if(d.corpid == l.corpid&&l.isValid){
                                                isValidHaveCert = true
                                            }else if(d.corpid == l.corpid&&!l.isValid){
                                                $scope.allCertList.filter(f => f.corpid !== l.corpid);
                                            }
                                        });
                                        // 无有效证书
                                        if(!isValidHaveCert){
                                            d.certTipStatus = "4";
                                            $scope.allCertList.unshift(d);
                                        }
                                    }
                                });
                                if($scope.tabIndex==""){
                                     $scope.showLocalCertList = $scope.allCertList
                                     console.log('showLocalCertList:' + JSON.stringify($scope.showLocalCertList))
                                }
                                 // 业务管理跳转 获取信用码执行过滤
                                 if ($stateParams.certManageSearchKey) {
                                     $scope.searchInfo.key = $stateParams.certManageSearchKey;
                                     $scope.showLocalCertList=$scope.showLocalCertList.filter(f => f.oldCertSn == $stateParams.certManageSearchKey || f.serialNum == $stateParams.certManageSearchKey);
                                 }
                                 // 输入密码弹窗跳转 获取信用码执行过滤
                                 if ($rootScope.deleteCertSnfromPopup) {
                                     $scope.searchInfo.key = $rootScope.deleteCertSnfromPopup;
                                     $rootScope.deleteCertSnfromPopup= "";
                                     $scope.showLocalCertList=$scope.showLocalCertList.filter(f => f.oldCertSn == $stateParams.certManageSearchKey || f.serialNum == $stateParams.certManageSearchKey);
                                 }
                            }
                        }
                        if(!result.success){
                          $scope.showLocalCertList = $scope.localCertList
                        }
                    }
                    var failFunc = function (e) {
                        $scope.isFirstLoad = false;
                        $scope.showLocalCertList = $scope.localCertList
                    };
                    nativeHelper.getWaitDownCertByOrderAndAuthRecord({ data: params, success: successFunc, fail: failFunc });
                }

                var getCertList = function () {
                    var params = [$rootScope.loginInfo.accountId];
                    var successFunc = function (result) {
                        $rootScope.localCertList = result;
                        $scope.hasCert = $rootScope.localCertList.length > 0;
                        console.log('cert :'+JSON.stringify($rootScope.localCertList));
                        if ($rootScope.localCertList.length > 0){
                            if($scope.tabIndex == "2"){
                                $scope.isCertChangeEntry = true;
                                getCertValidityV2("modify");
                            }else{
                                getCertValidityV2("all");
                            }
                        }else{
                            // 首页跳转 延期证书
                            if ($scope.tabIndex=="1") {
                                 $scope.showLocalCertList = $scope.delayCertList;
                            } else if ($scope.tabIndex=="2") {  // 首页跳转 显示变更证书
                                 $scope.showLocalCertList = $scope.changeCertList;
                            }
                            $scope.showLocalCertList=[];
                            getWaitDownCertByOrderAndAuthRecord();
                        }
                    }
                    var failFunc = function (e) {
                        getWaitDownCertByOrderAndAuthRecord();
                    };
                    nativeHelper.getLocalCertList({ data: params, success: successFunc, fail: failFunc });
                }

                getCertList();

                var deleteCert = function (curCert) {
                     control.showLoading();
                     var params = [curCert.containerName,curCert.serialNum,curCert.SDKVersion];
                     var successFunc = function (result) {
                         control.hideLoading();
                         if (result == null || angular.equals({}, result)) {
                             control.showPopup('服务出错啦', 3000);
                             return;
                         };
                         if (result.indexOf('成功') > 0) {
                             control.showPopup(result, 2000);
                             getCertList();
                             $rootScope.isGetHomeCertApi = true;
                         }else{
                             control.showPopup(result, 2000);
                         }
                     }
                     var failFunc = function (error) {
                         control.hideLoading();
                     };
                     nativeHelper.deleteCert({ data: params, success: successFunc, fail: failFunc });
                };

                var changeCertPwd = function (curCert) {
                    if (curCert.password == $rootScope.changeCertPasswordInfo.oldPwd) {
                        if (!validate.certPassword($rootScope.changeCertPasswordInfo.newPwd) || !validate.certPassword($rootScope.changeCertPasswordInfo.verifyPwd)) {
                            control.showPopup('请输入6位数字密码', 2000);
                            return;
                        }
                        if ($rootScope.changeCertPasswordInfo.newPwd == $rootScope.changeCertPasswordInfo.verifyPwd) {
                            control.showLoading();
                           var params = [curCert.containerName, $rootScope.changeCertPasswordInfo.oldPwd, $rootScope.changeCertPasswordInfo.newPwd,curCert.serialNum,curCert.SDKVersion];
                            var successFunc = function (result) {
                                control.hideLoading();
                                if (result == null || angular.equals({}, result)) {
                                    return;
                                }
                                if (result.indexOf('成功') > 0) {
                                   //修改密码成功  关闭弹窗  初始化相关参数
                                   $scope.changePasswordShow = false;
                                   $scope.changePasswordShow = false;
                                   $scope.eyeStatusPassword = 'password';
                                   $scope.eyeStatusVerifyPassword = 'password';
                                   $rootScope.changeCertPasswordInfo.oldPwd="";
                                   $rootScope.changeCertPasswordInfo.newPwd="";
                                   $rootScope.changeCertPasswordInfo.verifyPwd="";
                                    control.showPopup('密码修改成功', 2000);
                                    getCertList();
                                } else {
                                    control.showPopup(result, 2000);
                                }
                            }
                            var failFunc = function (error) {
                                control.hideLoading();
                            };
                            nativeHelper.changeCertPwd({ data: params, success: successFunc, fail: failFunc });
                        }
                        else {
                            control.showPopup('您输入的两次密码不相同', 2000);
                        }
                    }
                    else {
                        control.showPopup('旧密码输入错误', 2000);
                    }
                };

                var resetCertPwd = function (curCert) {
                    control.showLoading();
                    var params = [curCert.containerName, $rootScope.deleteCertInfo.password];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        };

                        if (result.indexOf('成功') > 0) {
                            $rootScope.localCertList.forEach(function (v) {
                                v.data.forEach(function (item) {
                                    if (item.serialNum == curCert.serialNum) {
                                        var index = v.data.indexOf(item);
                                        v.data.splice(index, 1);
                                    }
                                })
                            });
                        }
                        control.showPopup(result, 2000);
                    }

                    var failFunc = function (error) {

                    };

                    nativeHelper.resetCertPwd({ data: params, success: successFunc, fail: failFunc });
                }

                $scope.selectTab = function (selectIsValid) {

                    if($scope.tabIndex == selectIsValid){
                        return;
                    }
                     $scope.tabIndex = selectIsValid;
                    if($scope.isCertChangeEntry){
                        $scope.isCertChangeEntry = false;
                        getCertValidityV2("all");
                        return;
                    }

                     if(selectIsValid == "1"){
                        //延期证书
                        searchCert();
                     }else if(selectIsValid == "2"){
                        //变更证书
                        getCertValidityV2("modify");
                    }else if(selectIsValid == "3"){
                        //失效证书
                        searchCert();
                    }else{
                        //全部
                        searchCert();
                    }
                }

                $scope.copyText =function(text) {
                    var successFunc = function() {
                        control.showPopup('复制成功', 2000);
                    }

                    var failFunc = function() {
                        control.showPopup('复制失败', 2000);
                    }

                    nativeHelper.socialAgent({
                         data: [text, 1,''],
                        success: successFunc,
                        fail: failFunc
                    });
                }

                /**
                *证书使用
                **/
                $scope.certUse= function(currentCert){
                    var eventCounter = new Object();
                    eventCounter.page = "我的证书-证书详情";
                    MobclickAgent.onEventWithParameters("certManageCertUseEvent", eventCounter);
                    $rootScope.curManagedCert = currentCert;
                    nav.navigate('certDetail');
                }

                $scope.changePasswordTextShow=true;
                $scope.changeCertTextShow=true;
                $scope.stampManageTextShow=false;
                //证书管理操作
                $scope.certManage = function (entName, curCert, orgCode) {
                $scope.curCert=curCert;
                    if (curCert.isValid) {
                        $scope.changePasswordTextShow=true;
                        $scope.changeCertTextShow=true;
                        if ('省法人数字证书' == curCert.category) {
                            $scope.stampManageTextShow=true;
                        }else{
                            $scope.stampManageTextShow=false;
                        }
                    } else if (!curCert.isValid) {
                       $scope.changePasswordTextShow=false;
                       $scope.changeCertTextShow=false;
                       $scope.stampManageTextShow=false;
                    };


                    $scope.playMoreShow = true;
                };
                $scope.addCert = function () {
                    $rootScope.subjectQueryRoute = 'certManage';
                    $rootScope.applyCertType = 0;
                    nav.navigate('applyCertSearchV2');
                }
                //续费
                var navCertDelay = function (curCert) {
                    if (2 == curCert.existAnnueeFee) {
                        control.showPopup(curCert.refuseReason, 3000);
                        return;
                    }
                    $rootScope.certAnnualFeeInfo = {
                        entName: curCert.entName,
                        uniscid: curCert.orgCode,
                        operator: '',
                        cardId: '',
                        parentPage: 'certManage',
                        corpid: curCert.corpid,
                    };
                    nav.navigate('confirmPayInfo');
                }

                /**
                 * 搜索证书
                 */
                var searchCert = function () {
                    if($scope.tabIndex == "1"){
                        //延期证书
                        $scope.showLocalCertList = $filter('filter')($scope.delayCertList, $scope.searchInfo.key);
                    }else if($scope.tabIndex == "2"){
                        //变更证书
                        $scope.showLocalCertList = $filter('filter')($scope.changeCertList, $scope.searchInfo.key);
                    }else if($scope.tabIndex == "3"){
                        //失效证书
                        $scope.showLocalCertList = $filter('filter')($scope.invalidCertList, $scope.searchInfo.key);

                    }else{
                        //全部
                        $scope.showLocalCertList = $filter('filter')($scope.allCertList, $scope.searchInfo.key);
                    }
                    //关闭软键盘
                    cordova.plugins.Keyboard.close();
//
                }

                 $("#searchMcKeyword").keypress(function(e){
                      // 搜索关键字
                        if(cordova.platformId === 'ios'){
                            if(e.keyCode === 13) {
                                $scope.$apply(function(){
                                    searchCert();
                                });
                            }
                         }else{
                            if(e.keyCode === 13) {
                                $scope.$apply(function(){
                                    searchCert();
                                });
                            }
                         }
                    })

                // 印章管理
                $scope.stampManage = function(curCert) {
                    var certBase64 = utility.URLEncode(curCert.certContent);
                    var url = urlFct.generate('', 'stampUrl') + 'tyyz/zlb/company/sealmanage/sealImgList?certBase64=' + certBase64;
                    console.log('stampManage' + url);
                    var operation = 'location=no,toolbartranslucent=no,toolbar=yes,toolbarcolor=#ffffff,clearcache=yes,clearsessioncache=yes,closebuttoncolor=#000000,hidenavigationbuttons=no,toolbarposition=top,closebuttoncaption=<,iscustomnav=no,customertitle=印章管理';
                    if (cordova.platformId === 'android') {
                        operation = 'hidenavigationbuttons=no,leftbackclose=yes,location=no,toolbar=yes,toolbarposition=top,customertitle=印章管理';
                    }
                    cordova.InAppBrowser.open(url, '_blank', operation);
                }

                //查询年报状态
                $scope.checkYearReportStatus= function (curCert) {
                    var eventCounter = new Object();
                    eventCounter.page = "我的证书-年报查询";
                    MobclickAgent.onEventWithParameters("checkYearReportStatusInterface", eventCounter);
                    control.showLoading();
                    var params = [curCert.certTipStatus=='4'?'':curCert.serialNum,curCert.corpid];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        };

                        if (result.success) {
                            //  $scope.reportStatus=result.value;
                            control.showPopup(result.value.text, 2000);
                        }else
                            control.showPopup(result.msg, 2000);
                    }

                    var failFunc = function (error) {
                        control.showPopup(error.msg, 2000);
                    };

                    nativeHelper.getYearReportStatus({ data: params, success: successFunc, fail: failFunc });
                }

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };



                  $scope.getBlur = function(id) {
                       console.log(id);
                       var ele = document.getElementById(id);
                       ele.className = ele.className.replace(' border-red','')
                       ele.className = ele.className.replace('border-red',' ');
                   }
                  $scope.getFocus = function(id){
                         var ele = document.getElementById(id);
                         ele.className +=  " border-red";
                  }
                  //修改密码弹窗逻辑控制
                  $scope.changePasswordShow = false;
                  $scope.eyeStatusPassword = 'password';
                  $scope.eyeStatusVerifyPassword = 'password';
                  $scope.eyeClickPassword = function(){
                        if($scope.eyeStatusPassword == 'password'){
                            $scope.eyeStatusPassword = 'text';
                        }else{
                            $scope.eyeStatusPassword = 'password';
                            }
                             }
                  $scope.eyeClickVerifyPassword = function(){
                        if($scope.eyeStatusVerifyPassword == 'password'){
                             $scope.eyeStatusVerifyPassword = 'text';
                         }else{
                             $scope.eyeStatusVerifyPassword = 'password';
                            }
                             }
                   //关闭修改密码弹窗，初始化修改密码相关参数
                  $scope.cancelChangePassword = function () {
                    $scope.changePasswordShow = false;
                    $scope.eyeStatusPassword = 'password';
                    $scope.eyeStatusVerifyPassword = 'password';
                    $rootScope.changeCertPasswordInfo.oldPwd="";
                    $rootScope.changeCertPasswordInfo.newPwd="";
                    $rootScope.changeCertPasswordInfo.verifyPwd="";
                   }
                  $scope.commitChangePassword = function () {
                      changeCertPwd($scope.curCert);
                   }

                   //更多操作弹框逻辑控制
                  $scope.playMoreShow = false;
                  $scope.playChangePassword = function () {
                      $scope.playMoreShow = false;
                      if ($scope.curCert.SDKVersion !== "V2") {
                          hideSheet();
                          control.showConfirm4('html/home/SDKVersionAlert.html', "特别提醒",
                          function() {
                              $scope.navigate("businessManage");
                              return;
                          },
                          function() {},
                          "取消", "去业务管理", 'cusClassTbtx');
                          return;
                      }
                      $rootScope.changeCertPasswordInfo = {
                          oldPwd: '',
                          newPwd: '',
                          verifyPwd: ''
                      };
                      $scope.changePasswordShow = true;
                    }
                  $scope.playdeleteCert = function () {
                      $scope.playMoreShow = false;
                       if ($scope.curCert.SDKVersion !== "V2") {
                           hideSheet();
                           control.showConfirm4('html/home/SDKVersionAlert.html', "特别提醒",
                           function() {
                               $scope.navigate("businessManage");
                               return;
                           },
                           function() {},
                                "取消", "去业务管理", 'cusClassTbtx');
                                return;
                           }
                       $rootScope.deleteCertInfo = {
                           password: '',
                       };
                       control.showCustomPopup('html/certManage/popupDeleteCert.html', '', '取消', '确认', 'popup-btn-default', 'popup-btn-light', function () {
                                return;
                       }, function () {
                               deleteCert($scope.curCert);
                       });

                     }

                  $scope.playYzManage = function () {
                        $scope.playMoreShow = false;
                        $scope.stampManage($scope.curCert);
                     }
                  $scope.playCancel = function () {
                         $scope.playMoreShow = false;
                     }

                var orderNoData; // 下载证书的订单信息
                //证书证书
                $scope.createBusinessOrder = function (item) {
                    //V2.9.8判断证书是否被冻结  certFrozen==1 冻结
                    if(item.certFrozen=='1'){
                       $scope.showFrozenTip=true;
                       return;
                    }
                    var eventCounter = new Object();
                    eventCounter.page = "我的证书-证书安装";
                    MobclickAgent.onEventWithParameters("certManageCertInstallEvent", eventCounter);
                    var orderNo = ""
                    var type = ""// 1 业务单  2 授权单
                    if(item.downloadType=='0'){// 业务单
                        type = "1";
                        orderNo = item.orderNo;
                    }else if(item.downloadType=='1'){
                        type = "2";
                        orderNo = item.authId;
                    }
                    if(validate.isStrEmpty(item.uniscid)){
                        downloadLogic.downloadCertLogic(item);
                        return;
                    }
                    orderNoData = item;
                    var params = [item.uniscid,type,orderNo];
                    var successFunc = function (result) {
                        if(result.success){

                             downloadLogic.downloadCertLogic(item);
                        }else{
                             control.hideLoading();
                             control.showPopup(result.msg, 2000);
                             setTimeout(function () {
                                 getCertList();
                             }, 2000);
                        }
                    }
                    var failFunc = function (e) {
                        control.hideLoading();
                        control.showPopup(e.msg, 2000);
                    };
                    nativeHelper.checkEntState({ data: params, success: successFunc, fail: failFunc });
                }

              
                // 华测证书需要更新资料
                $scope.doUploadPic = function () {
                    $rootScope.updatePictures = {
                        businessLicensePic: '',
                        IDCardFrontPic: '',
                        IDCardBackPic: '',
                        authorizationPic: '',
                        uploadFrom: '',
                        orderNo:'',
                    }
                    $rootScope.updatePictures.uploadFrom = 'certManage';
                    $rootScope.updatePictures.orderNo = orderNoData.orderNo;
                    //非个人 上传营业执照/身份证正反面
                    nav.navigate("uploadBusinessLicense");
                }
                //v2.9.8 新增冻结证书提示弹窗
                $scope.showFrozenTip=false;
                $scope.colseFrozenTip = function(){
                    $scope.showFrozenTip=false;
                }

            }]);
})();
