(function () {
    "use strict"
    angular.module('starter')
        .controller('searchEnterprise', ['$rootScope', '$scope', '$ionicLoading',
            '$filter', 'nav', 'control', 'localStorage',
            'nativeHelper', '$state','verifyIdentity', 'md5', 'utility','validate',
            function ($rootScope, $scope, $ionicLoading, $filter, nav,
                control, localStorage, nativeHelper, $state, verifyIdentity, md5, utility,validate ) {
                $scope.isloading = true;
                $scope.searchInfo = { key: '' }

                $scope.enterpriseInfoList = [];

                var getEnterpriseInfoList = function () {
                    if($scope.searchInfo.key==""){
                        $scope.$apply(function () {
                          $scope.isloading = true;
                          $scope.enterpriseInfoList = [];
                        });

                        return;
                    }
                    control.showLoading();

                    var params = [$scope.searchInfo.key];
                    var successFunc = function (result) {
                        control.hideLoading();
                        $scope.isloading = false;

                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        };
                        switch (result.success) {
                            case true:
                                $scope.$apply(function () {
                                    $scope.enterpriseInfoList = result.value;
                                });
                                break;
                            case false:
                                control.showPopup(result.msg, 2000);
                                break;
                        }
                    };

                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };
                    nativeHelper.getAlreadyApplyCertInfo({ data: params, success: successFunc, fail: failFunc });
                };

                 //监听输入框软键盘搜索按钮  触发搜索
                 $("#searchBmKeyword").keypress(function(e){
                    if(cordova.platformId === 'ios'){
                        if(e.keyCode === 13) {
                            getEnterpriseInfoList();
                            cordova.plugins.Keyboard.close();
                        }
                     }else{
                        if(e.keyCode === 13) {
                            getEnterpriseInfoList();
                         }
                       //关闭软键盘
                       cordova.plugins.Keyboard.close();
                     } 
                 })

                $scope.backBtn = function () {
                    nav.navigate('tab/home');
                };

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };
            }]);
})();
