﻿(function () {
    "use strict"
    angular.module('starter')
    .controller('account', ['$rootScope', '$scope', 'nav', 'localStorage', 'control', 'nativeHelper', function ($rootScope, $scope, nav, localStorage, control, nativeHelper) {
        // $scope.statusBarHeight = 44 + 30;

        $rootScope.loginInfo = localStorage.getObject('loginInfo');
        // console.log('account info: ' + JSON.stringify($rootScope.loginInfo))
        $rootScope.isLogin = false;
        if (JSON.stringify($rootScope.loginInfo) == '{}') {
            $rootScope.isLogin = false;
        } else {
            $rootScope.isLogin = true;
        }

        $scope.navToHelp = function () {
//            if (!cordova.InAppBrowser) { return; }
//            var operation = 'location=no,toolbartranslucent=no,toolbar=yes,toolbarcolor=#ffffff,clearcache=yes,clearsessioncache=yes,closebuttoncolor=#000000,hidenavigationbuttons=yes,toolbarposition=top,closebuttoncaption=<,iscustomnav=yes,title=' + '移动证书';
//            //这块安卓报错 点击进不去 故使用上面之前的可以正常访问
//            if(cordova.platformId === 'ios'){
//                operation = 'location=no,toolbartranslucent=no,toolbar=yes,toolbarcolor=#ffffff,clearcache=yes,clearsessioncache=yes,closebuttoncolor=#000000,hidenavigationbuttons=yes,toolbarposition=top,closebuttoncaption=,iscustomnav=yes,title=' + '使用帮助';
//            }
//
//            cordova.InAppBrowser.open(window.currentUrl + '/app/api/apphelp', '_blank', operation);

            nav.navigate('helpCenter');

        };






        $scope.openPush = '1';
        $scope.personalizationoPush = '1';
//        var pushObj = localStorage.getObject('openPush');
//        if (JSON.stringify(pushObj) == '{}') {
//            $scope.openPush = '0';
//        } else {
//            $scope.openPush = pushObj;
//        }

        var getAppMesConfig = function() {
            var params = [$rootScope.loginInfo.mobile];
            var successFunc = function (result) {
                $scope.$apply(function () {
                    if(result.success){
                        if(result.value.flag == '0'||result.value.flag == '1'){
                            $scope.openPush = result.value.flag
                        }else{
                            $scope.openPush = '1';
                        }
                        if(result.value.personalizationFlag == '0'||result.value.personalizationFlag == '1'){
                            $scope.personalizationoPush = result.value.personalizationFlag

                        }else{
                            $scope.personalizationoPush = '1';
                        }
                    }else{
                        if(result.msgType=='0002'){
                            $scope.openPush = '1';
                        }
                    }
                });
            }
            var failFunc = function (error) {}
            nativeHelper.getAppMesConfig({data: params, success: successFunc, fail: failFunc});
        }
         var doUpdateAppMesConfig = function(pushType) {
             var status = ''
             if(pushType=='1'){
                if($scope.openPush=='1'){
                    status = '0'
                }else{
                    status = '1'
                }
             }else{
                if($scope.personalizationoPush=='1'){
                    status = '0'
                }else{
                    status = '1'
                }
             }

             var params = [status,pushType];
             var successFunc = function (result) {
                 if(result.success){
                    $scope.$apply(function () {
                        if(pushType=='1'){
                            $scope.openPush = status;
                        }else {
                            $scope.personalizationoPush = status;
                        }
                    });
                 }
             }
             var failFunc = function (error) {}
             nativeHelper.doUpdateAppMesConfig({data: params, success: successFunc, fail: failFunc});
        }
        getAppMesConfig()
        $scope.pushClick = function() {
            doUpdateAppMesConfig('1');
        }
        $scope.personalizationoClick = function() {
            doUpdateAppMesConfig('2');
        }

        $scope.infoClick = function(type) {
            var host = window.currentUrl;
            var url = '';
            if ('personal' == type) {
                url = host + '/app/personal-information-collection.html';
            } else if ('third' == type) {
                url = host + '/app/third-party-information-sharing.html';
            }
            var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
            cordova.InAppBrowser.open(url, '_blank', operation);
        }

        $scope.permissionSet = function() {
           nav.navigate('permissionSettings');
        }

//        $scope.agreement = function(type) {
//            if (type === 'appagreement') {
//                var url = window.currentUrl + '/app/api/appagreement';
//            } else {
//                var url = window.currentUrl + '/app/api/appprivacy';
//            }
//            cordova.InAppBrowser.open(url, '_blank', operation);
//        }

        $scope.signOut = function () {
            var confirm = function () {
                $rootScope.isLogin = false;
                $rootScope.localCertList = [];
                $rootScope.authSuccessTime = null;
                localStorage.deleteItem('loginInfo');

                PushAgent.delAlias(function(){},$rootScope.loginInfo.userId,'userUniqueId')
                nav.navigate('signIn');

                if ('android' == cordova.platformId) {
                    var params = [$rootScope.loginInfo.mobile];
                    var successFunc = function (result) {}
                    var failFunc = function (error) {}
                    nativeHelper.signOut({data: params, success: successFunc, fail: failFunc});
                }
            };
            var cancel = function () { };

            control.showConfirm('确定要退出当前账号登录？', confirm, cancel);
        };

        $scope.aboutVersion = function () {
            nav.navigate("aboutVersion");
        }

        $scope.userAuth = function () {
            $rootScope.identityAuthRootPage = "tab/account";
           // 直接去实名  无需二次弹框
            $rootScope.faceAuth();
        }

        $scope.navigate = function (state) {
            nav.navigate(state);
        };
    }]);
})();