﻿(function () {
    "use strict"

    angular.module('starter')
    .filter('telDes', [function () {
        return function (value) {
            if(value == undefined || value == null || value == ''){
                return ''
            }
            
            if (value.length != 11) {
                return value;
            }
            if (!isNaN(parseFloat(value)) && isFinite(value)) {
                var str = value;
                let prefix = str.slice(0, 3);
                let suffix = str.slice(7)
                return prefix + "****" + suffix;
            }
            return value;
        };
    }]);
})();