﻿(function () {
    "use strict"
    angular.module('starter')
    .controller('aboutVersion', ['$rootScope', '$scope', 'nav','nativeHelper', function ($rootScope, $scope, nav,nativeHelper) {

        $scope.isHaveUpdate = false;
        $scope.url = "";
        var checkUpdate = function () {
            var params = [{ 'type': 'ios' }];
            var successFunc = function (result) {
                if (result == null || angular.equals({}, result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }
                if (result.success) {
                    var version = result.value.version;
                    $scope.url = result.value.url;
                    if(compareVersions(version,$rootScope.appVersion) > 0){
                      $scope.$apply(function () {
                         $scope.isHaveUpdate = true;
                      });
                    }
                }
                if (!result.success) {
                    control.showPopup(result.msg, 3000);
                }
            };

            var failFunc = function (result) {
                control.showPopup(result.msg, 3000);
            };

            nativeHelper.checkUpdateV2({
                data: params, success: successFunc, fail: failFunc
            });
        };
        checkUpdate();
        function compareVersions(v1, v2) {
          var parts1 = v1.split('.').map(Number);
          var parts2 = v2.split('.').map(Number);

          for (let i = 0; i < Math.max(parts1.length, parts2.length); i++) {
            var num1 = parts1[i] || 0;
            var num2 = parts2[i] || 0;

            if (num1 > num2) return 1;
            if (num1 < num2) return -1;
          }
          return 0;
        }

        $scope.toUpdate = function () {
           if($scope.isHaveUpdate){
                cordova.InAppBrowser.open($scope.url, '_system', 'location=no');
           }
        };
        $scope.navigate = function (state) {
            nav.navigate(state);
        };
    }]);
})();