(function () {
    "use strict"
    angular.module('starter')
    .controller('helpCenter', ['$rootScope', '$scope', 'nav', 'localStorage', 'control', 'utility','$ionicHistory','nativeHelper', function ($rootScope, $scope, nav, localStorage, control, utility,$ionicHistory, nativeHelper) {
        $scope.centerList = [];

        var getHelpCenterList = function () {
            control.showLoading();
            var params = [];
            var successFunc = function (result) {
                control.hideLoading();
                if (result == null || angular.equals({}, result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }
                if (result.code == 200) {
                    $scope.centerList = result.data;
                }else {
                    control.showPopup(result.message, 3000);
                }
            }
            var failFunc = function (result) {
                control.hideLoading();
                control.showPopup(result.message, 3000);
            };
            nativeHelper.getHelpCenterList({ data: params, success: successFunc, fail: failFunc });
        }
        getHelpCenterList();
        $scope.chooseCenter = function (item) {
            if (!cordova.InAppBrowser) { return; }
            var operation = 'location=no,toolbartranslucent=no,toolbar=yes,toolbarcolor=#ffffff,clearcache=yes,clearsessioncache=yes,closebuttoncolor=#000000,hidenavigationbuttons=yes,toolbarposition=top,closebuttoncaption=<,iscustomnav=yes,title=' + item.title;
            if(cordova.platformId === 'ios'){
                operation = 'location=no,toolbartranslucent=no,toolbar=yes,toolbarcolor=#ffffff,clearcache=yes,clearsessioncache=yes,closebuttoncolor=#000000,hidenavigationbuttons=yes,toolbarposition=top,closebuttoncaption=,iscustomnav=yes,title=' + item.title;
            }
            cordova.InAppBrowser.open(item.link, '_blank', operation);
        }
    }]);
})();
