(function () {
    "use strict"

    angular.module('starter')
    .controller('logOff', ['$rootScope', '$ionicPopup','$timeout', '$interval', '$scope', 'nav', 'control', 'localStorage', '$ionicHistory', 'requestWrapper', 'utility', 'md5','nativeHelper', function ($rootScope, $ionicPopup,   $timeout, $interval,$scope, nav, control, localStorage, $ionicHistory, requestWrapper, utility, md5,nativeHelper) {

        $scope.isAgree = false;
        $scope.agree=function(){
             $scope.isAgree=!$scope.isAgree;
        };
        $scope.shouldKnow=function(){
            var url = window.currentUrl + '/app/account-cancellation-notice.html';
            var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
            cordova.InAppBrowser.open(url, '_blank', operation);
        };
        $rootScope.btnConfirm = "确定注销";
        $rootScope.isShowConfirm10 = false;
        $scope.confirmLogoff=function(){
            if(!$scope.isAgree){
                  control.showPopup("请先阅读注销须知并同意", 2000);
                  return
             }
              $rootScope.secDown = 10;//倒计时设置
              $scope.stopTime = $interval($scope.getTimeDown, 1000);
             $rootScope.logoffPopup = $ionicPopup.show({
                    templateUrl: 'html/home/logoffPopup.html',
                    cssClass: 'popup-home-tips',
             });


//             var confirm = function () {
//                $scope.doRemoveAccount()
//                   localStorage.setObject('logOff', '1');
//
//                   $rootScope.localCertList = [];
//                   localStorage.deleteItem('loginInfo');
//                   PushAgent.delAlias(function(){},$rootScope.loginInfo.userId,'userUniqueId')
//                    $ionicHistory.clearHistory();
//                    nav.navigate('signIn');
//             };
//             var cancel = function () { };

//             var confirmPopup = $ionicPopup.confirm({
//                 title: "【特别提醒】您的账号符合注销条件，当您点击确认注销后，个人资料和历史信息都将无法找回，而且我们无法协助您重新恢复。确定要继续注销吗？",
//                 cssClass:'private-popup-confirm',
//                 cancelText: '取消',
//                 okText:   $scope.btnConfirm
//              });
//             confirmPopup.then(function (res) {
//                  if (res) {
//                    confirm();
//                  } else {
//                     cancel();
//                  }
//             });
//             control.showConfirm('【特别提醒】您的账号符合注销条件，当您点击确认注销后，个人资料和历史信息都将无法找回，而且我们无法协助您重新恢复。确定要继续注销吗？', confirm, cancel,"取消",$scope.btnConfirm);
         };
        $scope.doRemoveAccount = function(){
          var time = utility.getCurrentTime();
          var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
          var temp = {
               "userUniqueId": $rootScope.loginInfo.userId,
               "keyNo": $rootScope.uuid,
               "token": $rootScope.loginInfo.token
          }
          console.log("doRemoveAccount temp :" + JSON.stringify(temp));
          var reqParams = DES3.encrypt(hashdata.substring(0,24), 'ZJHUIXIN', angular.toJson(temp))

          var params = {
               "appid": $rootScope.appid,
               "time": time,
               "hashdata": hashdata,
               "reqParams": reqParams
          };
          console.log("doRemoveAccount params :" + JSON.stringify(params));
          control.showLoading();
          requestWrapper.doRemoveAccount({ data: params, refresh: true })
             .then(function (result) {
                 control.hideLoading();
                 if (result == null || angular.equals({}, result)) {
                     control.showPopup('服务出错啦', 2000);
                     return;
                 };

                 if (true == result.success) {
                        control.showPopup("注销成功", 2000);
                        $rootScope.logoffPopup.close()
                        localStorage.deleteItem('loginInfo');
                        $ionicHistory.clearHistory();
                        
                        
                        nav.navigate('signIn');
                 } else {
                     control.showPopup(result.msg, 2000);
                 }
          }).catch(function (e) {
               control.hideLoading();
               control.showPopup('网络请求失败：' + e.status, 2000);
          });
        };
         $scope.getTimeDown = function () {
             if ($rootScope.secDown >= 1) {
                $rootScope.isShowConfirm10 = false
                $rootScope.btnConfirm = "确定注销("+$rootScope.secDown+")"
                $rootScope.secDown--;
             }else{
                $rootScope.isShowConfirm10 = true
                $rootScope.btnConfirm = "确定注销"
                $interval.cancel($scope.stopTime);//取消循环
             }
        };
        $rootScope.confirmLogoffAgain = function () {
            if ($rootScope.isShowConfirm10){
                 $scope.doRemoveAccount()
            }
         };
         $rootScope.stopTimeDown = function () {
             $rootScope.btnConfirm = "确定注销"
             $interval.cancel($scope.stopTime);
             $rootScope.logoffPopup.close()
         };
        $scope.navigate = function (state) {
            nav.navigate(state);
        };
    }]);
})();