﻿(function () {
    "use strict"

    angular.module('starter')
    .controller('modifyPassword', ['$rootScope', '$scope', '$ionicLoading', 'nav', 'validate', 'control',
     'nativeHelper', function ($rootScope, $scope, $ionicLoading, nav, validate, control, nativeHelper) {
         $scope.modifyPasswordInfo = {
             oldPwd: '',
             newPwd: '',
             verifyPwd: ''
         };

         $scope.modifyPassword = function () {
            if (validate.loginPasswordReg($scope.modifyPasswordInfo.verifyPwd)) {
            // if (validate.loginPassword($scope.modifyPasswordInfo.verifyPwd)) {
                 if ($scope.modifyPasswordInfo.newPwd === $scope.modifyPasswordInfo.verifyPwd) {
                     control.showLoading();
                     var params = [$rootScope.loginInfo.mobile, $scope.modifyPasswordInfo.oldPwd, $scope.modifyPasswordInfo.newPwd];
                     var successFunc = function (result) {
                         control.hideLoading();
                         if (result == null || angular.equals({}, result)) {
                             control.showPopup('服务出错啦', 3000);
                             return;
                         }
                         switch (result.success) {
                             case true:
                                 control.showPopup('密码修改成功', 3000);
                                //  nav.navigate('account');
                                 nav.navigate('security');
                                 break;
                             case false:
                                 control.showPopup(result.msg, 3000);
                                 break;
                         }
                     }

                     var failFunc = function (error) {
                       control.hideLoading();
                     };

                     nativeHelper.modifyPassword({ data: params, success: successFunc, fail: failFunc });
                 }
                 else {
                     control.showPopup('您输入的两次密码不相同', 3000);
                 }
             }
             else {
                 control.showPopup('8-32位字符，至少包含数字、大小写字母及特殊符号中的三种', 2000);
             }
         }

         $scope.navigate = function (state) {
             nav.navigate(state);
         };

        $scope.btnColor = '0';
        $scope.showBtn = true;
        $scope.getBlur = function(id) {
            $scope.showBtn = true;
            var ele = document.getElementById(id);
            ele.className = ele.className.replace(' border-red','')
            ele.className = ele.className.replace('border-red',' ');

            if('' != $scope.modifyPasswordInfo.oldPwd && '' != $scope.modifyPasswordInfo.newPwd && '' != $scope.modifyPasswordInfo.verifyPwd){
                  $scope.btnColor = '1';
            }else{
                  $scope.btnColor = '0';
            }
        }
        $scope.getFocus = function(id){
             $scope.showBtn = false;
             var ele = document.getElementById(id);
             ele.className +=  " border-red";
        }

        $scope.eyeStatusPassword = 'password';
        $scope.eyeStatusVerifyPassword = 'password';
        $scope.eyeClickPassword = function(){
            if($scope.eyeStatusPassword == 'password'){
                 $scope.eyeStatusPassword = 'text';
               }else{
                  $scope.eyeStatusPassword = 'password';
            }
             }
        $scope.eyeClickVerifyPassword = function(){
            if($scope.eyeStatusVerifyPassword == 'password'){
                 $scope.eyeStatusVerifyPassword = 'text';
               }else{
                  $scope.eyeStatusVerifyPassword = 'password';
            }
             }



     }]);
})();