(function () {
    "use strict"
    angular.module('starter')
        .controller('confirmPayInfo', ['$rootScope', '$scope', 'nav'
            , 'control', 'nativeHelper', '$state', function ($rootScope, $scope, nav, control,
                nativeHelper, $state) {
                // 付款人信息确认页

                $scope.payInfo = { name: $rootScope.certAnnualFeeInfo.operator, cardId: $rootScope.certAnnualFeeInfo.operatorid }


                //生成业务单
                $scope.confirmPayInfo = function(name, cardId) {
                    if (null == name || "undefined" == typeof(name) || "" == name) {
                        control.showPopup("经办人姓名不能为空", 2000);
                        return;
                    }
                    if (null == cardId || "undefined" == typeof(cardId) || "" == cardId) {
                        control.showPopup("经办人身份证号码不能为空", 2000);
                        return;
                    }
                    if (cardId.length === 17) {
                        cardId += "X";
                    }
                    $rootScope.certAnnualFeeInfo.operator = name;
                    $rootScope.certAnnualFeeInfo.operatorid = cardId;
                    $rootScope.certAnnualFeeInfo.count = "1";
                    nav.navigate('annualFeeInvoice');
                }

                $scope.showBtn=true
                $scope.getBlur=function(){
                    $scope.showBtn=true;
                }
                $scope.getFocus=function(){
                    $scope.showBtn=false;
                }

                $scope.navigate = function (state) {
                    nav.navigate(state);
                };
            }]);
})();
