(function() {
    "use strict"
    angular.module('starter')
    .controller('applyAuthorizeComplete', ['$rootScope','$scope', 'nav', 'control', 'nativeHelper', '$stateParams', '$ionicPlatform', '$location', '$ionicHistory','$ionicModal','localStorage',
    function($rootScope,$scope, nav, control, nativeHelper, $stateParams, $ionicPlatform, $location, $ionicHistory,$ionicModal,localStorage) {
        //生物识别引导 
//        $ionicModal.fromTemplateUrl("html/downloadCert/deviceAuthGuide.html", {
//            scope:$scope,
//            animation:"slide-in-up"
//        }).then(function(modal) {
//            $scope.dialog = modal;
//            console.log('showDeviceAuthGuide');
//            if(($rootScope.openBiometryAndroid == '1'  && 'android' == cordova.platformId) || ($rootScope.openBiometryIOS == '1' && 'ios' == cordova.platformId)){
//                // let openVerify = localStorage.getObject('openVerify');//账号与安全中是否已开启
//                var authInfo = localStorage.getObject('authInfo' + $rootScope.loginInfo.accountId);
//                if($rootScope.isShowGuide && '1' != authInfo.openVerify){
//                    setTimeout(function () {
//                        $scope.dialog.show();
//                    }, 500);
//                }
//            }
//        });
        $scope.showNoAuth = false;
        // 法定代表人无法授权？
        $scope.noAuthClick = function(){
            $scope.showNoAuth = true;
        }

        // 进入材料在线领证
        $scope.materialApply = function(){
            nav.navigate('userNotice')
        }

//        $rootScope.openAuth = function(){
//            if ('0' != $rootScope.deviceAuthenticationType) {
//                // 如果指纹已打开且可用 用指纹校验
//                var successFunc = function(res) {
//                    console.log('success - ' + JSON.stringify(res));
//                    if (1 == res.code) {
//                        // localStorage.setObject('openVerify', '1');
//                        var authConfigInfo = {
//                            openVerify:'1',
//                            isFirstVerify:'0'
//                        }
//                        localStorage.setObject('authInfo' + $rootScope.loginInfo.accountId, authConfigInfo);
//
//                        var msg = '指纹验证设置成功';
//                        if($rootScope.deviceAuthenticationType == '1'){
//                            msg = '面容验证设置成功';
//                        }
//                        control.showPopup(msg, 2000);
//                        $scope.dialog.hide();
//
//                        // nav.navigate('home')
//                    } else if(2 == res.code) {
//                        //用户选择了取消
//
//                        return;
//                    }else if(3 == res.code) {
//                        //连续失败5次，锁定
//                        control.showPopup('操作太频繁，请稍后再试', 2000);
//                        $scope.dialog.hide();
//                        return;
//                    }else if(4 == res.code) {
//                        //用户未录入指纹
//                        var msg = '你尚未设置设备指纹，请先在手机系统设置中录入指纹';
//                        if($rootScope.deviceAuthenticationType == '1'){
//                            msg = '你尚未设置面容ID，请先在手机系统设置中录入面容';
//                        }
//                        control.showCustomAlert6(msg,'check-information');
//                        $scope.dialog.hide();
//                        return;
//                    }else if(5 == res.code) {
//                        //连续错误3次
//                        var msg = '指纹不匹配';
//                        if($rootScope.deviceAuthenticationType == '1'){
//                            msg = '面容不匹配';
//                        }
//                        control.showPopup(msg, 2000);
//                        return;
//                    }else if(6 == res.code) {
//                        //权限未打开
//                        var msg = '需要开启设备指纹权限才能使用';
//                        if($rootScope.deviceAuthenticationType == '1'){
//                            msg = '需要开启设备面容ID权限才能使用';
//                        }
//                        control.showPopup(msg, 2000);
//                        return;
//                    }else {
//                        // control.showPopup(res.msg, 2000);
//                        return;
//                    }
//                }
//                var failFunc = function(res) {
//                    console.log('fail - ' + JSON.stringify(res));
//                }
//                nativeHelper.deviceAuthentication({
//                    data: [''],
//                    success: successFunc,
//                    fail: failFunc
//                });
//            } else {
//                control.showPopup('当前设备不支持指纹或面部认证', 2000);
//            }
//        }

//        $rootScope.closeModal = function(){
//            $scope.dialog.hide();
//        }
//
//        $rootScope.deviceAuthGuideCloseClick = function() {
//            $scope.dialog.hide();
//            $rootScope.isShowGuide = false;
//        }


        $scope.linkInfo = $stateParams.linkInfo;

//        $scope.linkContent="您单位正在办理您名下法人数字证书业务，请在微信上打开此链接进行授权与签名，如有疑问，详询4008884636。";
        $scope.isShowShare = false;
        $scope.isShowCopy = false;

        $scope.showShare = function() {
            console.log('linkInfo: ' + JSON.stringify($scope.linkInfo));
            // 1: 短地址  2: 小程序 
            if('2' == $scope.linkInfo.shareContentType){
                $scope.isShowCopy = true;
                $scope.linkContent = $scope.linkInfo.xcxContent;

                nativeHelper.socialAgent({
                    data: [$scope.linkContent,1,''],
                    success: ()=>{},
                    fail: ()=>{},
                });
            }else{
                $scope.isShowShare = true;
                $scope.linkContent = $scope.linkInfo.shareContent;
                $scope.url = $scope.linkInfo.url;
                //jbr：经办人申请授权，分享弹窗新增查看法人授权流程入口；fr：法人主动授权，分享弹窗不显示查看法人授权流程入口；
                $scope.type = "jbr";
            }
        }

        $scope.cancel=function(){
            $scope.isShowShare = false;
            $scope.isShowCopy = false;
        }

        $scope.navigate = function(state) {
            nav.navigate(state);
        };
        
        var applyAuthorizeCompleteEvent = function() {
            var eventCounter = new Object();
            eventCounter.page = "授权已提交";
            MobclickAgent.onEventWithParameters("applyAuthorizeComplete", eventCounter);
        }
        
        applyAuthorizeCompleteEvent();
    }]);
})();
