(function() {
    "use strict"
    angular.module('starter')
    .controller('approvallnfoV2', ['$rootScope', '$scope', '$filter', 'nav', 'control', 'nativeHelper', 'validate', '$state', 'utility',
    function($rootScope, $scope, $filter, nav, control, nativeHelper, validate, $state, utility) {

       screen.orientation.unlock();
       screen.orientation.lock('portrait');
       $scope.agenterList = [];
       $scope.isShowAgenter = false;
       $scope.chooseIdentityId = '';
//       $scope.authorizeDay = 30;//授权时间
//       $scope.chooseDate = 30;//选中的时间


       $scope.approvalDetail = {
            name:"",
            cert:"",
            mobile:""
       };
       $scope.isShowAuthorizeDate = false;// 显示授权时间弹框

       // 被授权人弹框
       $scope.isShowAgenterClick = function(){
           $scope.isShowAgenter = true;
       }
       // 选中被授权人
       $scope.chooseAgenter = function(item){
           $scope.chooseIdentityId = item.identityId;
       }
       // 提交被授权人
       $scope.comfireChoose = function(){
            if($scope.chooseIdentityId==''){
                return
            }
            $scope.isShowAgenter = false;
            $scope.agenterList.forEach(function(l) {
                if (l.identityId == $scope.chooseIdentityId) {
                     $scope.approvalDetail = l
                }
           })
            if($rootScope.applyCertType == 0){
                var eventCounter = new Object();
                eventCounter.page = "证书申领-证书授权页面-确认";
                MobclickAgent.onEventWithParameters("applyCertAuthorizationEvent", eventCounter);
            }else if($rootScope.applyCertType == 1){
                var eventCounter = new Object();
                eventCounter.page = "证书补办-证书授权页面-确认";
                MobclickAgent.onEventWithParameters("makeUpCertAuthorizationEvent", eventCounter);
            }
       }

//        // 授权期限弹框
//       $scope.isShowAuthorizeDateClick = function(){
//            $scope.chooseDate =  $scope.authorizeDay;
//            $scope.isShowAuthorizeDate = true
//       }
        // 提交授权期限
//       $scope.comfireAuthorizeDate = function(){
//            $scope.authorizeDay = $scope.chooseDate;
//            $scope.isShowAuthorizeDate = false;
//       }

        var getAgenterList = function() {
            control.showLoading();
            var params = [$rootScope.certUnderwayInfo.uniscid];
            var successFunc = function(result) {
                control.hideLoading();
                if (result == null || angular.equals({},
                result)) {
                    control.showPopup('服务出错啦', 3000);
                    return;
                }
                if (result.rslt == 'success') {
                    $scope.$apply(function() {
                        $scope.agenterList = result.agenterList
                    });
                }
                if (result.rslt == 'fail') {
                    control.showPopup(result.errorMsg, 2000);
                }
            }

            var failFunc = function(error) {
                control.hideLoading();
                control.showPopup(error.msg, 2000);
            };
            nativeHelper.getAgenterList({
                data: params,
                success: successFunc,
                fail: failFunc
            });
        }
        getAgenterList();

//        $scope.toAuthorization = function(item) {
//            $state.go('authenticationApproval', {
//                authorizationDetail: {
//                    'srcPage': 'selectHandler',
//                    name: item.name,
//                    cert: item.cert,
//                    mobile: item.mobile,
//                    identityId: item.identityId,
//                    authIdentityId: $rootScope.certUnderwayInfo.identityId,
//                    uniscid: $rootScope.certUnderwayInfo.uniscid,
//                    startTime: $rootScope.certUnderwayInfo.systemTime,
//                    'certName': $rootScope.certUnderwayInfo.netType=="8"?$rootScope.certUnderwayInfo.certName:$rootScope.certUnderwayInfo.entName,
//                    'categoryBh': $rootScope.certUnderwayInfo.categoryBh,
//                    'netType': $rootScope.certUnderwayInfo.netType,
//                    'corpid': $rootScope.certUnderwayInfo.corpid,
//                    'businessType':$filter('netTypeNumToText')($rootScope.certUnderwayInfo.netType)
//                }
//            });
//        }

        $scope.authenticationSign=function(){
            if (validate.nullOrEmpty($scope.approvalDetail.name)) {
                return;
            }
            if (validate.nullOrEmpty($scope.approvalDetail.cert)) {
                return;
            }
            if (validate.nullOrEmpty($scope.approvalDetail.mobile)) {
                return;
            }
            $scope.approvalDetail.startTime = $rootScope.certUnderwayInfo.systemTime;
            var endDate=$('#datetime-picker-end').val();

            if(validate.nullOrEmpty(endDate)){
                 return;
            }
            if(validTime(endDate)=='0'){
                control.showPopup('截止日期不能小于起始日期', 2000);
                return;
            }
            if(validTime(endDate)=='2'){
                control.showPopup('授权日期不能小于当前时间', 2000);
                return;
            }
            if(validTime(endDate)=='3'){
                control.showPopup('截止时间最长选择不能超过1年', 2000);
                return;
            }

            $scope.approvalDetail.endTime=endDate;
            $scope.approvalDetail.uniscid = $rootScope.certUnderwayInfo.uniscid;
            $scope.approvalDetail.srcPage = "approvallnfoV2";
            $scope.approvalDetail.certName=$rootScope.certUnderwayInfo.netType=="8"?$rootScope.certUnderwayInfo.certName:$rootScope.certUnderwayInfo.entName;
            $scope.approvalDetail.categoryBh= $rootScope.certUnderwayInfo.categoryBh;
            $scope.approvalDetail.netType= $rootScope.certUnderwayInfo.netType;
            $scope.approvalDetail.corpid= $rootScope.certUnderwayInfo.corpid;
            $scope.approvalDetail.businessType=$filter('netTypeNumToText')($rootScope.certUnderwayInfo.netType);

//
            $state.go('authorizationBook',{'authorizationDetail':$scope.approvalDetail});
//            $state.go('signatureAuthorization',{'authorizationDetail':$scope.approvalDetail});
        //    if (cordova.platformId === 'ios') {
        //        nativeHelper.setOrientation({ data: ['LandscapeRight'], success: null, fail: null });
        //    }
        }

        function formatDayTime(val) {
            if(val) {
                  var date = new Date(val);
                  var Y = date.getFullYear();
                  var M = date.getMonth() + 1;
                  var D = date.getDate();
                  if(M < 10) {
                      M = '0' + M;
                  }
                  if(D < 10) {
                      D = '0' + D;
                  }
                  return Y + '-' + M + '-' + D ;
            } else {
                  return '';
            }
        }

        var getDate = function(time, day) {
        	time.setDate(time.getDate() + day);
        	var y = time.getFullYear();
        	var m = time.getMonth() + 1;
        	var d = time.getDate();
        	return y + "-" + (m < 10 ? "0" + m : m) + "-" + (d < 10 ? "0" + d : d);
        }
        var nowTime = new Date();
        var getTime = getDate(nowTime, 0);


        var years = function() {
        	for (var t = [], e = nowTime.getFullYear(); e <= nowTime.getFullYear() + 1; e++)
        		t.push(e);
        	return t
        }
        //选择截止日期
        $("#datetime-picker-end")
        	.datetimePicker({
        		onOpen: function(data) {
        			$('#picker-title')
        				.html(data.value[0] + '-' + data.value[1] + '-' + data.value[2]);
        		},
        		onChange: function(data) {
        			$('#picker-title')
        				.html(data.value[0] + '-' + data.value[1] + '-' + data.value[2]);
        		},
        		years: years(),
        		toolbarTemplate: '<div class="tool-bar"><div class="close-picker fl close-text">关闭</div><div class="fl title-text" id="picker-title"></div><div class="close-picker fr finish-text">完成</div></div>',
        		times: function() {
        			return [];
        		}
        	});
        var date = new Date($rootScope.certUnderwayInfo.systemTime.replace(/-/g, '/'));
        $("#datetime-picker-end").val(formatDayTime(date.setDate(date.getDate() + 30))+" ")

        var validTime = function(endTime) {
        	var date1 = new Date($scope.approvalDetail.startTime.replace(/-/g, '/'));
        	var date2 = new Date(endTime.replace(/-/g, '/'));
        	var arr1 = $scope.approvalDetail.startTime.split("/");
        	var date3 = new Date(parseInt(arr1[0]) + 1, parseInt(arr1[1]) - 1, parseInt(arr1[2]), 0, 0, 0);
//        	var nowDate = new Date();
            // 365*1000*60*60*24
        	if (date1.getTime() > date2.getTime()) {
        		return '0';
        	} else if (date2.getTime() > date3.getTime()) {
        		return '1';
        	} else if (date2.getTime() < date1.getTime()) {
        		return '2';
        	} else if (date2.getTime() > date1.getTime()+(365*1000*60*60*24)) {
                return '3';
            }
        }

        $scope.navigate = function(state) {
            nav.navigate(state);
        };

    }]);
})();
