(function () {
    "use strict"
    angular.module('starter')
        .controller('postIntroduction', ['$rootScope', '$scope', 'nav', '$stateParams','nativeHelper','control','$ionicModal','localStorage','$state',function ($rootScope, $scope, nav,$stateParams,nativeHelper,control,$ionicModal,localStorage,$state) {
             $scope.orderNo=$stateParams.orderNo;
             $scope.isAgreeApplyAgreement=false;
             $scope.agree=function(){
                   $scope.isAgreeApplyAgreement=!$scope.isAgreeApplyAgreement;
             }
             $scope.commit=function(){
                  if(!$scope.isAgreeApplyAgreement){
                       control.showPopup("请先阅读协议并同意", 2000);
                       return
                  }
                  if($scope.orderNo == null||$scope.orderNo == ''){
                       doSaveNoAuthNetOrderInfo();
                  }else{
                    $state.go('businessCompleted',{
                       orderNo: $scope.orderNo,
                       sourceType:"0"
                    });
                  }
             }
             console.log(JSON.stringify($rootScope.certUnderwayInfo))
             //邮寄领证生成免费业务单
             var doSaveNoAuthNetOrderInfo = function() {
             	control.showLoading();
             	var params = [$rootScope.loginInfo.mobile, $rootScope.loginInfo.accountId, $rootScope.certUnderwayInfo.categoryBh, $rootScope.certUnderwayInfo.businessCode, '5', $rootScope.certUnderwayInfo.netType, $rootScope.certUnderwayInfo.entName, $rootScope.certUnderwayInfo.uniscid, $rootScope.certUnderwayInfo.corpid, '0', //是否通过ocr校验0：不通过，1：已通过
             	'1', //人脸识别是否通过状态：0通过，1不通过
             	$rootScope.loginInfo.userName ? $rootScope.loginInfo.userName: '', $rootScope.loginInfo.idCard ? $rootScope.loginInfo.idCard: ''];
             	console.log("doSaveNoAuthNetOrderInfo info:" + JSON.stringify(params));

             	var successFunc = function(result) {
             		control.hideLoading();
             		if (result == null || angular.equals({},
             		result)) {
             			control.showPopup('服务出错啦', 2000);
             			return;
             		}
             		if (result.success) {
             			//订单号
             			$scope.$apply(function() {
             				$rootScope.curAutoApplyOrderNo = result.value.orderNo;
                            $state.go('businessCompleted',{
                                 orderNo: result.value.orderNo,
                                 sourceType:"0"
                            });
             			});
             		} else {
             			control.showPopup(result.msg, 2000);
             		}
             	}
             	var failFunc = function(result) {
             		control.hideLoading();
             		control.showPopup(result.msg, 2000);
             	};
             	nativeHelper.doSaveNoAuthNetOrderInfo({
             		data: params,
             		success: successFunc,
             		fail: failFunc
             	});
             };

        }]);
})();
