(function () {
    "use strict"

    angular.module('starter')
        .controller('businessManage', ['$rootScope', '$scope', '$ionicLoading',
            '$ionicActionSheet', '$filter', 'nav', 'control', 'localStorage',
            'nativeHelper', '$state','$stateParams','verifyIdentity', 'requestWrapper', 'md5', 'utility','validate',
            function ($rootScope, $scope, $ionicLoading, $ionicActionSheet, $filter, nav,
                control, localStorage, nativeHelper, $state, $stateParams, verifyIdentity, requestWrapper, md5, utility,validate ) {
                var pageNum = 1;//页码
                var showNum = 5;
                $scope.can_loadmore = true;
                $scope.isloadmore = false;
                $scope.isloading = true;
                $scope.searchInfo = { key: '' }
                $scope.selectIsValid = "";
                var curItem = null;

                // 资料更新是否需要隐藏授权书上传
                $rootScope.hideAuthUpload = false;

                $rootScope.updatePictures = {
                    businessLicensePic: '',
                    IDCardFrontPic: '',
                    IDCardBackPic: '',
                    authorizationPic: '',
                    uploadFrom: '',
                    orderNo:'',
                }

                $scope.businessInfoList = [
                    //{ entName: '杭州天日管带机电有限公司', createDate: '2018-03-20 12:23:56', orderNo: '45678909988766543257', netType: '8', handleState: '7', reason: '长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差长得太丑，人品差' },
                    //{ entName: '杭州天日管带机电有限公司', createDate: '2018-03-20 12:23:56', orderNo: '45678909988766543257', netType: '6', handleState: '0', reason:''},
                    //{ entName: '杭州天日管带机电有限公司', createDate: '2018-03-20 12:23:56', orderNo: '45678909988766543257', netType: '6', handleState: '1', reason: '' },
                    //{ entName: '杭州天日管带机电有限公司', createDate: '2018-03-20 12:23:56', orderNo: '45678909988766543257', netType: '8', handleState: '2', reason: '' },
                    //{ entName: '杭州天日管带机电有限公司', createDate: '2018-03-20 12:23:56', orderNo: '45678909988766543257', netType: '8', handleState: '5', reason: '' },
                ];
                var refreshBtnStatus = false;



            
            var authLivingFailEvent = function() {
                var eventCounter = new Object();
                eventCounter.page = "活体识别失败";
                MobclickAgent.onEventWithParameters("authLivingFailEvent", eventCounter);
            }

                var getBusinessInfoList = function () {
                    control.showLoading();
                    refreshBtnStatus = true;
                    var timeout = setTimeout(function () {
                        refreshBtnStatus = false;
                    }, 2000);
                    var params = [$rootScope.loginInfo.accountId, $rootScope.loginInfo.mobile,
                        pageNum, showNum, $scope.searchInfo.key, $rootScope.loginInfo.idCard,$scope.selectIsValid,$stateParams.orderNo];
                    var successFunc = function (result) {
                        control.hideLoading();
                        $scope.isloading = false;
                        $scope.can_loadmore = true;
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        };
                        switch (result.success) {
                            case true:
                                $scope.$apply(function () {
                                    $scope.businessInfoList = result.value.netOrderDetailsList;
                                    $scope.businessInfoList.forEach(function(r){
                                        console.log("业务单:"+JSON.stringify(r))
                                    })
                                    $scope.recordsTotal = result.value.pagination.total;
                                });
                                break;
                            case false:
                                control.showPopup(result.msg, 2000);
                                break;
                        }
                    };

                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };

                    nativeHelper.getBusinessInfoList({ data: params, success: successFunc, fail: failFunc });
                };

                //业务管理tab
//                $('.bm-tab span').bind('click',function(){
//                    $(this).addClass("active").siblings().removeClass("active")
//                    if($(this).index() == 1){
//                        //有效
//                        $scope.selectIsValid = "1";
//                    }else if($(this).index() == 2){
//                        //无效
//                         $scope.selectIsValid = "0";
//                    }else {
//                        //全部
//                        $scope.selectIsValid = "";
//                    }
//                     getBusinessInfoList();
//                })
                $rootScope.recordType="";
                $scope.selectTab = function (selectIsValid) {
                    if(selectIsValid == "1"){
                        //有效
                        $scope.recordType = "1";
                    }else if(selectIsValid == "0"){
                        //无效
                        $scope.recordType = "0";
                    }else {
                        //全部
                        $scope.recordType = "";
                    }
                     $scope.selectIsValid = selectIsValid;
                     getBusinessInfoList();
                }

                
                // 授权记录跳转 获取信用码执行搜索
                if ($stateParams.businessManageSearchKey) {
                    // 搜索条件 - 信用代码 有效
                    $scope.searchInfo.key = $stateParams.businessManageSearchKey;
                    $scope.selectIsValid = "1";
                    $('.ywgl-tab span').removeClass("active");
                    var eleArr = $('.ywgl-tab span').get();
                    if (eleArr.length > 2) {
                        eleArr[1].setAttribute("class", "active");
                    }
                }

                getBusinessInfoList();

                $scope.searchBusiness = function () {
                    pageNum = 1;
                    showNum = 5;
                    getBusinessInfoList();
                    //关闭软键盘
                    cordova.plugins.Keyboard.close();
                }

                 //监听输入框软键盘搜索按钮  触发搜索
                 $("#searchBmKeyword").keypress(function(e){
                    if(cordova.platformId === 'ios'){
                        if(e.keyCode === 13) {
                            pageNum = 1;
                            showNum = 5;
                            getBusinessInfoList();
                            cordova.plugins.Keyboard.close();
                        }
                     }else{
                        if(e.keyCode === 13) {
                            pageNum = 1;
                            showNum = 5;
                            getBusinessInfoList();
                         }
                       //关闭软键盘
                       cordova.plugins.Keyboard.close();
                     } 
                 })


                // 检查是否需要上传资料
                var doCheckUploadPicture = function(item, state) {
                    var time = utility.getCurrentTime();
                    var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                    var temp = {
                        "corpid": item.corpid,
                        "proxIdNo": $rootScope.loginInfo.idCard,
                        "categoryBh": item.categoryBh,
                        "orderNo": item.orderNo,
                        'keyNo':$rootScope.uuid,
                        "token" : $rootScope.loginInfo.token
                    }

                    var reqParams = DES3.encrypt(hashdata.substring(0,24), 'ZJHUIXIN', angular.toJson(temp))
            
                    var params = {
                        "appid": $rootScope.appid,
                        "time": time,
                        "hashdata": hashdata,
                        "reqParams": reqParams
                    };
                    console.log("doCheckUploadPicture params :" + JSON.stringify(params));
                    requestWrapper.doCheckUploadPicture({ data: params, refresh: true })
                        .then(function (result) {
                            control.hideLoading();
                            console.log('doCheckUploadPicture - result:' + JSON.stringify(result));
                            if (result == null || angular.equals({}, result)) {
                                control.showPopup('服务出错啦', 2000);
                                return;
                            };
                            if (true == result.success) {
                                if ('yes' == result.value.isUpload) {
                                    $scope.showUpdatePicAlert = true;
                                } else {
                                    doDownloadCertOp(item, state);
                                }
                            } else {
                                control.showPopup(result.msg, 2000);
                            }
                        })
                        .catch(function (e) {
                            control.hideLoading();
                            console.log('网络请求失败：' + e.status);
                            control.showPopup('网络请求失败：' + e.status, 2000);
                        });
                }

                $scope.doUploadPic = function () {
                    $rootScope.updatePictures.uploadFrom = 'businessManage';
                    $rootScope.updatePictures.orderNo = curItem.orderNo;
                    //非个人 上传营业执照/身份证正反面
                    nav.navigate("uploadBusinessLicense");
                }

                $scope.orderNoData;
                
                $rootScope.popupPwdHidden = true;
                $rootScope.userNameForPwdPopup = $rootScope.loginInfo.userName;
                $rootScope.userPhoneForPwdPopup  = $rootScope.loginInfo.mobile;
                $rootScope.pwdPopup = {userPassword: ''};
                $rootScope.passwordPopupCloseClick = function() {
                    control.hideCustomPopup();
                }
                $rootScope.passwordPopupConfirmClick = function () {
                    if('' == $rootScope.pwdPopup.userPassword){
                        return;
                    }

                    var time = utility.getCurrentTime();
                    var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                    var temp = {
                        'mobile': $rootScope.loginInfo.mobile,
                        'password': $rootScope.pwdPopup.userPassword,
                        'keyNo':$rootScope.uuid,
                        "token" : $rootScope.loginInfo.token
                    }

                    var reqParams = DES3.encrypt(hashdata.substring(0,24), 'ZJHUIXIN', angular.toJson(temp))
            
                    var params = {
                        "appid": $rootScope.appid,
                        "time": time,
                        "hashdata": hashdata,
                        "reqParams": reqParams
                    };
                    control.showLoading();
                    requestWrapper.verifyPassword({data: params, refresh: true})
                        .then(function (result) {
                            control.hideLoading();
                            console.log("doGetMobileDeviceCount" + JSON.stringify(result));
                            $rootScope.pwdPopup = {userPassword: ''};
                            if (true == result.success) {
                                control.hideCustomPopup();
                                $state.go('downloadCert', {
                                    'downloadCertInfo': orderNoData
                                });
                            } else {
                                control.showPopup(result.msg, 2000);
                            }
                        });
                }

                $rootScope.passwordPopupForgetClick = function () {
                    control.hideCustomPopup();
                    var hideMobile = $rootScope.loginInfo.mobile;
                    if(hideMobile == undefined || hideMobile == null || hideMobile == ''){
                        hideMobile = ''
                    }
                    if (!isNaN(parseFloat(hideMobile)) && isFinite(hideMobile)) {
                        var prefix = hideMobile.slice(0, 3);
                        var suffix = hideMobile.slice(7)
                        hideMobile = prefix + "****" + suffix;
                    }
                    var template = "<h4 style='word-break:break-all;'>找回密码需要短信验证，确定要给您的手机号"+hideMobile+ "发送验证码短信吗？</h4>"
                    control.showConfirm3(function() {
                        nav.navigate('retrievePasswordForPwdPopup');
                    },function() {},'', '确定', 'check-information', template);
                }

                $rootScope.popupPwdIconClick = function() {
                    if ($rootScope.popupPwdHidden) {
                        let input = document.getElementById("pwdpopup-pwdinput");
                        console.log(input);
                        input.setAttribute("type", "text");
                        let icon = document.getElementById("pwdpopup-pwdicon");
                        icon.setAttribute("class", "pwdpopup-show-icon");
                    } else {
                        let input = document.getElementById("pwdpopup-pwdinput");
                        input.setAttribute("type", "password");
                        let icon = document.getElementById("pwdpopup-pwdicon");
                        icon.setAttribute("class", "pwdpopup-hide-icon");
                    }
                    $rootScope.popupPwdHidden = !$rootScope.popupPwdHidden;
                    console.log($rootScope.popupPwdHidden);
                }

                $rootScope.popupPwdClearClick = function() {
                    $rootScope.pwdPopup = {userPassword: ''};
                }

                //下载证书
                $scope.downloadCert = function (item, state) {
                    //V2.9.8判断证书是否被冻结  certFrozen==1 冻结
                    if(item.certFrozen=='1'){
                       $scope.showFrozenTip=true;
                       return;
                    }
                    var eventCounter = new Object();
                    eventCounter.page = "业务管理-证书安装";
                    MobclickAgent.onEventWithParameters("businessManageCertInstallEvent", eventCounter);
                    control.showLoading();
                    if(validate.isStrEmpty(item.uniscid)){
                        continueBusiness(item,state);
                        return;
                    }
                    var params = [item.uniscid,'1',item.orderNo];
                    var successFunc = function (result) {
                        control.hideLoading();
                        if(result.success){
                            continueBusiness(item,state);
                        }else{
                            control.showPopup(result.msg, 2000);
                            setTimeout(function () {
                                pageNum = 1;
                                showNum = 5;
                                getBusinessInfoList();
                            }, 2000);
                        }
                    }
                    var failFunc = function (e) {
                        control.hideLoading();
                        control.showPopup(e.msg, 2000);
                    };
                    nativeHelper.checkEntState({ data: params, success: successFunc, fail: failFunc });
                }
                var continueBusiness = function (item, state) {
                    curItem = item;
                    orderNo = item.orderNo;
                    if (state == 'checking') {
                        control.showPopup('正在审核中', 2000);
                        return;
                    }
                    if (state == 'orderDetails') {
                        nav.navigate(state);
                        return;
                    }
                    
                    // B01变更 B02 延期
                    if ('B01' == item.businessCode || 'B02' == item.businessCode) {
                        $rootScope.hideAuthUpload = true;
                    }

                    if (item.flag == '0') {
                        control.showPopup('该业务已失效，请重新办理', 2000);
                    } else {

                        var params = [$rootScope.loginInfo.accountId, item.certSn];
                        var successFunc = function (result) {
                            
                            console.log(JSON.stringify("judge - " + result));
                            if (result && 'B01' != item.businessCode && 'B02' != item.businessCode) {
                                $scope.$apply(function () {
                                    // 本地有证书且不是B01变更和B02延期的业务单无需下载
                                    $scope.deleteCertSn = item.certSn;
                                    $scope.showDeleteTip = true;
                                });
                                //control.showPopup('证书已下载至本设备，无需重新下载。如果证书出现了无法使用的故障，可删除证书后再重新下载。', 2000);
                            } else {
                                //netType业务单类型 6:证书新领 8:证书补办 7:子证书新领
                                var certApplyTypeText ="";
                                if(item.netType=='8'){
                                    certApplyTypeText="补办";
                                }else if(item.netType=='6' || item.netType=='7'){
                                    certApplyTypeText="新领";
                                }

                                $rootScope.curBusinessInfo = item;
                                //封装证书新领或补办进行中所需信息
                                $rootScope.certUnderwayInfo = {
                                    entName: item.entName,
                                    category: $filter('categoryType')(item.categoryBh),
                                    businessCode: item.businessCode,
                                    //更新资料页面变更 新增参数
                                    uniscid: item.uniscid,
                                    certApplyType: certApplyTypeText,
                                    netType: item.netType,
                                    entProvince: item.entProvince,
                                };

                                //if (item.businessCode == 'B01' && item.handleState == '7') {
                                //    $rootScope.certApplyNoticeParent = 'businessManage';
                                //    nav.navigate('certChange');
                                //}
                                //else {
                                //                        if ($rootScope.curBusinessInfo.keySerial != 'eztApp' && $rootScope.curBusinessInfo.isweb == '1' && state == 'downloadCert' && $rootScope.curBusinessInfo.keySerial !== $rootScope.phoneUUID) {
                                //                            control.showPopup('请使用业务申请的手机进行操作，或走证书补办流程', 2000);
                                //                            return;
                                //                        }


                                $rootScope.certApplyNoticeParent = 'businessManage';

                                if(state=='downloadCert'){
                                   //判断是否需要续费  需要续费的弹窗提示
                                   if(item.payYearFee=='1'){
                                       certFeeScale(item);
                                       return;
                                   }
                                    $scope.$apply(function(){
                                        if ('HCCA_NEW' == item.caName) {
                                            doCheckUploadPicture(item, state);
                                        } else {
                                            doDownloadCertOp(item);
                                        }
                                    });
                                    return;
                                }
                                //跳转资料更新需要的参数
                                $rootScope.autoApplyInfo = {
                                                businessLicensePic: '',
                                                authorizationPic: '',
                                                serviceProtocolPic: '',
                                                IDCardFrontPic: '',
                                                IDCardBackPic: '',
                                                needGetInfo:'true', //跳转资料上传页面，第一次需要请求审核数据
                                                picErrorMsg:''//图片审核不通过原因
                                            };


                                $scope.$apply(function(){
                                    nav.navigate(state);
                                });
                            }
                        }
                        var failFunc = function (e) {
                            control.showPopup(e, 2000);
                        };
                        nativeHelper.getSpecifiedCert({ data: params, success: successFunc, fail: failFunc });
                    }

                }

                var authDevice = localStorage.getObject('isAuthDevice');

                var doDownloadCertOp = function (item) {
                    $scope.orderNoData = item;
                    orderNoData=item;

                    //orderType = 业务单类型：0材料领证 1授权领证 isweb = 2 线下网点办理
                    if((item.orderType == '0'&&item.facePassState!='0')||item.isweb=='2'){//0材料 facePassState=1 邮寄
                        $state.go('downloadCert', {
                            'downloadCertInfo': orderNoData
                        });
                        return;
                    }else{
                        // realNameGrade = 0未实名 1已实名
                        if($rootScope.loginInfo.realNameGrade == "1"){
                            control.showLoading();
                            var time = utility.getCurrentTime();
                            var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                            var params = {
                                'appid': $rootScope.appid,
                                'time': time,
                                'hashdata': hashdata,
                                'mobilePhone': $rootScope.loginInfo.mobile,
                                'idCard': $rootScope.loginInfo.idCard,
                                'keyNo':$rootScope.uuid,
                                'token': $rootScope.loginInfo.token
                            }
                            
                            requestWrapper.doGetMobileDeviceList({data: params, refresh: true})
                            .then(function (result) {
                                control.hideLoading();
                                console.log("doGetMobileDeviceCount" + JSON.stringify(result));
                                if (result.success) {
                                    var deviceList = result.value;
                                    var isTrustedDevice = false;
                                    for (let index in deviceList) {
                                        if (deviceList[index].keySerial == $rootScope.uuid) {
                                            isTrustedDevice = true;
                                            break;
                                        }
                                    }
                                    // 是否是信任设备
                                    if (isTrustedDevice) {
                                        console.log('生物识别开关是否打开:' + ($rootScope.openBiometryAndroid == '1' && 'android' == cordova.platformId) || ($rootScope.openBiometryIOS == '1' && 'ios' == cordova.platformId))
                                        //生物识别开关是否打开, 不同系统不同开关
                                        if(($rootScope.openBiometryAndroid == '1'  && 'android' == cordova.platformId) || ($rootScope.openBiometryIOS == '1' && 'ios' == cordova.platformId)){
                                            // var openVerify = localStorage.getObject('openVerify');
                                            var authInfo = localStorage.getObject('authInfo' + $rootScope.loginInfo.accountId);
                                            console.log(JSON.stringify(authInfo));
                                            //是否开启指纹
                                            if(JSON.stringify(authInfo) == '{}' || authInfo.openVerify == '0'){
                                                // 密码校验
                                                $rootScope.pwdPopupFrom = 'businessManage';
                                                control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                return;
                                            }else{
                                                // 用指纹/登录密码校验
                                                if ('0' != $rootScope.deviceAuthenticationType) {
                                                    // 如果指纹已打开且可用 用指纹校验
                                                    var successFunc = function(res) {
                                                        console.log('success - ' + JSON.stringify(res));
                                                        if (1 == res.code) {
                                                            $state.go('downloadCert', {
                                                                'downloadCertInfo': orderNoData
                                                            });
                                                        }else if(2 == res.code) {
                                                            //用户选择了取消
                                                            if(cordova.platformId === 'android' && $rootScope.deviceAuthenticationType === '1'){
                                                                //安卓面容验证点击取消出现密码验证
                                                                $rootScope.pwdPopupFrom = 'businessManage';
                                                                control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                            }
                                                            return;
                                                        }else if(3 == res.code) {
                                                            //连续失败5次，锁定
                                                            // control.showPopup('操作太频繁，需验证账号密码', 3000);
                                                            $rootScope.pwdPopupFrom = 'businessManage';
                                                            control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                            return;
                                                        }else if(4 == res.code) {
                                                            //用户未录入指纹
                                                            // var msg = '你尚未设置设备指纹，请先在手机系统设置中录入指纹';
                                                            // if($rootScope.deviceAuthenticationType == '1'){
                                                            //     msg = '你尚未设置面容ID，请先在手机系统设置中录入面容';
                                                            // }
                                                            // control.showCustomAlert6(msg,'check-information');
                                                            $rootScope.pwdPopupFrom = 'businessManage';
                                                            control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                            return;
                                                        }else if(5 == res.code) {
                                                            //连续错误3次
                                                            // var msg = '指纹不匹配';
                                                            // if($rootScope.deviceAuthenticationType == '1'){
                                                            //     msg = '面容不匹配';
                                                            // }
                                                            // control.showPopup(msg, 2000);
                                                            $rootScope.pwdPopupFrom = 'businessManage';
                                                            control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                            return;
                                                        }else {
                                                            // 密码校验
                                                            $rootScope.pwdPopupFrom = 'businessManage';
                                                            control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                            return;
                                                        }  
                                                    }
                                                    var failFunc = function(res) {
                                                        console.log('fail - ' + JSON.stringify(res));
                                                    }
                                                    nativeHelper.deviceAuthentication({
                                                        data: ['输入登录密码'], 
                                                        success: successFunc, 
                                                        fail: failFunc 
                                                    });
                                                } else {
                                                    // 密码校验
                                                    $rootScope.pwdPopupFrom = 'businessManage';
                                                    control.showCustom4Popup('html/downloadCert/enterLoginPasswordPopup.html');
                                                    return;
                                                }
                                            }
                                        }else{
                                            $state.go('downloadCert', {
                                                'downloadCertInfo': orderNoData
                                            });
                                        }
                                    } else {
                                        if($rootScope.isAuthFace()){
                                             // ctid认证流程
                                             $scope.acShowAuthConfirm = false;
                                             $scope.alert_applicant_info = true;
                                        }else{
                                             $state.go('downloadCert', {
                                                 'downloadCertInfo': orderNoData
                                             });
                                        }
                                    }

                                } else {
                                    control.showPopup(result.msg, 2000);
                                }
                            });
                        }else{
                            $rootScope.identityAuthRootPage="businessManage";
                            nav.go('authorizationFace');
                        }
                    }

                }

                $rootScope.hide=function(){
                    control.hideCustomPopup();
                }

                var currentTime ;//当前时间

                /**
                *初始化人脸验证弹框内信息
                **/
                 $scope.operator='';
                 $scope.operatorId='';
                 $scope.alert_applicant_info=false;
                 var orderNoData='';
                 
                 var startLiveDetection = function(){
                    //人脸识别结果监听
                    var liveDetectionResult = function(res) {
                        $scope.$apply(function() {
                            $scope.alert_applicant_info=false;
                             if (res.rslt == 'success') {
                                 if (res.data.result == 'success') {
                                    $rootScope.setAuthSuccessTime();
                                    $state.go('downloadCert', {
                                       'downloadCertInfo': orderNoData
                                    });
                                 }else{
                                     authLivingFailEvent();
                                    if(!$rootScope.isOpenFaceAuthFail()){
                                        control.showPopup(res.data.authResultMsg, 2000);
                                    }
                                 }
                             }else{
                                authLivingFailEvent();
                                control.showPopup(res.errorMsg, 2000);
                             }
                        });
                    };
                    var eventCounter = new Object();
                    eventCounter.page = "活体检测-业务管理";
                    MobclickAgent.onEventWithParameters("authLivingBusinessManageEvent", eventCounter);
                    verifyIdentity.startLiveDetection(orderNoData.operator, orderNoData.operatorId, $rootScope.loginInfo.userId,liveDetectionResult);
                }

              
              $scope.acShowAuthConfirm = false;
              $scope.acCloseClick = function() {
                  $scope.acShowAuthConfirm = false;
              }
              // 人脸再试一次
              $scope.faceAuthTryAgain = function(){
                  $scope.acShowAuthConfirm = true;
                  $rootScope.closeFaceAuthFail();
              }
              $scope.acIsAgreeApplyAgreement = false;
              $scope.acAgree = function() {
                  $scope.acIsAgreeApplyAgreement = !$scope.acIsAgreeApplyAgreement;
              }
              $scope.acAgreement = function() {
                  var url = window.currentUrl + '/app/ezt/faceAgreement.html';
                  var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                  cordova.InAppBrowser.open(url, '_blank', operation);
              }
              $scope.acNext = function() {
                  if (!$scope.acIsAgreeApplyAgreement) {
                      control.showPopup("请确认同意《人脸认证功能协议》", 2000);
                      return;
                  }
                  $scope.acShowAuthConfirm = false;
                  startLiveDetection();
              }

              $scope.startLiveDetectionClick = function() {
                $scope.acShowAuthConfirm = true;
                $scope.alert_applicant_info = false;
             }

              $scope.closeApplicantInfoAlert=function(){
                $scope.alert_applicant_info=false;
              }
                //获取下拉刷新数据
                $scope.doRefresh = function () {
                    pageNum = 1;
                    showNum = 5;
                    getBusinessInfoList();
                    $scope.$broadcast('scroll.refreshComplete');
                };

                //点击加载更多
                $scope.loadMore = function () {
                    if ($scope.recordsTotal > showNum) {
                        showNum = 5 + showNum;
                        getBusinessInfoList();
//                        $scope.can_loadmore = false;

                    } else {
                        $scope.isloadmore = true;
                    }
                    $scope.can_loadmore = false;
                    $scope.$broadcast('scroll.infiniteScrollComplete');
                    return;
                };
                var refreshBtnStatus = false;
                $scope.refreshBtn = function () {
                    refreshBtnStatus = true;
                    var timeout = setTimeout(function () {
                        refreshBtnStatus = false;
                    }, 10000);
                    getBusinessInfoList();
                };
                $scope.backBtn = function () {
                    if($stateParams.orderNo != ""){
                        nav.navigate($stateParams.parentPage);
                    }else{
                        nav.navigate('tab/home');
                    }
                };

                /**
                 *
                 *缴费
                 *
                 */
                $scope.goPay = function (item) {
                if(item.orderType=='1'){
                    $state.go('orderInfoConfirm',{'orderInfo':item});
                      return;
                }
                    var item = { orderNo: item.orderNo, payType: item.payType, allFee: item.allFee, entName: item.entName, lastPage: 'businessManage',facePassState:item.facePassState };
                    $state.go('orderDetails', { orderInfo: item });
                }
                /**
                *下载电子发票
                *
                **/
                $scope.downloadInvoice = function (pdfUrl) {
                    var operation = 'location=no,toolbar=yes,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                    var url = pdfUrl;
                    //解决Safari浏览器下载文件后缀exe的问题
                    if (cordova.platformId === 'ios') {
                        url = window.currentUrl + '/app/api/fpDownload?path=' + pdfUrl;
                    }
                    cordova.InAppBrowser.open(url, '_system', operation);
                }
                $scope.navigate = function (state) {
                    nav.navigate(state);
                };


            var orderNo='';
            var isApplyCertSearch = false;
            $scope.postTipDialog=true;

            // 点击撤销业务单
            $scope.revokeOrder=function(item){
                if(item.handleState == '100'){
                    control.showConfirm5("<div class='tbtx-cont'><p>当前证书还未完成付款,是否确定撤销业务单？</p></div>", "<div class='popup-new-title'>提示</div>",
                        function() {
                            isApplyCertSearch = false
                            $scope.doCancelNetOrder()
                        },
                        function() {},
                    "取消", "确定", 'check-information');
                }else{
                    control.showConfirm5("<div class='tbtx-cont'><p>确定要撤销业务单吗？</p></div>", "<div class='popup-new-title'>撤销确认</div>",
                        function() {
                            isApplyCertSearch = false
                            $scope.doCancelNetOrder()
                        },
                        function() {},
                    "再想想", "确定", 'check-information');
                }
                orderNo=item.orderNo;
            }

            $scope.showReviewUrging=false;
            //点击审核催办
            $scope.reviewUrging=function(item){
               var eventCounter = new Object();
               eventCounter.page = "业务管理-审核催办";
               MobclickAgent.onEventWithParameters("businessManageReviewUrgingEvent", eventCounter);
               control.showLoading();
               var params = [item.orderNo];
               var successFunc = function (result) {
                         control.hideLoading();
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        };
                        switch (result.success) {
                            case true:
                                item.urgeMarkState='0';
                                $scope.showTip=result.msg;
                                $scope.showReviewUrging=true;
                                break;
                            case false:
                                control.showPopup(result.msg, 2000);
                                break;
                        }
                    };

               var failFunc = function (result) {
                    control.hideLoading();
                    control.showPopup(result.msg, 2000);
               };

                nativeHelper.auditPushMesToEntWx({ data: params, success: successFunc, fail: failFunc });
            }
            //关闭催办提示弹窗
            $scope.cancelReviewUrging=function(){
                $scope.showReviewUrging=false;
            }
            $scope.postTip=function(item){
                $scope.categoryBh=item.categoryBh;
                $scope.postTipDialog=false;
                if(item.allFee===0){
                    $scope.mainCert=true;
                    $scope.otherCert=false;
                    orderNo=item.orderNo;
                    isApplyCertSearch = true
                }else{
                    $scope.mainCert=false;
                    $scope.otherCert=true;
                }
            }
            //撤销业务单
            $scope.doCancelNetOrder = function () {
                    control.showLoading();
                    var params = [orderNo];
                    var successFunc = function (result) {
                         control.hideLoading();
                         $scope.postTipDialog=true;
                         $scope.mainCert=false;
                         $scope.otherCert=false;
                        if (result == null || angular.equals({}, result)) {
                            control.showPopup('服务出错啦', 2000);
                            return;
                        };
                        switch (result.success) {
                            case true:
                                control.showPopup("撤销成功", 2000);
                                var timeout = setTimeout(function () {
                                    clearTimeout(timeout)
                                    if(isApplyCertSearch){
                                        $scope.$apply(function () {
                                        //非邮寄线上申领，区分主体是否被申领过，走对应的新领补办操作
                                        $rootScope.applyCertType=-1;
                                            nav.go('applyCertSearchV2');
                                        });
                                    }else{
                                        pageNum = 1;
                                        showNum = 5;
                                        getBusinessInfoList();
                                    }
                                },2000);
                                break;
                            case false:
                                control.showPopup(result.msg, 2000);
                                break;
                        }
                    };

                    var failFunc = function (result) {
                        control.hideLoading();
                        control.showPopup(result.msg, 2000);
                    };

                    nativeHelper.doCancelNetOrder({ data: params, success: successFunc, fail: failFunc });
                };

                $scope.cancelClick = function () {
                    $scope.showUpdatePicAlert = false;
                }
                
                $scope.cancelPost=function(){
                    $scope.postTipDialog=true;
                    $scope.mainCert=false;
                    $scope.otherCert=false;
                }

               $scope.showDeleteTip = false;
               //取消特别提醒弹窗
               $scope.cancleFunc = function() {
                   $scope.showDeleteTip = false;
               }
               //去删除
               $scope.deleteFunc = function() {
                   $scope.showDeleteTip = false;
                   $state.go('certManage', {
                       certManageSearchKey: $scope.deleteCertSn
                   });
               }

               //补办证书
               $scope.makeUpCert = function(item) {
                try{
                    control.showLoading();
                    var key = item.uniscid;
                    var containCategory = [];
                    var params = [key,containCategory];
                    var successFunc = function(result) {
                    control.hideLoading();
                    if (result == null || angular.equals({},
                    result)) {
                        control.showPopup('服务出错啦', 2000);
                        return;
                    }
                    if (result.success) {
                        $rootScope.searchResult = result.value;
                        nav.navigate('ableMakeUpCertInfoV2');
                    }
                    if (!result.success) {
                        $scope.errMsg = result.msg
                    }
                }

                var failFunc = function(error) {
                    control.hideLoading();
                    control.showPopup(error.msg, 2000);
                };
                nativeHelper.searchAuthorizeEnt({
                    data: params,
                    success: successFunc,
                    fail: failFunc
                });
            }catch(e){}
               }

                var certFeeScale = function (item) {

                     control.showConfirm('证书年费<p>' +item.payYearFeeMes +'<p>',
                         /*
                         *【取消】按钮的后续操作
                         */
                         function () {


                         },
                         // 【知道了】按钮的后续操作
                         function () {

                             //封装证书年费所需信息
                             $rootScope.certAnnualFeeInfo = {
                                 entName: item.entName,
                                 uniscid: item.uniscid,
                                 category: '',
                                 categoryBh: '',
                                 isFree: false,
                                 corpid: item.corpid,
                                 businessCode: '',
                                 operator: item.operator,
                                 operatorid: item.operatorId,
                                 count: '',
                                 parentPage: 'businessManage',
                             }
                             nav.navigate('confirmPayInfo');

                         }, '缴费', '取消', 'cusClass');
                 }

                //v2.9.8 新增冻结证书提示弹窗
                $scope.showFrozenTip=false;
                $scope.colseFrozenTip = function(){
                    $scope.showFrozenTip=false;
                }

            }]);
})();
