(function () {
    "use strict"

    angular.module('starter')
        .controller('home', ['$rootScope', '$scope', '$state', 'nav', 'nativeHelper', 'localStorage',
        'control', 'utility', '$timeout', '$ionicLoading', 'verifyIdentity', '$stateParams', 'requestWrapper', "md5", "$ionicPopup",'$ionicSlideBoxDelegate','downloadLogic','validate', function ($rootScope, $scope, $state, nav, nativeHelper, localStorage, control, utility,$timeout, $ionicLoading, verifyIdentity, $stateParams, requestWrapper, md5, $ionicPopup,$ionicSlideBoxDelegate,downloadLogic,validate) {
            // $scope.statusBarHeight = 44;//20  44
            $scope.hasUnreadMsg = false;
            $rootScope.localCertList = [];
            $scope.scrollCertList = [];
            $scope.hasCert = false;
            $rootScope.isNeedAuthFace = true;
            $rootScope.recordType = '0';// 0 待授权 1 授权记录
            $rootScope.loginInfo = localStorage.getObject('loginInfo');
            $rootScope.isLogin = false;
            //判断扫码跳转参数 证书详情扫码不跳证书列表，当前页直接使用证书
            $rootScope.scanFromCertDetail = false;
            $scope.showGuideVideo=false; //是否显示引导视频弹窗
            $rootScope.showGuideVideoTip=false; //引导视频弹窗是否今日不再提示
            //首页强制竖屏
             screen.orientation.unlock();
             screen.orientation.lock('portrait');
             $rootScope.homeCertShowUpdatePicAlert = false;// 华测证书下载需要更新资源的弹框开关

            if (JSON.stringify($rootScope.loginInfo) == '{}') {
                $rootScope.isLogin = false;
            } else {
                $rootScope.isLogin = true;
            }

            $scope.isDynamicBanner = false;
            $scope.banners = [
                {
                    bannerPath: 'img/Advertising/applyguide.png',
                    bannerUrl: 'https://zsfwpt.icinfo.cn/app/api/appquestion'
                },
                // {
                //     bannerPath: 'img/Advertising/home_banner_three.png',
                //     bannerUrl: ''
                // }
            ]

            // 获取native基础数据配置
            var getBaseConfig = function () {
                var returnFunc = function (baseData) {
                    $rootScope.appid = baseData.appid;
                    $rootScope.secret = baseData.secret;
                    $rootScope.zwwAppid = baseData.zwwAppid;
                    $rootScope.zwwSecret = baseData.zwwSecret;
                    $rootScope.deviceModelName = baseData.deviceModelName;
                    $rootScope.systemVersion = baseData.systemVersion;
                    $rootScope.uuid = baseData.uuid;
                    $rootScope.deviceAuthenticationType = baseData.deviceAuthenticationType;//0-生物识别都不支持 1-面容 2-指纹
                    $rootScope.appVersion = baseData.version;
                    if (cordova.platformId === 'android') {
                        $rootScope.urlConfig = {
                            "serverUrl": baseData.urlConfig.serverUrl,
                            "cloudCertUrl": baseData.urlConfig.cloudCertUrl,
                            "doDecDataUrl": baseData.urlConfig.cloudCertUrl,
                            "authCenterUrl" : baseData.urlConfig.authCenterUrl,
                            "scanUrl": baseData.urlConfig.scanUrl,
                            "OCRUrl": baseData.urlConfig.OCRUrl,
                            "CTIDAuthUrl": baseData.urlConfig.CTIDAuthUrl,
                            "msgCenterUrl": baseData.urlConfig.msgCenterUrl,
                            "TimeUrl": baseData.urlConfig.TimeUrl,
                            "frdecrUrl": baseData.urlConfig.frdecrUrl,
                            "stampUrl": baseData.urlConfig.stampUrl,
                            "letterUrl":baseData.urlConfig.letterUrl
                        }
                    }
                }

                nativeHelper.getBaseConfig({
                    data: [],
                    success: returnFunc
                });
            }
            getBaseConfig();

            // v2.9.7 点击补办弹窗提示观看引导视频
            $scope.clickApplyCert = function(){
                if (!$rootScope.loginInfo.userId) {
                    $scope.navigate('signIn');
                    return;
                }
             doCallEventTrack('2');
             let storeDateStr = localStorage.get('hiddenVideoToday');
             //是否今日不再提示判断
             if(storeDateStr == utility.todayDate()){
                $rootScope.applyCertType = 1; // 0 可申领的证书   1 可补办的证书
                if ($rootScope.loginInfo.realNameGrade != "1") {
                    $rootScope.identityAuthRootPage = "applyCertSearchV2";
                    $rootScope.showActive = true;
                    $rootScope.isIdentityAuth = true;
                }else{
                    nav.navigate('applyCertSearchV2');
                    var eventCounter = new Object();
                    eventCounter.page = "首页-证书补办";
                    MobclickAgent.onEventWithParameters("homeCertReissueEvent", eventCounter);
                }
             }else{
               $rootScope.privacyUpdatePopup = $ionicPopup.show({
                     templateUrl: 'html/home/particularAttentionV4.html',
                     cssClass: 'popup-home-tips',
               });
             }
            };
            //跳过 引导视频
            $rootScope.cancelVideoClick=function(){
                $rootScope.privacyUpdatePopup.close()
                doCallEventTrack('3');
                if ($scope.showGuideVideoTip) {
                   localStorage.set('hiddenVideoToday', utility.todayDate());
                }
                $scope.showGuideVideo=false;
               if (!$rootScope.loginInfo.userId) {
                    $scope.navigate('signIn');
                    return;
                }
                $rootScope.applyCertType = 1; // 0 可申领的证书   1 可补办的证书
                if ($rootScope.loginInfo.realNameGrade != "1") {
                    $rootScope.identityAuthRootPage = "applyCertSearchV2";
                    $rootScope.showActive = true;
                    $rootScope.isIdentityAuth = true;
                }else{
                    nav.navigate('applyCertSearchV2');
                    var eventCounter = new Object();
                    eventCounter.page = "首页-证书补办";
                    MobclickAgent.onEventWithParameters("homeCertReissueEvent", eventCounter);
                }
            }
            //观看 引导视频
            $rootScope.lookVideoClick=function(){
               $rootScope.privacyUpdatePopup.close()
               doCallEventTrack('4');
               if ($scope.showGuideVideoTip) {
                   localStorage.set('hiddenVideoToday', utility.todayDate());
               }
               //标识观看视频是首页跳转还是上一个页面返回
               $rootScope.isHomePageToVideo = true;
               nav.navigate('videoGuidance');
               //$scope.showGuideVideo=false;
            }
            //点击引导视频是否今日不再提示
            $rootScope.hiddenVideoPopToday = function () {
               $rootScope.showGuideVideoTip = !$rootScope.showGuideVideoTip;
            }
            //v2.9.8 新增冻结证书提示弹窗
            $rootScope.showHomeFrozenTip=false;
            $rootScope.colseHomeFrozenTip = function(){
                $rootScope.showHomeFrozenTip=false;
            }

            var showLetterGuide = function () {
                var time = utility.getCurrentTime();
                var hashdata = md5.createHash($rootScope.appid + time + $rootScope.secret);
                var params = {
                    'appid': $rootScope.appid,
                    'time': time,
                    'hashdata': hashdata,
                    'mobile': $rootScope.loginInfo.mobile
                }

                $rootScope.letterGuideMsg = '';
                $rootScope.letterUrl = '';

                requestWrapper.getAppRemind({ data: params, refresh: true })
                    .then(function (result) {
                        if (result.code == 200) {
                            $rootScope.letterGuideMsg = result.data.message || '';
                            $rootScope.letterUrl = result.data.url || '';
                            $rootScope.isShowLetterGuide = false;
                            
                            $rootScope.letterPopup = $ionicPopup.show({
                                templateUrl: 'html/home/letterGuide.html',
                                cssClass: 'popup-home-tips',
                            });
                        }
                    });
            }

            $rootScope.navToLetter = function () {
                if ($rootScope.loginInfo.realNameGrade != "1") {
                    // control.showPopup('请先完成实名认证', 3000);
                    // return;
                    $rootScope.identityAuthRootPage = "tab/home";
                    $rootScope.showActive = true;
                }else{

                    var url = '';
    
                    if ($rootScope.letterUrl.indexOf('?') == -1) {
                        url = $rootScope.letterUrl + '?token=' + $rootScope.loginInfo.token;
                    } else {
                        url = $rootScope.letterUrl + '&token=' + $rootScope.loginInfo.token;
                    }
                    var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=我的函证,clearcache=yes';
                    cordova.InAppBrowser.open(url, '_blank', operation);
                    $rootScope.letterPopup.close()
                }
            }

            $rootScope.closeGuide = function () {
                $rootScope.isShowLetterGuide = false;
                $rootScope.letterPopup.close()
            }

            $rootScope.closePrivacyUpdate = function () {
                localStorage.set('privacyUpdateDateV2',$rootScope.configInfo.agreementConfig.updateTime);
                $rootScope.privacyUpdatePopup.close()
                //我已知晓用户协议更新埋点
                doCallEventTrack('1');
            }

            var usageConfirm = function () {
                var confirm = function () {
                    localStorage.set('isfirstInstall', true);
                    if ('android' == cordova.platformId) {
                        var failFunc = function (error) {};
                        var successFunc = function (result) {}
                        var params = [];
                        nativeHelper.applyPermission({data: params, success: successFunc, fail: failFunc});
                    }
                };
                var cancel = function () {
                    $rootScope.rejectPolicy = true;
                    control.showConfirm7(confirm, () => { }, '同意', '不同意', '', 'html/other/agreementConfirm.html');
                };

                if ($rootScope.rejectPolicy) {
                    control.showConfirm7(confirm, cancel, '同意', '不同意', '', 'html/other/agreementConfirm.html');
                } else {
                    control.showConfirm7(cancel, confirm, '不同意', '同意', 'agree-information', 'html/other/usageConfirm.html');
                }
            }

            var firstInstall = localStorage.get('isfirstInstall');
            if (!firstInstall && !$rootScope.cancelSecond) {
                usageConfirm();
            }

            $rootScope.agreementClick = function (type) {
                if (type === 'appagreement') {
                    var url = window.currentUrl + '/app/api/appagreement';
                } else if(type == 'appprivacy'){
                    var url = window.currentUrl + '/app/api/appprivacy';
                }else{
                    var url = window.currentUrl + '/app/third-party-information-sharing.html';
                }

                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                cordova.InAppBrowser.open(url, '_blank', operation);
            }

            // 预警通知
            var sendAlertMsg = function (err) {
                $ionicLoading.hide();
                control.showPopup(err.errMsg, 2000);
                requestWrapper.sendMesToDingTalk("密码模块错误", "", err.errMsg);
            }
            if (!window.broadcaster.channelExists("sendAlertMsg")) {
                window.broadcaster.addEventListener("sendAlertMsg", sendAlertMsg);
            }

            var noMentionToday = function () {
                let storeDateStr = localStorage.get('noMentionToday');
                return storeDateStr == utility.todayDate()
            }
            var isNoMentionToday = noMentionToday();
            $rootScope.agreement = function (type) {
                var url = window.currentUrl + '/app/api/' + type;
                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                cordova.InAppBrowser.open(url, '_blank', operation);
            }

            var setDefaultConfigInfo = function () {
                if (!$rootScope.configInfo) {
                $rootScope.noticeArray = [{
                    noticeTitle: 'e照通申领移动证书，快!好！省!',
                        noticeUrlV1:''
                    }]
                    $rootScope.configInfo = {
                        ocrAppId: '1106835427',
                        ocrAppKey: 'Nz4rzhucmXq5SMkf',
                        faceRecognition: '0',
                    };

                    $rootScope.openBiometryAndroid = '0';//是否打开安卓生物特征识别
                    $rootScope.openBiometryIOS = '0';//是否打开苹果生物特征识别

                }
            };
            setDefaultConfigInfo();

            $rootScope.authFaceMax = 3;//授权领证刷脸次数
            $rootScope.materialFaceMax = 3;//材料领证刷脸次数
            $rootScope.riseLevelFaceMax = 3;//提升实名等级刷脸次数

            $rootScope.faceReApplyDate = null;//重新制证需要刷脸日期（天）
            $rootScope.faceValidTime = 30;//刷脸成功后的有效时间（小时）

            $rootScope.SDKVersion = "V2";//密码模块版本
            //首页通知弹框
            $rootScope.showHomePopup = true;
            var showPopout = function () {
                if ($rootScope.configInfo.popout && $rootScope.configInfo.popout !== null && $rootScope.configInfo.popout !== '' && $rootScope.showHomePopup) {
                    control.showCustomAlert('test', 'html/home/popupHomeNotice.html', '知道了', 'popup-btn-positive', function () { return; });
                    $rootScope.showHomePopup = false;
                }
            }

            $scope.hasValidCert = false;
            $scope.validCertList = [];
            // 是否显示有证书即将到期的提示
            $scope.showCertAlert = false;
            $rootScope.searchRecord = { 'key': '' };


            var getCertValidityV2 = function (operaType) {

                var eventCounter = new Object();
                eventCounter.page = "V2接口全部证书校验";
                MobclickAgent.onEventWithParameters("CertValidityV2AllInterface", eventCounter);

                var certSnList = [];
                $rootScope.localCertList.forEach(function (v) {
                    certSnList.push(v.serialNum);
                });
                var params = [certSnList,operaType];
                var successFunc = function (result) {
                    if (result == null || angular.equals({}, result)) {
                        getWaitDownCertByOrderAndAuthRecord();
                        control.showPopup('本地证书校验失败', 3000);
                        return;
                    };
                    if (result.success) {
                        // 延期证书
                        var delayCertList = [];
                        // 变更证书
                        var changeCertList = [];
                        // 有效证书
                        var effectiveCertList = [];
                        $rootScope.delayCertNum = 0;
                        $rootScope.changeCertNum = 0;
                        result.value.forEach(function (c) {
                            $rootScope.localCertList.forEach(function (l) {
                                if (l.serialNum == c.certSn) {
                                    l.isValid = c.valid;
                                    l.operation = c.operation;
                                    l.canPostpone = c.canPostpone;
                                    l.canModify = c.canModify;
                                    l.reason = c.reason;
                                    if (typeof c.category != 'undefined') {
                                        l.category = c.category;
                                    };
                                    if (typeof c.categoryBh != 'undefined') {
                                        l.categoryBh = c.categoryBh;
                                    };
                                    if (typeof c.yearSerEnd != 'undefined') {
                                        l.yearSerEnd = c.yearSerEnd;
                                    };
                                    if (typeof c.annueeFee != 'undefined') {
                                        l.annueeFee = c.annueeFee;
                                    };

                                    l.corpid = c.corpid;
                                    l.existAnnueeFee = c.existAnnueeFee;
                                    l.refuseReason = c.refuseReason;

                                    // 区分有效证书和失效证书
                                    if (l.isValid) {
                                        l.certTipStatus = c.certTipStatus;
                                        l.sourceType = "tab/home";
                                        // certTipStatus 0过期 1有效,2即将过期 3变更 4 待安装
                                        if(l.certTipStatus=='0'){
                                            $rootScope.delayCertNum++;
                                            delayCertList.unshift(l);
                                        }else if(l.certTipStatus=='2'){
                                            if (!isNoMentionToday) {
                                                $scope.showCertAlert = true;
                                            }else{
                                                $scope.showCertAlert = false;
                                            }
                                            $rootScope.delayCertNum++;
                                            delayCertList.unshift(l);
                                        }else if(l.certTipStatus=='3'){
                                            $rootScope.changeCertNum++;
                                            changeCertList.unshift(l);
                                        }else if(l.certTipStatus=='1'){
                                            effectiveCertList.unshift(l);
                                        }
                                        $scope.validCertList.push(l);
                                    }
                                }
                            });
                        })

                        var tempCertList = [];
                        effectiveCertList.forEach(function (v) {
                            tempCertList.unshift(v);
                        });
                        changeCertList.forEach(function (v) {
                            tempCertList.unshift(v);
                        });
                        delayCertList.forEach(function (v) {
                            tempCertList.unshift(v);
                        });

                        $scope.validCertList = tempCertList;

                        if($scope.validCertList.length > 0){
                            $scope.hasValidCert = true;
                        }
                    } else {
                        control.showPopup(result.msg, 3000);
                    }
                    getWaitDownCertByOrderAndAuthRecord();
                    if ($scope.showCertAlert) {
                        control.showCustom4Popup('html/home/homeConfirmPopup.html');
                        return;
                    }
                }
                var failFunc = function (error) {
                    getWaitDownCertByOrderAndAuthRecord();
                    control.hideLoading();
                    control.showPopup(error.msg, 2000);
                };
                nativeHelper.getCertValidityV2({ data: params, success: successFunc, fail: failFunc });
            };

            // 获取待授权的业务单和授权单
            var getWaitDownCertByOrderAndAuthRecord = function () {
                var params = [
                    $rootScope.loginInfo.accountId,
                    $rootScope.loginInfo.mobile,
                    $rootScope.loginInfo.idCard,
                    ''
                ];
                var allCertList = $scope.validCertList;
                var successFunc = function (result) {
                    if (result == null || angular.equals({},result)) {
                        control.showPopup('服务出错啦', 3000);
                         return;
                    };
                    if (result.success) {
                        if (result.value != null && !angular.equals({},result)) {
                            result.value.forEach(function(d) {
                                 d.sourceType = "tab/home";
                                 if(d.downloadType == '1'&&(d.netType == '6'||d.netType == '7')){
                                    d.certTipStatus = "4";
                                    allCertList.unshift(d);
                                 }else{
                                    var isValidHaveCert = false;// 是否有有效证书
                                    $scope.validCertList.forEach(function(l) {
                                       if(d.corpid == l.corpid){
                                           isValidHaveCert = true
                                       }
                                    });
                                    // 无有效证书
                                    if(!isValidHaveCert){
                                       d.certTipStatus = "4";
                                       allCertList.unshift(d);
                                    }
                                 }
                            });
                        }
                        $scope.scrollCertList = allCertList
                        $rootScope.certOperationList = $scope.scrollCertList;
                        $rootScope.isGetHomeCertApi = false;
                        if($scope.scrollCertList.length > 0){
                            $scope.hasCert = true;
                        }
                    }
                    if(!result.success){
                        $scope.scrollCertList = allCertList
                        $rootScope.certOperationList = $scope.scrollCertList;
                        $rootScope.isGetHomeCertApi = false;
                        if($scope.scrollCertList.length > 0){
                            $scope.hasCert = true;
                        }
                    }
                }
                var failFunc = function (e) {
                    $scope.scrollCertList = allCertList
                    $rootScope.certOperationList = $scope.scrollCertList;
                    $rootScope.isGetHomeCertApi = false;
                    if($scope.scrollCertList.length > 0){
                        $scope.hasCert = true;
                    }
                };
                nativeHelper.getWaitDownCertByOrderAndAuthRecord({ data: params, success: successFunc, fail: failFunc });
            }

            var getCertList = function () {

                if (!$rootScope.isLogin) {
                    return;
                }

                var params = [$rootScope.loginInfo.accountId];
                var successFunc = function (result) {
                    if(result != null){
                        $rootScope.localCertList = result;
                        if ($rootScope.localCertList.length > 0) {
                            getCertValidityV2("all");
                        }else{
                            getWaitDownCertByOrderAndAuthRecord();
                        }
                    }

                }
                var failFunc = function (e) {
                  getWaitDownCertByOrderAndAuthRecord();
                };
                nativeHelper.getLocalCertList({ data: params, success: successFunc, fail: failFunc });
            }



            //getCertList();
            var getConfigInfo = function () {
                var successFunc = function (result) {
                    if (result == null || angular.equals({}, result)) {
                        control.showPopup('获取系统配置信息失败', 2000);
                        return;
                    }

                    if (result.success === "true") {
                        $rootScope.configInfo = result;
                        $rootScope.noticeArray = result.noticeArray
                        
                        $rootScope.privacyUpdateDate = localStorage.get('privacyUpdateDateV2');
                        if($rootScope.configInfo!=null&&$rootScope.configInfo.agreementConfig!=null&&$rootScope.configInfo.agreementConfig.isUpdate == "1"&&$rootScope.privacyUpdateDate!=$rootScope.configInfo.agreementConfig.updateTime){
                            $rootScope.privacyUpdatePopup = $ionicPopup.show({
                                templateUrl: 'html/home/privacyUpdate.html',
                                cssClass: 'popup-home-tips',
                            });
                        }else{
                            if ($rootScope.loginInfo.userId && $rootScope.isShowLetterGuide) {
                                showLetterGuide();
                            }
                        }

                        if($rootScope.configInfo!=null&&$rootScope.configInfo.newLiveConfig!=null&&$rootScope.configInfo.newLiveConfig.isNewLive == "1"){
                            $rootScope.isNewLive = "1";
                        }else{
                            $rootScope.isNewLive = "0";
                        }

                        if($rootScope.configInfo!=null&&$rootScope.configInfo.agreementConfig!=null&&$rootScope.configInfo.agreementConfig.certReissueVideoUrl != null){
                            $rootScope.certReissueVideoUrl = $rootScope.configInfo.agreementConfig.certReissueVideoUrl;
                        }else{
                            // 默认视频
                            $rootScope.certReissueVideoUrl = "https://xz-fzxw.oss-cn-hangzhou.aliyuncs.com/video/ydzsbb.mp4";
                        }
                        $rootScope.authFaceMax = parseInt(result.authFaceMax);//授权领证刷脸次数
                        $rootScope.materialFaceMax = parseInt(result.materialFaceMax);//材料领证刷脸次数
                        $rootScope.riseLevelFaceMax = parseInt(result.riseLevelFaceMax);//提升实名等级刷脸次数
                        if(result.homeCertRefreshIntervalTime==undefined||result.homeCertRefreshIntervalTime==null||result.homeCertRefreshIntervalTime==''){
                            $rootScope.homeCertRefreshIntervalTime = 60;//首页刷新时间间隔（秒）
                        }else{
                            $rootScope.homeCertRefreshIntervalTime = parseInt(result.homeCertRefreshIntervalTime);//首页刷新时间间隔（秒）
                        }

                        $rootScope.faceReApplyDate = result.faceReApplyDate == null ? result.faceReApplyDate : parseInt(result.faceReApplyDate);//重新制证需要刷脸日期（天）
                        $rootScope.faceValidTime = result.faceValidTime;//刷脸成功后的有效时间（小时）

                        $rootScope.SDKVersion = result.SDKVersion;//密码模块版本
                        $rootScope.expirdShow = result.expirdShow;
                        
                        // expirdShow为1可以显示证书即将过期弹窗
                        if ("1" == result.expirdShow) {
                            // 获取证书列表 判断是否有即将过期证书
                            // $rootScope.noAlert用于控制app打开只弹窗1次
                            if (!$rootScope.noAlert) { 
                                $rootScope.noAlert = true;
                            }
                        }

                        // getCertList();

                        $rootScope.openBiometryAndroid = result.openBiometryAndroid;//是否打开安卓生物特征识别
                        $rootScope.openBiometryIOS = result.openBiometryIOS;//是否打开苹果生物特征识别

                        $rootScope.realPersonAuthValidTime = result.realPersonAuthValidTime;//活体有效时间

                        if(result.banners != undefined && result.banners != null && result.banners.length > 0){
                            // if(result.banners[0].bannerBase64 != undefined && result.banners[0].bannerBase64 != '' && result.banners[0].bannerBase64 != null){
                                // 组件至少支持3张
                                $scope.banners = result.banners;
                                try{
                                    if(result.banners.length==1){
                                        result.banners.forEach(function (r) {
                                            $scope.banners.push(r)
                                            $scope.banners.push(r)
                                        });
                                    }else if(result.banners.length==2){
                                        result.banners.forEach(function (r) {
                                            $scope.banners.push(r)
                                        });
                                    }
                                }catch(e){}
                                $scope.isDynamicBanner = true;
                                
                                $ionicSlideBoxDelegate.update(); 
                                $ionicSlideBoxDelegate.loop(true);
                            // }
                        }
                    }
                    else {
                        control.showPopup(result.msg, 2000);
                    }
                };

                var failFunc = function (error) {
                    control.showPopup('获取系统配置信息失败002-' + error.errorMsg, 2000);
                };

                nativeHelper.getConfigInfo({ data: [], success: successFunc, fail: failFunc });
            }

            if ($rootScope.isLogin) {
                getConfigInfo();
            }

            $scope.searchEnterprise = function () {
                if (!$rootScope.loginInfo.userId) {
                    $scope.navigate('signIn');
                    return;
                }
                $scope.navigate('searchEnterprise');
            }
            var getUserToken = function () {
                if (undefined == $rootScope.loginInfo.token || "" == $rootScope.loginInfo.token) {
                    var successFunc = function (result) {
                        if (undefined == result.token || "" == result.token) {
                            $scope.navigate('signIn');
                        } else {chu
                            $rootScope.loginInfo.token = result.token;
                            localStorage.setObject('loginInfo', $rootScope.loginInfo);
                        }
                    }
                    var failFunc = function () { }
                    nativeHelper.getUserToken({ data: [], success: successFunc, fail: failFunc });
                }
            }

            if ($rootScope.isLogin) {
                getUserToken();
            }

            $scope.localCertList = localStorage.getObject($rootScope.loginInfo.accountId);
            if (JSON.stringify($scope.localCertList) == '{}') $scope.localCertList = [];

            var loadLocalCertListData = function () {
                control.showTitleLoading("证书数据迁移中请勿退出...");
                var params = [$rootScope.loginInfo.accountId, $scope.localCertList];
                var successFunc = function (result) {
                    control.hideLoading();
                    localStorage.setObject("backupCertInfo", $scope.localCertList)
                    localStorage.deleteItem($rootScope.loginInfo.accountId);
                }

                var failFunc = function (error) {
                    control.hideLoading();
                    control.showPopup(error, 2000);
                };

                nativeHelper.loadLocalCertListData({ data: params, success: successFunc, fail: failFunc });
            }

            if (cordova.platformId === 'android' && $rootScope.isLogin) {
                loadLocalCertListData();
            }

            //订单号
            $rootScope.orderNo = '';

            var openApplication = function () {
                var params = [$rootScope.loginInfo.accountId];
                var successFunc = function (result) {
                    $rootScope.phoneUUID = result.UUID;
                    $rootScope.appVersion = result.version;
                    //$rootScope.deviceModel = result.deviceModel;//机型
                }

                var failFunc = function (error) {
                    control.showPopup(error.msg, 2000);
                };

                nativeHelper.openApplication({ data: params, success: successFunc, fail: failFunc });
            };

            if ($rootScope.isLogin) {
                openApplication();
                utility.checkUpdate();
                if ($rootScope.isHomeCertRefresh()) {
                    getCertList();
                }else{
                    $scope.scrollCertList = $rootScope.certOperationList;
                    if($scope.scrollCertList.length > 0){
                        $scope.hasCert = true;
                    }
                }
            }

            $scope.isHiddenToday = false;
            $rootScope.hiddenToday = function () {
                $scope.isHiddenToday = !$scope.isHiddenToday;
                var checkEle = document.getElementById('check-mention');
                if ($scope.isHiddenToday) {
                    checkEle.setAttribute('class', 'check-selected');
                } else {
                    checkEle.setAttribute('class', 'check-default');
                }
            }
            $rootScope.lClick = function () {
                if ($scope.isHiddenToday) {
                    localStorage.set('noMentionToday', utility.todayDate());
                }
                control.hideCustomPopup();
            }
            $rootScope.rClick = function () {
                if ($scope.isHiddenToday) {
                    localStorage.set('noMentionToday', utility.todayDate());
                }
                control.hideCustomPopup();
                $rootScope.showDelayCert = true;
                $scope.navigate('certManage');
            }

            //扫一扫
            $scope.scanQRcode = function () {
                if (!$rootScope.loginInfo.userId) {
                    $scope.navigate('signIn');
                    return;
                }

                var params = [];
                var successFunc = function (result) {
                }
                var failFunc = function (error) {
                    control.showPopup(error.msg, 2000);
                };
                nativeHelper.navToScanView({ data: params, success: successFunc, fail: failFunc });
            };

            var showLocalCertList = function (e) {
                $scope.$apply(function () {
                    if (e.scanResult.indexOf("type") == -1) {
                        control.showPopup(e.scanResult, 2000)
                    } else {
                        var scanResult = JSON.parse(e.scanResult);
                        $rootScope.curQRCodeInfo = scanResult;
                        if (scanResult.type == 'elicense') {
                            $scope.navigate('businessLicDiscern');
                            return;
                        }

                        //判断如果是证书详情扫码跳详情页，其他跳证书列表页
                        if($rootScope.scanFromCertDetail){
                             if(typeof (scanResult.versions) == "undefined" || scanResult.versions == "1"){
                                $rootScope.certDetailScanResult = "true";
                             }else{
                                $scope.navigate('scanPrompt');
                             }

                        }else{
                            (typeof (scanResult.versions) == "undefined" || scanResult.versions == "1") ? nav.go('showLocalCertList') : nav.go('scanPrompt');
                        }
                    }
                });
            };

            window.broadcaster.addEventListener("showLocalCertList", showLocalCertList);

            $scope.customerService = function () {
                if (!$rootScope.loginInfo.userId) {
                    $scope.navigate('signIn');
                    return;
                }

                var url = 'https://ics.idinfo.cn/IntelQA/login/getUserInfo.action?loginName=' + $rootScope.loginInfo.mobile;

                var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=' + '移动证书';
                cordova.InAppBrowser.open(url, '_blank', operation);
                var eventCounter = new Object();
                eventCounter.page = "首页-在线客服";
                MobclickAgent.onEventWithParameters("homeOnlineServiceEvent", eventCounter);
            }  
            
            $scope.advertisingClick = function (url,index) {
                // if (!$rootScope.loginInfo.userId) {
                //     $scope.navigate('signIn');
                //     return;
                // }
                //判断是否同意隐私政策，同意后调用埋点接口
               var firstInstall=localStorage.get('isfirstInstall');
               if(firstInstall){
                  //点击banner后台埋点统计
                  doCallEventTrack('0');
                  //获取banner数据成功之后，埋点统计前4张焦点图
                  if($scope.isDynamicBanner){
                    switch(index){
                      case 0:
                              var eventCounter = new Object();
                              eventCounter.page = "首页-焦点图1";
                              MobclickAgent.onEventWithParameters("homeBanner1Event", eventCounter);
                        break;
                      case 1:
                              var eventCounter = new Object();
                              eventCounter.page = "首页-焦点图2";
                              MobclickAgent.onEventWithParameters("homeBanner2Event", eventCounter);
                        break;
                      case 2:
                              var eventCounter = new Object();
                              eventCounter.page = "首页-焦点图3";
                              MobclickAgent.onEventWithParameters("homeBanner3Event", eventCounter);
                        break;
                      case 3:
                              var eventCounter = new Object();
                              eventCounter.page = "首页-焦点图4";
                              MobclickAgent.onEventWithParameters("homeBanner4Event", eventCounter);
                        break;

                    }
                  }
               }

                if (url.indexOf('http') !== -1) {
                    var operation = 'location=no,toolbartranslucent=no,toolbar=yes,toolbarcolor=#ffffff,clearcache=yes,clearsessioncache=yes,closebuttoncolor=#000000,hidenavigationbuttons=yes,toolbarposition=top,closebuttoncaption=,iscustomnav=yes,customertitle=' + '移动证书';
                    if (cordova.platformId === 'android') {
                        operation ='location=no,toolbartranslucent=no,toolbar=yes,toolbarcolor=#ffffff,clearcache=yes,clearsessioncache=yes,closebuttoncolor=#000000,hidenavigationbuttons=yes,toolbarposition=top,closebuttoncaption=<,iscustomnav=yes,title=' + '移动证书';
                    }
                    cordova.InAppBrowser.open(url, '_blank', operation);
                }
            };

            $scope.navigate = function (state) {
                try {
                clearInterval($scope.timer);
                } catch(e){}
                nav.navigate(state);
            };

            $scope.applyCert = function(type){
                if (!$rootScope.loginInfo.userId) {
                    $scope.navigate('signIn');
                    return;
                }

                $rootScope.applyCertType = type; // 0 可申领的证书   1 可补办的证书

                if ($rootScope.loginInfo.realNameGrade != "1") {
                    $rootScope.identityAuthRootPage = "applyCertSearchV2";
                    $rootScope.showActive = true;
                    $rootScope.isIdentityAuth = true;
                }else{
                    nav.navigate('applyCertSearchV2');
                    if(type==0){
                        var eventCounter = new Object();
                        eventCounter.page = "首页-证书申领";
                        MobclickAgent.onEventWithParameters("homeCertApplyEvent", eventCounter);
                    }else if(type==1){
                        var eventCounter = new Object();
                        eventCounter.page = "首页-证书补办";
                        MobclickAgent.onEventWithParameters("homeCertReissueEvent", eventCounter);
                    }
                }
            }

            $rootScope.navToHome = function () {
                $rootScope.isIdentityAuth = false;
                var confirm = function () {
                    $rootScope.isNeedAuthFace = true;
                    $scope.navigate('tab/home');
                };
                var cancel = function () { };
            
                control.showConfirm('确认返回首页', confirm, cancel);
            };

            $rootScope.navToHomeV2 = function () {
                $rootScope.isIdentityAuth = false;
                $scope.navigate('tab/home');
            };

             $rootScope.navToCertManage = function () {
                 control.hideCustomPopup();
                 $state.go('certManage', {
                   certManageSearchKey: $rootScope.deleteCertSnfromPopup
                 });
             };

            //中转友盟消息页面跳转
            var openUmengNotificationPath = function (e) {
                try {
                      $scope.$apply(function () {
                        $scope.navigate('messageCenter');
                      });
//                    $scope.$apply(function () {
//                        console.log('openUmengNotificationPath:' + JSON.stringify(e))
//                        if(e){
//                            var extra = e.extra;
//                            console.log('extra:' + JSON.stringify(extra));
//                            if(extra){
//                                var data = extra.data;
//                                console.log('data:' + JSON.stringify(data));
//                                if(!data){
//                                    $scope.$apply(function () {
//                                        $scope.navigate('messageCenter');
//                                    })
//                                }
//
//                                var type = data.type;// delay  change
//                                var certSerial = data.certSerial;
//                                console.log('type:' + type);
//                                console.log('certSerial:' + certSerial);
//                                if('delay' == type || 'change' == type){
//                                    if (!$rootScope.isLogin) {
//                                        return;
//                                    }
//
//                                    var params = [$rootScope.loginInfo.accountId];
//                                    var successFunc = function (result) {
//                                        console.log('result:' + JSON.stringify(result));
//                                        if(result != null &&  result != [] && result.length > 0){
//                                            var certList = result;
//                                            var hasCert = false;
//                                            for(var i = 0; i < certList.length; i++) {
//                                                if(certList[i].serialNum === certSerial) {
//                                                    hasCert = true;
//                                                    break;
//                                                }
//                                            }
//                                            console.log('hasCert:' + hasCert);
//                                            if(hasCert){
//                                                if('delay' == type){
//                                                    $scope.$apply(function () {
//                                                        $rootScope.showDelayCert = true;
//                                                        $state.go('certManage', {
//                                                            certManageSearchKey: certSerial
//                                                        });
//                                                    })
//                                                }else{
//                                                    $scope.$apply(function () {
//                                                        $scope.navigate('certManage');
//                                                    })
//                                                }
//                                            }else{
//                                                $scope.$apply(function () {
//                                                    $scope.navigate('businessManage');
//                                                })
//                                            }
//                                        }else{
//                                            $scope.$apply(function () {
//                                                $scope.navigate('businessManage');
//                                            })
//                                        }
//                                    }
//                                    var failFunc = function (e) {
//                                        $scope.$apply(function () {
//                                            $scope.navigate('certManage');
//                                        })
//                                    };
//                                    nativeHelper.getLocalCertList({ data: params, success: successFunc, fail: failFunc });
//                                }else {
//                                    $scope.$apply(function () {
//                                        $scope.navigate('messageCenter');
//                                    })
//                                }
//                            }else{
//                                $scope.navigate('messageCenter');
//                            }
//                        }else{
//                            $scope.navigate('messageCenter');
//                        }
//                    });
                } catch (error) {
                    console.log('processDelay:' + error)   
                }
            };

            window.broadcaster.addEventListener("openUmengNotificationPath", openUmengNotificationPath);

            //检查是否存在未读消息
            var checkUnreadNotification = function () {
                //control.showLoading();
                var params = [$rootScope.loginInfo.mobile];
                var successFunc = function (result) {
                    control.hideLoading();
                    if (result == null || angular.equals({},
                        result)) {
                        control.showPopup('服务出错啦', 3000);
                    }
                    if (result.rslt == 'success') {
                        $scope.unread = result.data.unread == "1";
                    }

                    if (result.rslt == 'fail') {
                        //control.showPopup(result.errorMsg, 2000);
                    }
                }
                var failFunc = function (error) {
                    //control.hideLoading();
                    //control.showPopup(error.msg, 2000);
                };
                nativeHelper.checkUnreadNotification({
                    data: params,
                    success: successFunc,
                    fail: failFunc
                });
            }

            var path = $stateParams.pagePath;
            if (path == "messageCenter") {
                checkUnreadNotification();
            }

            $scope.accountClick = function () {
                if (!$rootScope.loginInfo.userId) {
                    $scope.navigate('signIn');
                    return;
                }
                $scope.navigate('tab/account');
            }

            $scope.messageCenterClick = function () {
                if (!$rootScope.loginInfo.userId) {
                    $scope.navigate('signIn');
                    return;
                }
                $scope.navigate('messageCenter');
                var eventCounter = new Object();
                eventCounter.page = "首页-消息";
                MobclickAgent.onEventWithParameters("homeMessageEvent", eventCounter);
            }

            $scope.certClick = function (isExpired) {
                if (!$rootScope.loginInfo.userId) {
                    $scope.navigate('signIn');
                    return;
                }

                $rootScope.showDelayCert = false;
                $rootScope.showChangeCert = false;

                if('true' == isExpired){
                    $rootScope.showDelayCert = true;
                    var eventCounter = new Object();
                    eventCounter.page = "首页-证书延期";
                    MobclickAgent.onEventWithParameters("homeCertExtensionEvent", eventCounter);
                } else if('false' == isExpired){
                    $rootScope.showChangeCert = true;
                    var eventCounter = new Object();
                    eventCounter.page = "首页-证书变更";
                    MobclickAgent.onEventWithParameters("homeCertChangeEvent", eventCounter);
                }else{
                    var eventCounter = new Object();
                    eventCounter.page = "首页-全部证书";
                    MobclickAgent.onEventWithParameters("homeCertAllEvent", eventCounter);
                }
                $scope.navigate('certManage');
            }
//            //我的证书操作 安装 延期 变更 使用
//            $scope.certOperation = function (item) {
//                if(item.certTipStatus == "4"){ // 安装
//
//                }else if(item.certTipStatus == "0"||item.certTipStatus == "2"){ // 延期
//
//                }else if(item.certTipStatus == "3"){ // 变更
//
//                }else if(item.certTipStatus == "1"){ // 使用
//
//                }
//            }
            var orderNoData; // 下载证书的订单信息
            // 下载证书
            $scope.createBusinessOrder = function (item) {
                //V2.9.8判断证书是否被冻结  certFrozen==1 冻结
                if(item.certFrozen=='1'){
                    $rootScope.showHomeFrozenTip=true;
                   return;
                }
                var eventCounter = new Object();
                eventCounter.page = "首页-证书安装";
                MobclickAgent.onEventWithParameters("homeCertInstallEvent", eventCounter);
                var orderNo = ""
                var type = ""// 1 业务单  2 授权单
                if(item.downloadType=='0'){// 业务单
                    type = "1";
                    orderNo = item.orderNo;
                }else if(item.downloadType=='1'){
                    type = "2";
                    orderNo = item.authId;
                }
                if(validate.isStrEmpty(item.uniscid)){
                    downloadLogic.downloadCertLogic(item);
                    return;
                }
                orderNoData = item;
                var params = [item.uniscid,type,orderNo];
                var successFunc = function (result) {
                    if(result.success){
                         downloadLogic.downloadCertLogic(item);
                    }else{
                         control.hideLoading();
                         control.showPopup(result.msg, 2000);
                         setTimeout(function () {
                            getCertList();
                         }, 2000);
                    }
                }
                var failFunc = function (e) {
                    control.hideLoading();
                    control.showPopup(e.msg, 2000);
                };
                nativeHelper.checkEntState({ data: params, success: successFunc, fail: failFunc });
            }


            /**
             *证书使用
             **/
             $scope.certUse= function(currentCert){
                var eventCounter = new Object();
                eventCounter.page = "首页-证书详情";
                MobclickAgent.onEventWithParameters("homeCertUseEvent", eventCounter);
                $rootScope.curManagedCert = currentCert;
                nav.navigate('certDetail');
             }


            //续费
            var navCertDelay = function (curCert) {
                if (2 == curCert.existAnnueeFee) {
                     control.showPopup(curCert.refuseReason, 3000);
                     return;
                }
                $rootScope.certAnnualFeeInfo = {
                     entName: curCert.entName,
                     uniscid: curCert.orgCode,
                     operator: '',
                     cardId: '',
                     parentPage: 'tab/home',
                     corpid: curCert.corpid,
                };
                nav.navigate('confirmPayInfo');
            }


            $scope.recordClick = function () {
                if (!$rootScope.loginInfo.userId) {
                    $scope.navigate('signIn');
                    return;
                }
                
                if ($rootScope.loginInfo.realNameGrade != "1") {
                    $rootScope.identityAuthRootPage = "tab/home";
                    $rootScope.showActive = true;
                }else{
                    $scope.navigate('authorizationRecord');
                    var eventCounter = new Object();
                    eventCounter.page = "首页-授权管理";
                    MobclickAgent.onEventWithParameters("homeAuthorizationRecordEvent", eventCounter);
                }
            }

            $scope.businessManageClick = function () {
                if (!$rootScope.loginInfo.userId) {
                    $scope.navigate('signIn');
                    return;
                }

                $scope.navigate('businessManage');
                var eventCounter = new Object();
                eventCounter.page = "首页-业务管理";
                MobclickAgent.onEventWithParameters("homeBusinessManageEvent", eventCounter);
            }

            $scope.myLetters = function () {
                if (!$rootScope.loginInfo.userId) {
                    $scope.navigate('signIn');
                    return;
                }

                if ($rootScope.loginInfo.realNameGrade != "1") {
                    $rootScope.identityAuthRootPage = "tab/home";
                    $rootScope.showActive = true;
                }else{
                    // 我的函证
                    console.log('$rootScope.loginInfo.token - ' + $rootScope.loginInfo.token);
                    var url = $rootScope.configInfo.letterUrl;

                    if (!url) {
                        control.showPopup('函证地址错误，无法跳转', 2000);
                        return;
                    }

                    url = url + '?token=' + $rootScope.loginInfo.token;
                    var operation = 'location=no,toolbar=no,toolbarposition=top,closebuttoncaption=关闭,title=我的函证,clearcache=yes';
                    cordova.InAppBrowser.open(url, '_blank', operation);
                    var eventCounter = new Object();
                    eventCounter.page = "首页-涵证";
                    MobclickAgent.onEventWithParameters("homeLetterEvent", eventCounter);
                }
            }

            $rootScope.cancelOnClick = function () {
                control.hideCustomPopup()
                return;
            }

            $rootScope.isIdentityAuth = false;
            $scope.forIdentityAuth = function () {
                $rootScope.identityAuthRootPage = "tab/home";
                // 直接去实名  无需二次弹框
                $rootScope.faceAuth();
                var eventCounter = new Object();
                eventCounter.page = "首页-去实名";
                MobclickAgent.onEventWithParameters("homeGoAuthenticationEvent", eventCounter);
            }

            $scope.toApply = function(){
                // 当前用户当前设备有没领过新领，否则去补办
                if($scope.hasCert){
                    $scope.applyCert(1);
                }else{
                    $scope.applyCert(0);
                }
            }

            //获取消息列表
            var getMsgList = function (pageSize, type) {
                var params = [$rootScope.loginInfo.mobile, 1, pageSize, type];
                var successFunc = function (result) {
                    if (result == null || angular.equals({}, result)) {
                        $scope.hasUnreadMsg = false;
                        return;
                    }
                    if (result.rslt == 'success') {
                        $scope.$apply(function () {
                            if(result.data.total > 0){
                                $scope.hasUnreadMsg = true;
                            }
                        });
                    }
                }

                var failFunc = function (error) {
                    control.hideLoading();
                    control.showPopup(error.msg, 2000);
                };

                nativeHelper.getNotificationMsgList({ data: params, success: successFunc, fail: failFunc });
            };

//            if ($rootScope.isLogin) {
//                getMsgList(10,'unread');
//            }
            //后台通用埋点接口  0：点击banner图 1：点击我已知晓用户协议更新 2：点击首页补办 3：点击跳过引导视频 4：点击观看视频
            var doCallEventTrack = function (type) {
                        var params = [type];
                        var successFunc = function (result) {
                                if (result == null || angular.equals({}, result)) {
                                    control.showPopup('服务出错啦', 3000);
                                    return;
                                }
                            }

                        var failFunc = function (result) {
                            //control.showPopup(result.msg, 3000);
                        };

                        nativeHelper.doCallEventTrack({ data: params, success: successFunc, fail: failFunc });
                    };
                    // 华测证书需要更新资料
                    $scope.doUploadPic = function () {
                        $rootScope.updatePictures = {
                             businessLicensePic: '',
                             IDCardFrontPic: '',
                             IDCardBackPic: '',
                             authorizationPic: '',
                             uploadFrom: '',
                             orderNo:'',
                        }
                        $rootScope.updatePictures.uploadFrom = 'tab/home';
                        $rootScope.updatePictures.orderNo = orderNoData.orderNo;
                        //非个人 上传营业执照/身份证正反面
                        nav.navigate("uploadBusinessLicense");
                    }
        }]);
})();
  
