(function () {
    "use strict"

    angular.module('starter')
        .factory('url', ['$rootScope' , function ($rootScope) {
            if (cordova.platformId === 'android') {
                var serverUrl = $rootScope.urlConfig.serverUrl;
                var cloudCertUrl = $rootScope.urlConfig.cloudCertUrl;
                var doDecDataUrl = $rootScope.urlConfig.doDecDataUrl;
                var authCenterUrl = $rootScope.urlConfig.authCenterUrl;
                var scanUrl = $rootScope.urlConfig.scanUrl;
                var OCRUrl = $rootScope.urlConfig.OCRUrl;
                var CTIDAuthUrl = $rootScope.urlConfig.CTIDAuthUrl;
                var msgCenterUrl = $rootScope.urlConfig.msgCenterUrl;
                var TimeUrl = $rootScope.urlConfig.TimeUrl;
                var frdecrUrl = $rootScope.urlConfig.frdecrUrl;
                var stampUrl = $rootScope.urlConfig.stampUrl;
                var letterUrl = $rootScope.urlConfig.letterUrl;
            }else{
                // var serverUrl = 'http://test.icinfo.cn:8183/';
                var serverUrl = 'http://192.168.1.240:8085/';
                var cloudCertUrl = 'http://115.238.48.66:8180/V3/cloud/new/DECRYPT';
                var doDecDataUrl = 'http://115.238.48.66:8582/api/openService/doDecData';
                var authCenterUrl = 'https://test.icinfo.cn:9443/';
                var scanUrl = 'http://115.238.48.66:28010/';
                var OCRUrl = 'http://115.238.48.66:8799/';
                var CTIDAuthUrl = 'http://115.238.48.66:8085/';
                var msgCenterUrl = 'http://115.238.48.66:8788/';
                var TimeUrl = 'http://115.238.48.66:7081/';
                var frdecrUrl = 'http://115.238.48.66:8582/';
                var stampUrl = 'http://115.238.48.66:8099/';
                var letterUrl = 'https://test.icinfo.cn:9443/ezthz/';

                // var serverUrl = 'https://zsfwpt.icinfo.cn/';
                // var cloudCertUrl = 'https://cloudcert.icinfo.cn/V3/cloud/new/DECRYPT';
                // var doDecDataUrl = 'https://hxenc.icinfo.cn/api/openService/doDecData';
                // var authCenterUrl = 'https://frzsrz.zjzwfw.gov.cn:8443/';
                // var scanUrl = 'https://frzsrz.zjzwfw.gov.cn/';
                // var OCRUrl = 'https://hxocr.icinfo.cn/';
                // var CTIDAuthUrl = 'https://zsfwpt.icinfo.cn/';
                // var msgCenterUrl = 'https://hxmsg.icinfo.cn/';
                // var TimeUrl = 'https://hxtsa.icinfo.cn/';
                // var frdecrUrl = 'https://hxenc.icinfo.cn/';
                // var stampUrl = 'https://zjseal.zjzwfw.gov.cn/';
                // var letterUrl = 'https://ezthz.icinfo.cn/ezthz-service/';
            }

            var generate = function (action, urlType) {
                if (action == null)
                    return null;
                switch (urlType) {
                    case undefined:
                    case 'serverUrl':
                        var ret = serverUrl + action;
                        return ret;
                    case 'cloudCertUrl':
                        var ret = cloudCertUrl + action;
                        return ret;
                    case 'doDecDataUrl':
                        var ret = doDecDataUrl + action;
                        return ret;
                    case 'authCenterUrl':
                        var ret = authCenterUrl + action;
                        return ret;
                    case 'scanUrl':
                        var ret = scanUrl + action;
                        return ret;
                    case 'OCRUrl':
                        var ret = OCRUrl + action;
                        return ret;
                    case 'CTIDAuthUrl':
                        var ret = CTIDAuthUrl + action;
                        return ret;
                    case 'msgCenterUrl':
                        var ret = msgCenterUrl + action;
                        return ret;
                    case 'TimeUrl':
                        var ret = TimeUrl + action;
                        return ret;
                    case 'frdecrUrl':
                        var ret = frdecrUrl + action;
                        return ret;
                    case 'stampUrl':
                        var ret = stampUrl + action;
                        return ret;
                    case 'letterUrl':
                        var ret = letterUrl + action;
                        return ret;
                }
            }

            return {
                generate: generate
            };
        }]);
})();
